#!/usr/bin/env python
# vim: ts=4 et sts=4 sw=4 autoindent


try:
    import locale
    locale.setlocale(locale.LC_ALL, '')
except:
    pass

from docutils.core import publish_file
from glob import glob
import os

docs = glob("*.txt")

for doc in docs:
    (name, ext) = os.path.splitext(doc)
    publish_file(source_path=doc, destination_path="%s.html" % (name), writer_name='html')
    publish_file(source_path=doc, destination_path="%s.tex" % (name), writer_name='latex')
    try:
        os.system("pdflatex %s" % (name))
    except:
        print "You need to install pdflatex to get PDF output."

# Remove the unnecessary build files
cruft = glob("*.tex")
cruft += glob("*.aux")
cruft += glob("*.out")
cruft += glob("*.log")

for f in cruft:
    os.remove(f)
