'''
Indirect.py
'''

from Pyro.EventService.Clients import Publisher

from GeneratedPy.GenIndirect import GenIndirect
from sndcs.Config import config


class Indirect(GenIndirect, Publisher):

    def __init__(self):
        GenIndirect.__init__(self)
        Publisher.__init__(self)
        self.eventservice._release()

        # Get the Pyro namespace from the config
        self.namespace = config.get("pyro", "namespace", "sndcs")

    def formattedDescription(self):
        return self.description()

    ### Add and Deleting indirects
    def add(self):
        from sndcs.Store import store
        store.saveChanges()
        self.publish(self.namespace + "_indirect_add", {"serialNum":self.serialNum(),"code":self.code(),"description":self.description() } )
        self.eventservice._release()
        
    def delete(self):
        self.publish(self.namespace + "_indirect_delete", {"serialNum":self.serialNum(),"code":self.code(),"description":self.description() } )
        self.eventservice._release()

    def edit(self):
        from sndcs.Store import store
        store.saveChanges()
        self.publish(self.namespace + "_indirect_edit", {"serialNum":self.serialNum(),"code":self.code(),"description":self.description() } )
        self.eventservice._release()
