from Indirect import Indirect
from Store import store

class IndirectFactory(object):

    def new(self, code, description = None, isActive = 1, notes = None):
        indirect = Indirect()
        indirect.setCode(code)
        if description:
            indirect.setDescription(description)
        indirect.setIsActive(isActive)
        if notes:
            indirect.setNotes(notes)
        return indirect

    def getIndirects(self):
        return [ x for x in store.fetchObjectsOfClass(Indirect, clauses="WHERE code NOT IN ('BREAK','LUNCH') ORDER BY code+'0',code") ]

    def getActiveIndirects(self):
        return [ x for x in store.fetchObjectsOfClass(Indirect, clauses="WHERE isActive=1 AND code NOT IN ('BREAK','LUNCH') ORDER BY code+'0',code") ]

    def getAllActiveIndirects(self):
        return [ x for x in store.fetchObjectsOfClass(Indirect, clauses = "WHERE isActive=1 ORDER BY code+'0',code") ]

    def getIndirectByCode(self, code, onlyActive = 0):
        """ If onlyActive is set only look for active indirects. """
        if onlyActive:
            clauses = "WHERE code='%s' and isActive=1" % code
        else:
            clauses = "WHERE code='%s'" % code
        indirects = store.fetchObjectsOfClass(Indirect, clauses = clauses)
        if not len(indirects):
            return None
        else:
            return indirects[0]

    def getIndirectBySerialNum(self, serialNum):
        return store.fetchObject(Indirect, serialNum)
