from threading import Thread
import time

class Pinger(Thread):
    """
    This is needed mostly for MySQL. If the client remains idle for a long
    time the server may close the connection.  This will start up a
    "Pinger" thread that will ping once every 'frequency' in seconds.
    Checks whether the connection to the server is working. If the
    connection has gone down, an automatic reconnection is attempted. (For
    MySQL anyway.)
    """

    def __init__(self, store, frequency=3600):
        Thread.__init__(self)
        self.setDaemon(1)

        self.store = store
        self.frequency = frequency

    def run(self):
        if self.store.engine == "MySQL":
            while 1:
                conn, cur = self.store.connectionAndCursor()
                try:
                    conn.ping()
                except:
                    print "Exception in ping"
                time.sleep(self.frequency)
        else:
            pass

