'''
ScrapCode.py
'''

from Pyro.EventService.Clients import Publisher

from GeneratedPy.GenScrapCode import GenScrapCode
from sndcs_common.DateTimeMixin import DateTimeMixin
from sndcs_common.SndcsExceptions import *
from sndcs_common.PyroProxyMixin import PyroProxyMixin
from sndcs.Config import config

class ScrapCode(GenScrapCode, DateTimeMixin, Publisher, PyroProxyMixin):

    def __init__(self):
        GenScrapCode.__init__(self)
        Publisher.__init__(self)
        self.eventservice._release()

        # Get the Pyro namespace from the config
        self.namespace = config.get("pyro", "namespace", "sndcs")


    def add(self):
        from sndcs.Store import store
        store.saveChanges()
        self.publish(self.namespace + "_scrapcode_add", {"code": self.code(), "description": self.description()} )
        self.eventservice._release()

    def delete(self):
        from sndcs.Store import store
        store.saveChanges()
        self.publish(self.namespace + "_scrapcode_delete", {"code": self.code()})
        self.eventservice._release()

