from Account import Account
from AccountParameter import AccountParameter
from Store import store
import md5

class UserFactory(object):
    
    priv_table = { 
           "create_employee"      : 0x001,
           "edit_employee"        : 0x002,
           "delete_employee"      : 0x004,
           "create_time"          : 0x008,
           "edit_time"            : 0x010,
           "delete_time"          : 0x020,
           "create_indirect"      : 0x040,
           "edit_indirect"        : 0x080,
           "delete_indirect"      : 0x100,
           "create_jobs"          : 0x200,
           "edit_jobs"            : 0x400,
           "delete_jobs"          : 0x800,
           "create_items"         : 0x1000,
           "edit_items"           : 0x2000,
           "delete_items"         : 0x4000,
           "create_customers"     : 0x8000,
           "edit_customers"       : 0x10000,
           "delete_customers"     : 0x20000,
           "create_shifts"        : 0x40000,
           "edit_shifts"          : 0x80000,
           "delete_shifts"        : 0x100000,
           "create_departments"   : 0x200000,
           "edit_departments"     : 0x400000,
           "delete_departments"   : 0x800000,

           "admin_globals"        : 0x1000000,
           }



    def new(self):
        return Account()
    
    def validateUser(self,username,password):
        return store.fetchObjectsOfClass(Account,clauses="""WHERE username='%s' AND password='%s' """ % (username,md5.new(password).hexdigest()))

    def getUserBySerialNum(self,serialNum):
        from MiddleKit.Run.ObjectStore import UnknownObjectError
        try:
            return store.fetchObject(Account,serialNum)
        except UnknownObjectError:
            return False

    def getUserByName(self,name):
        return store.fetchObjectsOfClass(Account,clauses="""WHERE username='%s' """ % name )

    def getUsers(self):
        return store.fetchObjectsOfClass(Account)

    def changeUserPassword(self,serialNum,oldpassword,newpassword):
        tmpuser=self.getUserBySerialNum(serialNum)
        if tmpuser:
            if md5.new(oldpassword).hexdigest() == tmpuser.password():
                tmpuser.setPassword(md5.new(newpassword).hexdigest() )
                store.addObject(tmpuser)
                store.saveChanges()
                return True
            else:
                return False

    def checkPriv(self,serialNum,privName):
        tmpseek = self.getUserBySerialNum(int(serialNum))
        if tmpseek and not serialNum == 1:
            tmppriv = store.fetchObjectsOfClass(AccountParameter,clauses="""WHERE name='%s' """ % tmpseek.username() )
            return bool(int(tmppriv[0].value()) & int(self.priv_table[privName]) ) # 0 = Access Denied, 1 = Access Granted
        elif serialNum == 1:
            return True
        else:    
            return False

    def redirectIfAccessDenied(self,serialNum,privName,page = "dcs_login/priv_error"):
        if not self.checkPriv(serialNum,privName) and not serialNum == 1:
            return page 
        else:
            return False
