import Pyro.naming
from threading import Thread

from sndcs.Config import config

from sndcs_common.Logger import logger
log = logger.getLogger("Name Server")

class NameServer(Thread):
    def __init__(self):
        Thread.__init__(self)
        self.setDaemon(1)
        self.starter = Pyro.naming.NameServerStarter() # no special identification

    def run(self):
        log.info("Launching Pyro Name Server")
        hostname = config.get("pyro", "hostname", "")
        self.starter.start(hostname=hostname)

    def waitUntilStarted(self, timeout=None):
        return self.starter.waitUntilStarted(timeout)
