#!/usr/bin/python

# You can pass several parameters on the command line
# (more info by running this with option --help)
# or you can modify the default values here
# (more info in WebKit.Launch):

from sndcs.Config import config
import os
from sndcs_common.TrueAndFalseMixin import TrueAndFalseMixin
import Pyro

if TrueAndFalseMixin().true(config.get("pyro", "start_name_server", True)):
    hostname = config.get("pyro", "hostname", "") # If we are starting the name server set the PYRO_NS_HOSTNAME to whatever we are binding to
    Pyro.config.PYRO_NS_HOSTNAME = hostname
else:
    # If we aren't starting the Name Server look up the address from the config file
    pyro_ns_hostname = config.get("pyro", "ns_hostname", None)
    if pyro_ns_hostname:
        Pyro.config.PYRO_NS_HOSTNAME = pyro_ns_hostname

# Formulate the arguments we want to send to Launch.main
args = ["ThreadedAppServer"] # Since we are passing args we need to tell it what type of AppServer to run
host = config.get("web", "host", "127.0.0.1")
args.append("AppServer.Host=%s" % (host))
http_port = config.get("web", "http_port", "8080")
args.append("AppServer.HTTPPort=%s" % (http_port))
adapter_port = config.get("web", "appserver_port", "8086")
args.append("AppServer.AdapterPort=%s" % (adapter_port))

workDir = None
webwareDir = config.get("webware", "webware_path")
#Windows doesn't have PWD have to define it here
os.environ["PWD"]=os.getcwd()
print os.environ["PWD"]
libraryDirs = []
runProfile = 0
logFile = None
if os.name == "posix":
    pidFile = "/var/run/webkit.pid"
else:
    pidFile = None
user = None
group = None

import sys
sys.path.insert(0, webwareDir)

from WebKit import Launch

Launch.workDir = workDir
Launch.webwareDir = webwareDir
Launch.libraryDirs = libraryDirs
Launch.runProfile = runProfile
Launch.logFile = logFile
Launch.pidFile = pidFile
Launch.user = user
Launch.group = group

if __name__ == '__main__':
	Launch.main(args)
