# vim: ts=4 et sts=4 sw=4 autoindent

from index import index
from lib.SitePage import SitePage
from sndcs.UserFactory import UserFactory
from etc import siteindex
from etc import salt

class change_pass(index,SitePage):

    def __init__(self):
        index.__init__(self,3)
        SitePage.__init__(self,siteindex["dcs_admin"],3)

    def actions(self):
        return [ "changepass" ]

    def localTitle(self):
        return "Change Password"

    def changepass(self):
        req = self.request()
        if req.hasField("oldpassword") and req.hasField("newpassword") and req.hasField("retypepassword"):
            oldpassword=req.field("oldpassword")
            newpassword=req.field("newpassword")
            
            if not newpassword == req.field("retypepassword"):
                self.message = "Error: New typed passwords do not match"
                self.writeBody()
                return
            
            if self.session().hasValue("userLoggedOn") and UserFactory().changeUserPassword(req.session().value("userLoggedOn"),"%s%s" % (salt,oldpassword),"%s%s" % ( salt,newpassword ) ):
                self.goToPage("dcs_admin")
                return
            
            else:
                self.message="Error: Old password is incorrect"
                self.writeBody()
                return
        
    def writeLocalContent(self):

        self.writeln("""<table width="100%">""")
        self.writeln("""<tr>\n\t<td>""")

        self.writeln( self.subTabs() )

        self.writeln("""<tr><td align=center><font color="#ff0000">%s</td></tr>""" % self.message )
        
        self.writeln("""\n\t</td>\n</tr>\n<tr>\n\t<td>""")

        self.writeln("""<table align='center' width="50%">""")
        self.writeln("""<form method='post' action='./change_pass.py'>""")

        self.writeln("<tr CLASS=table_header><th colspan=2 class=title align=center>Change Password</th></tr>")

        self.writeln("""<tr><td CLASS=body_desc ALIGN=right>Old Password: </td><td align=left><input type='password' name='oldpassword'>""")
        self.writeln("""<tr><td CLASS=body_desc ALIGN=right>New Password: </td><td align=left><input type='password' name='newpassword'>""")
        self.writeln("""<tr><td CLASS=body_desc ALIGN=right>Retype Password: </td><td align=left><input type='password' name='retypepassword'>""")

        self.writeln("<input name='_action_' value='changepass' type='hidden'>")

        self.writeln("""<tr><td height='40px' colspan=2 align=center><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';"></td></tr>""")

        self.writeln("""\n</form>\n</table>\n\t</td>\n</tr>\n</table>""")
