# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from index import index

from etc import siteindex
from etc import salt
from sndcs.UserFactory import UserFactory
from sndcs.UserParameterFactory import UserParameterFactory
from sndcs.Store import store
import md5


class manage_user(index,SecureSitePage):

        def __init__(self):
                SecureSitePage.__init__(self,siteindex["dcs_admin"],5)

        def newTab(self):
                return ["New User","edit_user"]
    
        def actions(self):
                return [ "delete" ]

        def localTitle(self):
                return "Manage Users"

        def delete(self):
                req=self.request()
                if self.session().value("userLoggedOn",0) == 1:
                        if req.hasField("serialNum"):
                                serialNum=int(req.field("serialNum"))
                                tmpdelete=UserFactory().getUserBySerialNum(serialNum)
                                tmpdelpriv=UserParameterFactory().getUserParameterByName(tmpdelete.username() )[0]      
                                
                                store.deleteObject(tmpdelpriv)
                                store.saveChanges()

                                store.deleteObject(tmpdelete)
                                store.saveChanges()
                            
                self.goToPage("dcs_admin/manage_user")
                
        def writeLocalContent(self):
                self.writeln("""<table width=100%">""")
                
                self.writeln( self.subTabs() )
               
                self.writeln("<tr><td colspan=6 align=center><font color='red'>%s</font></td></tr>" % self.message)

                if self.session().hasValue("userLoggedOn") and self.session().value("userLoggedOn") == 1:
                        self.writeln("<tr class=table_header><th colspan=6>Adminstrator Panel</th></tr>")
                        self.start_color()
                        self.writeln("<tr class=table_header><th align=left>Username</th><td align=left>Last Name</td><th align=left>First Name</th><th align=left>State</th><th WIDTH='30px'>Edit</th><th WIDTH='30px'>Delete</th></tr>")
                        for user in UserFactory().getUsers():
                                if not user.serialNum() == 1: # Administrator has no AccountParameters
                                        bgcolor = self.next_color()
                                        if user.state(): state = user.state().description()
                                        else: state = "N/A"
                                                
                                        self.writeln("""
                    <tr bgcolor='%s'>
                        <td CLASS=list_data>%s</td><td CLASS=list_data>%s</td><td CLASS=list_data>%s</td><td CLASS=list_data>%s</td><td align=center><a href='./edit_user.py?serialNum=%s'><img src='../images/button4.gif' border=0></a></td><td align=center><a href='./manage_user.py?_action_=delete&serialNum=%s'><img src='../images/button3.gif' border=0></a></td>
                    </tr>""" % (bgcolor,user.username(), self.escape( user.lastName() ), self.escape( user.firstName() ), state,user.serialNum(), user.serialNum()) )
                
                        self.writeln("""
                    <tr class=table_header>
                        <th align=left>Username</th><td align=left>Last Name</td><th align=left>First Name</th><th align=left>State</th><th WIDTH='30px'>Edit</th><th WIDTH='30px'>Delete</th>
                    </tr>""")
                        
                        self.writeln("""
                        <tr>
                            <td height='40px' colspan=6 align=center><A HREF="./edit_user"><IMG SRC="../images/new.gif" onMouseDown="this.src='../images/newdown.gif';" onMouseOut="this.src='../images/new.gif';" style="border-style: none;"></A></td>
                        </tr>""")
                        self.writeln("</table>")
