from index import index
from lib.SecureSitePage import SecureSitePage

from sndcs.UserFactory import UserFactory
from sndcs.StateFactory import StateFactory
from sndcs.Store import store

from etc import siteindex

class user_preferences(index,SecureSitePage):

    def __init__(self):
        SecureSitePage.__init__(self,siteindex["dcs_admin"],2)

    def localTitle(self):
        return "User Preferences"

    def writeJavascript(self):
        return """
        <script language='javascript' type='text/javascript'>
        function validOnSubmit(myForm) {
        
            if ( (myForm.HomePhone.value!="") && !isPhoneNumber(myForm.HomePhone.value) ) {
                alert('Enter a Home Phone in the format (330) 555-1212');
                myForm.HomePhone.focus();
                return false;
            }
            if ( (myForm.Email.value!="") && (myForm.Email.value.indexOf('@') == -1) ) {
                alert('Enter a valid Email Address');
                myForm.Email.focus();
                return false;
            }
            if ( (myForm.CellPhone.value!="") && !isPhoneNumber(myForm.CellPhone.value) ) {
                alert('Enter a Cell Phone in the format (330) 555-1212');
                myForm.CellPhone.focus();
                return false;
            }
            if ( (myForm.Fax.value!="") && !isPhoneNumber(myForm.Fax.value) ) {
                alert('Enter a Fax Number in the format (330) 555-1212');
                myForm.Fax.focus();
                return false;
            }
        return true;
        }
        </script>"""


    def actions(self):
        return [ "save" ]

    def save(self):
        req = self.request()
        saveFields = req.fields()

        if self.session().value("userLoggedOn"):
            tmpuser = UserFactory().getUserBySerialNum( self.session().value("userLoggedOn") )
        else:
            self.goToPage("dcs_login/login")

        state = self.checkLength(req.field("State", ""),2)
        if state:
            state = StateFactory().getStateByAbbev(state)
        tmpuser.setState(state)

        for value in [ "_action_", "x", "y","State" ]:
            del saveFields[value]

        for field in saveFields:
            self.middleKitObjectEval(tmpuser,field,self.escape( str(req.field(field,"") ) ) )

        store.addObject(tmpuser)
        store.saveChanges()

        self.writeBody()

    def writeLocalContent(self):
        self.writeln("""<table width="100%">""")
   
        self.writeln( self.subTabs(colspan = 2) )

        self.writeln("""<tr class=table_header><th colspan=6>User Preferences</th></tr>""")
    
        # Only the administrator account sees the following <tr>
        # Make sure that the administrator account serialNum is ALWAYS 1
        tmpuser = UserFactory().getUserBySerialNum(self.session().value("userLoggedOn") )
        
        if not tmpuser:
            self.goToPage("index") # This user is deleted

        self.writeln(self.writeJavascript())
        self.writeln("""
        <form method="post" action="./user_preferences" onSubmit="return validOnSubmit(this);">
        <tr><td class=body_desc align=right>Username:&nbsp;</td><td class=list_data colspan=3 align=left>%s</td>

        <tr><td colspan=6 align='center'><hr></td></tr>

        <tr><td class=body_desc>First Name: </td><td class=list_data align=left><input name="FirstName" type="text" value=%s></td><td class=body_desc align=left>Last Name: </td><td class=list_data><input name="LastName" type="text" value=%s></td></tr>
        <tr><td class=body_desc>Email: </td><td class=list_data align=left><input name="Email" type="text" value=%s></td><td class=body_desc align=left>Home Phone: </td><td class=body_desc><input name="HomePhone" type="text" value=%s></td></tr>
        <tr><td class=body_desc>Address: </td><td class=list_data align=left><input name="Address" type="text" value=%s></td><td class=body_desc align=left>Cell Phone: </td><td class=body_desc><input name="CellPhone" type="text" value=%s></td></tr>
        <tr><td class=body_desc>City: </td><td class=list_data align=left><input name="City" type="text" value=%s></td><td class=body_desc align=left>Fax Number: </td><td class=body_desc><input name="Fax" type="text" value=%s></td></tr>""" % (tmpuser.username(),self.quoted_escape( tmpuser.firstName() ),self.quoted_escape( tmpuser.lastName() ),self.quoted_escape( tmpuser.email() ),self.quoted_escape( tmpuser.homePhone() ),self.quoted_escape( tmpuser.address() ),self.quoted_escape( tmpuser.cellPhone() ),self.quoted_escape( tmpuser.city() ),self.quoted_escape( tmpuser.fax() ) ) )
        
        self.writeln("""<tr><td class=body_desc>State: </td><td colspan=3 align=left><select name="State"><option value=""> </option>""")
       
        state = tmpuser.state()
        if state: state = state.abbreviation()
        else: state=""
        
        self.writeln( self.state_option(state) )
        
        self.writeln("""</select></td></tr>\n<tr><td class=body_desc align=left>Comments: </td><td class=list_data colspan=3><textarea name="Comments" ROWS=15 COLS=78>%s</textarea></td></tr>
        <input type="hidden" name="_action_" value="save">
        """ % ( self.escape(tmpuser.comments())  ) )

        self.writeln("""
        <tr>
            <td colspan=4 align=center height='40px'><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';" ></td>
        </tr>
        </form>
        </table>""")

