# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from etc import siteindex
from sndcs.CustomerFactory import CustomerFactory

class index(SecureSitePage):
        def __init__(self):
            SecureSitePage.__init__(self,siteindex["dcs_edit_customers"],1)

        def backPage(self):
            return "dcs_edit_customers"

        def localTitle(self):
            return "Customers"
        
        def newTab(self):
            return ["New Customer","customers"]

        def subTabs(self):
            subtab1 = self.write_div(id="subtab1",classname="subtab",text="Main", construct = [ 1, siteindex["dcs_edit_customers"], "index" ]);
            subtab2 = self.write_div(id="subtab2",classname="subtab",text="Search", construct = [ 2, siteindex["dcs_edit_customers"], "search" ]);

            return """<tr><td><table align="left"><tr><td>%s</td><td>%s</td></tr></table></td></tr>""" % (subtab1,subtab2) 

        def writeStyleSheet(self):
            SecureSitePage.writeStyleSheet(self,linkStyle = True)
        
        def writeLocalContent(self):
            req = self.request()
            self.writeln("""<table width="100%">""")

            self.writeln( self.subTabs() )
            self.writeln("""\t</td>\n</tr>\n<tr>\n\t<td>""")
        
            sortBy = req.field("sortBy","customerId")
            orderBy = req.field("orderBy","ASC")

            sortDict = { "customerId" : "DESC", "status": "ASC", "name": "ASC" }
            if req.hasField("sortBy"):
                arrayBefore = [ sortBy, orderBy ]
                if len(arrayBefore) == 2:
                    for key,value in sortDict.items():
                        if arrayBefore[0] == key:
                            sortDict[key] = self.ifTrueReturn(arrayBefore[1] == "ASC","DESC","ASC")

            self.writeln("""<table width="100%" align="center">""")
            header = """
            <tr class='table_header'>
                <th align=left><a href="./index?sortBy=customerId&orderBy=%s">&nbsp;Cust. #&nbsp;</a></th>
                <th align=left><a href="./index?sortBy=status&orderBy=%s">&nbsp;Status&nbsp;</a></th>
                <th width=80%% align=left><a href="./index?sortBy=name&orderBy=%s">&nbsp;Name&nbsp;</a></th>
                <th width='30px'>Edit&nbsp;</th>
                <th width='30px'>Delete&nbsp;</th>
            </tr>""" % (sortDict["customerId"],sortDict["status"],sortDict["name"])

            self.writeln( header )

            self.start_color()

            results = CustomerFactory().getCustomersBySearchOrder(sortBy)
            if orderBy == "DESC":
               results.reverse() 

            for customer in results:
                bgcolor = self.next_color()
                self.writeln("""<tr bgcolor='%s'><td class=list_data>&nbsp;%s&nbsp;</td><td class=list_data align=left>&nbsp;%s</td><td class=list_data align=left>%s</td>    
                <td align=center><a href='./customers?serialNum=%s'`><img src='../images/button4.gif' border=0></a></td>
                <td align=center><a href='./customers?_action_=delete&serialNum=%s'><img src='../images/button3.gif' border=0></a></td></tr>""" % (bgcolor,customer.customerId(),customer.status(),customer.name(),customer.serialNum(),customer.serialNum() ) )

            self.writeln( header )

            self.writeln("""<tr><td ALIGN=center COLSPAN=5 height='40px'><A HREF="./customers"><IMG SRC="../images/new.gif" onMouseDown="this.src='../images/newdown.gif';" onMouseOut="this.src='../images/new.gif';" style="border-style: none;"></A></td></tr>\n\t\t</table>\n\t\t\t</td>\n\t\t</tr>\n</table>""")
