from index import index
from lib.SecureSitePage import SecureSitePage
from etc import siteindex

from sndcs.Customer import Customer
from sndcs.Store import store


class search(index,SecureSitePage):

        def __init__(self):
                SecureSitePage.__init__(self,siteindex["dcs_edit_customers"],2)

        def actions(self):
                return index.actions(self) + [ "search" ]
        
        def localTitle(self):
                return "Search Customers"


        def search(self):
                req = self.request()
                clausesString = req.field("clausesString","")

                message=""
    
                message += ("""<table width="100%">""")
                message += ("""<tr class='refresh'><td colspan=5 align=right height='50px'><b><a href='./search.py'>New Search</a></b></td></tr>""")
                header = ("""
                <tr class='table_header'>
                    <th>Customer #&nbsp;</th>
                    <th align=left>Status&nbsp;</th>
                    <th width=80%% align=left>&nbsp;Name&nbsp;</th>
                    <th width='30px'>Edit&nbsp;</th>
                    <th width='30px'>Delete&nbsp;</th>
                </tr>""")

                message += header
                if clausesString=="":
                    
                        if req.hasField("CustomerId") and req.field("CustomerId")<>"":
                            clausesString += "AND customerId='%s'" % self.escape(req.field("CustomerId"))
                        if req.hasField("CustomerName") and req.field("CustomerName")<>"":
                            clausesString += "AND name LIKE '%%%s%%'" % self.escape(req.field("CustomerName"))
                        if req.hasField("Status") and req.field("Status")<>"":
                            clausesString += " AND status='%s'" % self.escape(req.field("Status"))

                if not clausesString == "":
                    tmp = store.fetchObjectsOfClass(Customer,clauses="WHERE %s" % clausesString[4:] ) 
                else: tmp = False
                
                if clausesString=="" or not tmp:
                        message += ("""<table><tr><td><b>No Matching Records!</b></td></tr></table>""")
                        self.message=message
                        self.writeBody()
                        return

                self.start_color()
                for customer in tmp:
                        bgcolor=self.next_color()
                        message += ("""
                        <tr bgcolor='%s'><td class=list_data>%s</td><td class=list_data align=left>%s</td><td class=list_data align=left>&nbsp;%s</td>    
                        <td align=center><a href='./customers.py?_action_=editdialog&serialNum=%s'><img src='../images/button2.gif' border=0></a></td>
                        <td align=center><a href='./customers.py?_action_=delete&serialNum=%s'><img src='../images/button3.gif' border=0></a></td></tr>""" % (bgcolor,customer.customerId(),customer.status(),customer.name(),customer.serialNum(),customer.serialNum() ) )

                message += ("""%s </table>""" % header)

                self.message = message
                self.writeBody()

                self.session().setValue("backPage","search?_action_=search&clausesString=%s" % self.convertToHexString(clausesString) )
                self.setSearchResultsPage()
                        
        def writeLocalContent(self):

                self.writeln("""<table width="100%">""")
                self.writeln( self.subTabs() )
                self.writeln("""<tr align='center'>\n\t<td>""")

                if self.message=="":
                        
                        self.writeln("""<table width='50%' align='center'>""")
                        self.writeln("""<form action='./search?_action_=search' method='post'>
                        <tr><th class=table_header colspan=2>Search Customers</td></tr>
                        <tr><td class=body_desc align=right>Customer ID:</td><td align=left><input type=text name=CustomerId class=body_data></td></tr>
                        <tr><td class=body_desc align=right>Customer Name:</td><td align=left><input type=text name=CustomerName class=body_data></td</tr>
                        <tr><td class=body_desc align=right>Status:</td><td align=left><select name=Status>
                            <option value="" SELECTED>&nbsp;
                            <option value="Active">Active
                            <option value="Prospect">Prospect
                            <option value="Blocked">Blocked
                        </select>
                        </td></tr>
                        <tr height='40px'><td colspan=2 align='center'><INPUT TYPE=image SRC="../images/search1.gif" onMouseDown="this.src='../images/search1down.gif';" onMouseOut="this.src='../images/search1.gif';">&nbsp;<A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>
                        </form>
                        </table>
                        """)

                else:
                        self.writeln( self.message )

                self.writeln("""\t</td>\n</tr>\n</table>""")
                    
                


