# vim: ts=4 et sts=4 sw=4 autoindent

from index import index
from lib.SecureSitePage import SecureSitePage
from etc import siteindex

from sndcs.DepartmentFactory import DepartmentFactory
from sndcs.Department import Department
from sndcs.UserFactory import UserFactory
from sndcs.Store import store

class departments(index,SecureSitePage):

        def actions(self):
                return [ "edit", "delete" ]

        def writeJavascript(self):
                return """
                <script language='javascript' type='text/javascript'>
                <!--
                function validOnSubmit(myForm) {
                    /*if (myForm.Code.value == "" || !isInteger(myForm.Code.value) ) { */

                    if (myForm.Code.value == "" ) {
                        alert('Error: Enter a valid Code');
                        myForm.Code.focus();
                        return false;
                    }
                    
                    if ( myForm.Description.value == "" ) {
                        alert('Error: Enter a valid Description');
                        myForm.Description.focus();
                        return false;
                    }
                    return true;
                }
                //-->
                </script>
                """
        
        def delete(self):
                req = self.request()
                serialNum = self.returnType(req.field("serialNum",""),int,None)
                self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "delete_departments" ) ) 
                
                tmpdelete = DepartmentFactory().getDepartmentBySerialNum(int(serialNum) )

                if not store.fetchObjectsOfClass(Department,"WHERE code='%s' AND serialNum<>%s" % (tmpdelete.code(),serialNum ) ) and not tmpdelete.referencingObjectsAndAttrs():
                    store.deleteObject(tmpdelete)
                else: tmpdelete.setActive(False)
                
                store.saveChanges()
                self.goToPage("dcs_edit_departments")
                
        def edit(self):
                req = self.request()
                serialNum = self.returnType(req.field("serialNum",""),int,None)
                
                if serialNum:
                    self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_departments" ) ) 
                    tmpedit = DepartmentFactory().getDepartmentBySerialNum( serialNum )
                else:
                    self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "create_departments" ) ) 
            
                    if store.fetchObjectsOfClass(Department,"WHERE code='%s' AND employeeObjId IS NULL" % self.escape( req.field("Code") ) ):
                            self.message = ("""<b>Error:</b> An Department already exists with that Code""")
                            self.writeBody()
                            return

                    tmpedit = DepartmentFactory().new()
                
                changeDepartments = store.fetchObjectsOfClass(Department,"WHERE code='%s' AND (employeeObjId IS NOT NULL OR terminalObjId IS NOT NULL)" % tmpedit.code() )

                description = req.field("Description","No Description")
                
                tmpedit.setActive( req.hasField("Status") )

                tmpedit.setCode( req.field("Code") )
                tmpedit.setDescription( description )

                for x in changeDepartments:
                    for key,value in dict(req.fields()).items():
                        self.middleKitObjectEval(x, key, self.escape(value) )

                store.addObject(tmpedit)
                store.saveChanges()

                self.goToPage("dcs_edit_departments")
                
                
        def localTitle(self):
            if self.request().hasField("serialNum"):
                return "Edit Department"
            else:
                return "Create New Department"

        def writeLocalContent(self):
                req = self.request()
                serialNum = self.returnType(req.field("serialNum",""),int,0)

                if serialNum:
                    tmpedit=DepartmentFactory().getDepartmentBySerialNum(int(serialNum) )
                    code = tmpedit.code()
                    description = tmpedit.description()
                    active = self.ifTrueReturn(tmpedit.active(),"CHECKED","")
                else:
                    code = ""
                    description = ""
                    active = "CHECKED"

                self.writeln( self.writeJavascript() )
            
                if not self.message == "":
                        self.writeln("""<table width="100%%"><tr align="center"><td><font color="#ff0000">%s</font></td></tr></table>""" % self.message )
                else:
                        self.writeln("""<table width="50%">""")
                        
                        self.writeln("""
                        <FORM METHOD="post" ACTION="./departments?_action_=edit" onSubmit='return validOnSubmit(this);'>
                        <tr CLASS=table_header><th COLSPAN=4>%s Department </th></tr>
                        <tr><td ALIGN=right CLASS=body_desc>&nbsp;Code:&nbsp;</td>
                        <td ALIGN=left><INPUT TYPE=TEXT NAME=Code CLASS=body_data VALUE="%s"></td></tr>
                        <tr><td ALIGN=right CLASS=body_desc>&nbsp;Description:&nbsp;</td>
                        <td ALIGN=left><INPUT TYPE=TEXT NAME=Description CLASS=body_data VALUE="%s"></td></tr>
                        <tr><td ALIGN=right CLASS=body_desc>&nbsp;Active:&nbsp;</td>
                        <td ALIGN=left><INPUT TYPE=checkbox NAME=Status CLASS=body_data VALUE=1 %s>&nbsp;</td></tr>
                        <tr height='40px'><td colspan=2 align=center><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>""" % (self.ifTrueReturn(serialNum,"Edit","Create New"),code,description,active) );
                        

                        if serialNum:
                            self.writeln("<input type='hidden' name='serialNum' value=%s>" % serialNum)
                        
                        self.writeln("</form>\n</table>")
