# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from etc import siteindex

from sndcs.DepartmentFactory import DepartmentFactory
from sndcs.Store import store


class index(SecureSitePage):
        def __init__(self):
            SecureSitePage.__init__(self,siteindex["dcs_edit_departments"],0)

        def backPage(self):
            return "dcs_edit_departments"

        def newTab(self):
            return ["New Department","departments"]

        def localTitle(self):
            return "Departments"

        def writeLocalContent(self):
            self.writeln("""<table width="100%">""")
            header = ("""\n<tr CLASS=table_header ALIGN=left>
            <th align=left>&nbsp;Code&nbsp;</th><th align=left WIDTH=80%%>Description</th><th WIDTH='30px'>Active</th><th ALIGN=center WIDTH='30px'>&nbsp;Oprs.</th><th ALIGN=center WIDTH='30px'>&nbsp;Edit</th><th ALIGN=center WIDTH='30px'>&nbsp;Delete</th></tr>""")
            self.writeln( header )
    
            self.start_color()

            for department in DepartmentFactory().getDepartments():
                bgcolor = self.next_color()
                ActiveBool = self.ifTrueReturn(department.active(),"Yes","No") 
                
                self.writeln("""
                <tr bgcolor='%s'>
                        <td class='list_data' align='left'>%s</td>
                        <td class='list_data' align='left'>%s</td>
                        <td class='list_data' align='center'>%s</td>
                        <td align='center'><a class='pointer' href='./task_list?serialNum=%s'><img style='border-style: none;' src='../images/button2.gif'/></a></td>
                        <td align='center'><a class='pointer' href='./departments?serialNum=%s'><img style='border-style: none;' src='../images/button4.gif'/></a></td>
                        <td align='center'><a class='pointer' href='./departments?_action_=delete&serialNum=%s'><img style='border-style: none;' src='../images/button3.gif'/></a></td>
                </tr>""" % (bgcolor,department.code(),self.escape(department.description()),ActiveBool,department.serialNum(),department.serialNum(),department.serialNum()))
            
            self.writeln(header,"""\n<tr height='40px'>
                <td ALIGN=center COLSPAN=7><A HREF="./departments"><IMG SRC="../images/new.gif" onMouseDown="this.src='../images/newdown.gif';" onMouseOut="this.src='../images/new.gif';" style="border-style: none;"></A></td>
            </tr>
            </table>""")
