# vim: ts=4 et sts=4 sw=4 autoindent

from index import index
from lib.SecureSitePage import SecureSitePage
from etc import siteindex

from sndcs.EmployeeFactory import EmployeeFactory
from sndcs.DepartmentFactory import DepartmentFactory
from sndcs.LastUsedFactory import LastUsedFactory
from sndcs.Department import Department
from sndcs.ShiftFactory import ShiftFactory
from sndcs.StateFactory import StateFactory
from sndcs.Store import store
from sndcs.UserFactory import UserFactory

class edit_employee(index,SecureSitePage):
    def __init__(self):
        SecureSitePage.__init__(self,siteindex["dcs_edit_employees"],1,False, SecureSitePage.mainScripts + [ "../js/jscalendar/calendar.js", "../js/jscalendar/calendar-en.js" ])

    def newTab(self):
        req=self.request()
        serialNum=req.field("serialNum",False)
        if serialNum and str(self.session().value("backPage","")).count("search"):
            return ["Back To Search Results",str(self.session().value("backPage")).replace("dcs_edit_employees/","")]
        else:
            return index.newTab(self)

    def backPage(self):
        if str(self.session().value("backPage","")).count("search"):
            return self.session().value("backPage")
        else:
            return "dcs_edit_employees"

    # Validation scripts here
    def writeJavascript(self):
            return """
<script language="JavaScript">
function move(fbox, tbox) {
        var arrFbox = new Array();
        var arrTbox = new Array();
        var arrLookup = new Array();
        var i;
        //copy tbox options to arrTbox
        for(i=0; i<tbox.options.length; i++) {
                arrLookup[tbox.options[i].text] = tbox.options[i].value;
                arrTbox[i] = tbox.options[i].text;
        }
        var fLength = 0;
        var tLength = arrTbox.length
        for(i=0; i<fbox.options.length; i++) {
                arrLookup[fbox.options[i].text] = fbox.options[i].value;
                if(fbox.options[i].selected && fbox.options[i].value != "") {
                        arrTbox[tLength] = fbox.options[i].text;
                        tLength++;
                } else {
                        arrFbox[fLength] = fbox.options[i].text;
                        fLength++;
                }
        }
        arrFbox.sort();
        arrTbox.sort();
        fbox.length = 0;
        tbox.length = 0;
        var c;
        for(c=0; c<arrFbox.length; c++) {
                var no = new Option();
                no.value = arrLookup[arrFbox[c]];
                no.text = arrFbox[c];
                fbox[c] = no;
        }
        for(c=0; c<arrTbox.length; c++) {
                var no = new Option();
                no.value = arrLookup[arrTbox[c]];
                no.text = arrTbox[c];
                tbox[c] = no;
        }
}

function selectAndMoveEntry(entryToSelect, fBox, tBox)
{
        for(i=0; i<fBox.options.length; i++)
        {
            if(fBox.options[i].text == entryToSelect)
            {
                fBox.options[i].selected = true;
            }
        }

        move(fBox, tBox);
}

function addEntry(entryToAdd, Box){
    var no = new Option();
    no.text = entryToAdd;
    var numopts = Box.options.length;
    Box[numopts] = no;
}

function sendInfo(hiddenVar,box, text_only) {
    hiddenVar.length = 0;
    var strValue = new String();
    if(text_only != 1){
        for(var i=0; i<box.length; i++) {
            strValue += box[i].value;
            if (i < box.length-1) {
                strValue += ",";
            }
        }
    }
    else{
        for(var i=0; i<box.length; i++) {
            strValue += box[i].text;
            if (i < box.length-1) {
                strValue += ",";
            }
        }
    }
    hiddenVar.value = strValue;
}

</script>

<script language='javascript' type='text/javascript'>
function shiftHide(myForm) {
    if (myForm.Shift.value=="") {
        myForm.Shift_override_start.disabled = false;
        myForm.Shift_override_end.disabled = false;
    }
    else {
        myForm.Shift_override_start.disabled = true;
        myForm.Shift_override_end.disabled = true;
    }

}

function hideButton(myForm) {
    // hide the term button if appliciable
    if (myForm.Status.value=="Active") {
        myForm.TermDate.disabled=true;
        myForm.term_trigger.style.visibility='hidden';
        return false;
    }

    myForm.TermDate.disabled=false;
    myForm.term_trigger.style.visibility='visible';
}

function validOnSubmit(myForm) {
    if (myForm.FirstName.value=="") {
        alert('Error: Enter a First Name');
        myForm.FirstName.focus();
        return false;
    }
    if (myForm.LastName.value=="") {
        alert('Error: Enter a Last Name');
        myForm.LastName.focus();
        return false;
    }

    if ( (myForm.HireDate.value == "") || !isDate(myForm.HireDate.value) ) {
        alert('Error: Enter a valid Hire Date');
        myForm.HireDate.focus();
        return false;
    }

    if (myForm.Status.value=="Terminated") {
        if ( (myForm.TermDate.value == "") || !isDate(myForm.TermDate.value) ) {
            alert('Error: Enter a valid Termination Date');
            myForm.TermDate.focus();
            return false;
        }
    }
    if ( (myForm.Email.value!="") && (myForm.Email.value.indexOf('@') == -1) ) {
        alert('Enter a valid Email Address');
        myForm.Email.focus();
        return false;
    }
    if ( (myForm.HomePhone.value!="") && !isPhoneNumber(myForm.HomePhone.value) ) {
        alert('Error: Enter a valid Home Phone in the format (330) 555-1212');
        myForm.HomePhone.focus();
        return false;
    }

    if ( (myForm.CellPhone.value!="") && !isPhoneNumber(myForm.CellPhone.value) ) {
        alert('Error: Enter a valid Cell Phone in the format (330) 555-1212');
        myForm.CellPhone.focus();
        return false;
    }

    if ( !(myForm.PinNumber.value=="") && !isInteger(myForm.PinNumber.value) ) {
        alert('Error: Enter a valid PIN number');
        myForm.PinNumber.focus();
        return false;
    }

    if ( ( !(myForm.ZipCode.value=="")  || (myForm.ZipCode.value.length < 5) ) && !isInteger(myForm.ZipCode.value) ) {
        alert('Error: Enter a valid 5-digit Zip Code');
        myForm.ZipCode.focus();
        return false;
    }
return true;
}
    </script>"""

    def writeStyleSheet(self):
        SecureSitePage.writeStyleSheet(self)
        self.writeln("""<link rel="stylesheet" type="text/css" media="all" href="../css/calendar-blue.css" title="blue" />""")
        
    def actions(self):
        return SecureSitePage.actions(self) + ["edit"]
                    
    def edit(self):
        req = self.request()

        deleteValues = [ "x", "y", "_action_","HireDate", "Shift_override_start", "Shift_override_end","TermDate","AvailableDepartments" ]
        serialNum = self.returnType(req.field("serialNum",""),int,None)
        
        if serialNum:
            self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_employee" ) ) 

            tmpedit = EmployeeFactory().getEmployeeBySerialNum( serialNum )
            if tmpedit.activeLaborHed():
                self.goToPage("dcs_edit_employee") 
                return #The employee had a active laborHed, could not edit.
                
            deleteValues.append("serialNum")
        else:
            self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "create_employee" ) ) 

            empId = LastUsedFactory().getNextAvailableEmployeeNumber( self.returnType(req.field("EmpId",""),int,LastUsedFactory().getNextEmpId() ) )
            deleteValues.append("EmpId")
            tmpedit = EmployeeFactory().new( str(empId) )
            tmpedit.setCreateDate( self.convertToDateTime( date = self.currentdate() ) )

        supervisor = self.returnType(req.field("Supervisor",""),int,None)
        if supervisor:
            supervisor = EmployeeFactory().getEmployeeBySerialNum( supervisor )
        tmpedit.setSupervisor(supervisor)
        deleteValues.append("Supervisor")

        shift = self.returnType(req.field("Shift",""),int,None)
        if shift:
            shift = ShiftFactory().getShiftBySerialNum( shift )
        tmpedit.setShift(shift)
        deleteValues.append("Shift")

        state = self.checkLength(req.field("State",""),2)
        if state:
            state = StateFactory().getStateByAbbev(state)
        tmpedit.setState(state)
        deleteValues.append("State")

        hourlyrate = self.returnType( str(req.field("HourlyRate","")).replace("$",""), float, 0.00)
        tmpedit.setHourlyRate(hourlyrate)
        deleteValues.append("HourlyRate")
        
        departments = str(req.field("current_departments_selected","") ).split(",")
        if self.isType(departments,list) and len(departments) > 0 and not departments[0] == "":
            dontDelete = []
            for department in departments:
                tmpread = DepartmentFactory().getDepartmentBySerialNum( int(department) )
                if not store.fetchObjectsOfClass(Department,clauses = """WHERE code='%s' AND employeeObjId='%s'""" % (tmpread.code(),tmpedit.serialNum() ) ):
                    tmpdept = DepartmentFactory().new()
                    tmpdept.setCode(tmpread.code() )
                    tmpdept.setDescription(tmpread.description() )
                    store.addObject(tmpdept)
                            
                    tmpedit.addToDepartment(tmpdept)
                        
                dontDelete.append(tmpread.code())
                    
            for deleteDepartment in EmployeeFactory().getDepartmentsOfEmployeeBySerialNum(tmpedit.serialNum() ):
                if not dontDelete.count(deleteDepartment.code()):
                    store.deleteObject(deleteDepartment)
        else:
            for deleteDepartment in EmployeeFactory().getDepartmentsOfEmployeeBySerialNum(tmpedit.serialNum() ):
                store.deleteObject(deleteDepartment)

        deleteValues.append("current_departments_selected")
       
        shift_override_start = self.convertToDateTime(timestamp = req.field("Shift_override_start","") )
        shift_override_end = self.convertToDateTime(timestamp = req.field("Shift_override_end","") )
        if shift_override_start and shift_override_end: 
            tmpedit.setShift_override_start(shift_override_start)
            tmpedit.setShift_override_end(shift_override_end)

        hireDate = self.returnTrueOrDefault(self.convertToDateTime(date = req.field("HireDate","") ),None)
        tmpedit.setHireDate(hireDate)

        termDate = self.returnTrueOrDefault(self.convertToDateTime(date = req.field("TermDate","") ), None)
        tmpedit.setTermDate(termDate)
        
        for key,value in dict(req.fields()).items():
            if not key in deleteValues:
                self.middleKitObjectEval(tmpedit,key,value)
        
        if tmpedit.serialNum():
            if tmpedit.status() == "Active":
                tmpedit.add(actionType = "edit")
            else:
                tmpedit.delete()
        else:
            store.addObject(tmpedit) #NEEDS TO BE HERE or we won't get a serialNum()
            LastUsedFactory().setNextEmpId( empId )
            tmpedit.add()

        store.saveChanges()
        self.goToPage(self.backPage())

    def localTitle(self):
        if self.request().hasField("serialNum"):
            return "Edit Employee"
        else:
            return "Create New Employee"

    def writeLocalContent(self):
        req=self.request()
        serialNum = req.field("serialNum","")

        pinNumber, notes, supervisor, address, shiftSerialNum, state, greeting, email, empId, firstName, lastName, hireDate, termDate, shiftOverrideStart, shiftOverrideEnd, zipCode, cellPhone, homePhone, city, hourlyRate, status = [ None,"","","","","","Create New","","","","",self.currentdate(),"","00:00:00","00:00:00","","","","", "0.00", "Active" ]
            
        if self.isType(serialNum,int):
            serialNum = int(serialNum)
            employee = EmployeeFactory().getEmployeeBySerialNum(serialNum)
            note = employee.comments()
            address = employee.address()
            email = employee.email()
            empId = employee.empId()
            hireDate = employee.hireDate()
            termDate = employee.termDate()
            pinNumber = employee.pinNumber()
            
            if employee.shift_override_start() is not "" and employee.shift_override_end():
                shiftOverrideStart=self.escape(str(employee.shift_override_start() )[:8])
                shiftOverrideEnd=self.escape(str(employee.shift_override_end() )[:8])

            firstName=self.escape(employee.firstName())
            lastName=self.escape(employee.lastName())
            
            if employee.shift(): shiftSerialNum=employee.shift().serialNum()
            else: shiftSerialNum = "" 
            
            if employee.state(): state = employee.state().abbreviation()
            else: state=""
            
            notes = employee.comments()
            zipCode = employee.zipCode()
            city = employee.city()
            homePhone = employee.homePhone()
            cellPhone = employee.cellPhone()
            hourlyRate = employee.hourlyRate()
            status = employee.status()
            
            if employee.supervisor(): supervisor = employee.supervisor().properName()
            if hireDate: hireDate = self.parseDate(hireDate)
            if termDate: termDate = self.parseDate(termDate)
            
            greeting="Edit "
            empIdString = empId
        else:
            empId = LastUsedFactory().getNextEmpId()
            empIdString = "<input type=text size=4 name='EmpId' value='%s'>" % empId

        self.writeln("""<table width="100%">""")
        self.writeln(self.writeJavascript())
        self.writeln( self.subTabs() )
        self.writeln("""<tr>\n\t<td>""")
        self.writeln("""<table width="100%">""")

        if serialNum and employee.activeLaborHed():
            self.writeln("""<tr><td colspan=4 align=center><font color='#ff0000'><b>Warning:</b> Employee cannot be edited while "Clocked In"</font></td></tr>""")

        self.writeln("<tr class=table_header><th colspan=4>%s Employee</th></tr>" % greeting)

        self.writeln("""<form method='post' action='./edit_employee?_action_=edit' name='empForm' id='empForm' onSubmit='return validOnSubmit(this);'>
        <tr><td align=right class=body_desc>Employee ID: </td><td align=left>%s&nbsp;</td>""" % empIdString )

        self.writeln("""<tr><td ALIGN=right CLASS=body_desc>First Name: </td><td ALIGN=left><INPUT TYPE=text NAME=FirstName CLASS=body_data LENGTH=20 value="%s" TABINDEX=1>&nbsp;</td>""" % firstName)

        self.writeln("""<td ALIGN=right CLASS=body_desc>Supervisor: </td>
        <td><SELECT NAME='Supervisor'>
        <OPTION VALUE=''></OPTION>""")
        
        for boss in EmployeeFactory().searchEmployee("WHERE empId<>%s ORDER BY lastName,firstName" % empId): #Display active employees/supervisors
            self.writeln( self.write_option(boss.serialNum(),str(boss.empId())+" "+boss.properName(), boss.properName() == supervisor ) )
        
        self.writeln("</select></td></tr>")

        self.writeln("""<tr><td ALIGN=right CLASS=body_desc>Last Name:&nbsp;</td><td ALIGN=left><INPUT TYPE=text NAME=LastName CLASS=body_data LENGTH=20 value="%s" TABINDEX=1>&nbsp;</td>""" % lastName )
        
        self.writeln("""
        <td ALIGN=right CLASS=body_desc>Shift:&nbsp;</td>
        <td ALIGN=left><SELECT NAME=Shift onChange='shiftHide(this.form);'>
        <OPTION VALUE=''></OPTION>""")

        for shift in ShiftFactory().getActiveShifts(shiftSerialNum):  # Display active shifts
            self.writeln( self.write_option(shift.serialNum(),shift.name(), shiftSerialNum==shift.serialNum()) )
        
        self.writeln("""</SELECT></td></tr>""")

        self.writeln("""
        <tr>
            <td ALIGN=right CLASS=body_desc>Email: </td>
            <td ALIGN=left><INPUT TYPE=text NAME=Email CLASS=body_data LENGTH=20 value="%s" TABINDEX=1></td>""" % self.escape(email))


        self.writeln("""
            <td ALIGN=right CLASS=body_desc>Override Start: </td>
            <td ALIGN=left><INPUT TYPE=text NAME=Shift_override_start CLASS=body_data SIZE=8 MAXLENGTH=8 value="%s">&nbsp;</td>
        </tr>
        <tr>
            <td ALIGN=right CLASS=body_desc>Hire Date: </td>
            <td ALIGN=left><INPUT TYPE=text ID=hire_date NAME=HireDate CLASS=body_data LENGTH=20 value="%s" TABINDEX=1 SIZE=10 MAXLENGTH=10><IMG ID=hire_trigger SRC=../images/button1.gif CLASS=pointer border=0></td>
            <td ALIGN=right CLASS=body_desc>Override End: </td>
            <td ALIGN=left><INPUT TYPE=text NAME=Shift_override_end CLASS=body_data SIZE=8 MAXLENGTH=8 value="%s">&nbsp;</td>

        </tr>
        """ % (self.escape(shiftOverrideStart),self.escape(hireDate),self.escape(shiftOverrideEnd)) )
        
        if status == "Active": status = [ "SELECTED","" ]
        else: status = [ "","SELECTED" ]
        
        self.writeln("""
        <tr>
            <td ALIGN=right CLASS=body_desc>Termination Date:&nbsp;</td>
            <td ALIGN=left><INPUT TYPE=text ID=term_date NAME=TermDate CLASS=body_data MAXLENGTH=20 value="%s" TABINDEX=1 SIZE=10 MAXLENGTH=10><IMG ID=term_trigger SRC=../images/button1.gif CLASS=pointer border=0></td>
            <td ALIGN=right CLASS=body_desc>Hourly Rate:&nbsp;</td>
            <td ALIGN=left><INPUT TYPE=text NAME=HourlyRate CLASS=body_data MAXLENGTH=20 SIZE=10 value="$%s">&nbsp;</td>
        </tr>
        <tr><td ALIGN=right CLASS=body_desc>Status:&nbsp;</td>
        <td><SELECT NAME=Status CLASS=body_data onChange="hideButton(this.form);" TABINDEX=1>
            <OPTION VALUE='Active' %s>Active</OPTION>
            <OPTION VALUE='Terminated' %s>Terminated</OPTION>
            </SELECT>

        </td>
        <td ALIGN=right CLASS=body_desc>PIN Number:&nbsp;</td>
        <td ALIGN=left>
        <input type='text' name='PinNumber' CLASS=body_data SIZE=5 VALUE='%s'>
        </td></tr>""" % (self.escape( termDate ),self.escape(hourlyRate, "0.00"),status[0],status[1],self.escape(pinNumber)) )


        self.writeln("""
        <tr>
        <td class=body_desc align=right>Departments:&nbsp;</td>
        <td>
        <table>
        <tr>
        <td width='100%'>
        <table width='100%'>
        <tr>
            <td class=body_desc>Works In:</td>
            <td>
            </td>
        </tr>
        </table>
        <select multiple size=8 name="CurrentDepartments" style='width: 200px; max-width: 200px;' TABINDEX=1>
        """)

        currentDepartments = []
        if self.isType(serialNum,int):
            for departmentForEmployee in EmployeeFactory().getEmployeeBySerialNum(int(serialNum)).department():
                currentDepartments.append(departmentForEmployee.code())

        self.writeln("""
        </select>
        <td>
            <table>
            <tr>
                <td>
        <input type='button' value='<<'  onclick="move(document.empForm.AvailableDepartments, document.empForm.CurrentDepartments); sendInfo(document.empForm.current_departments_selected, document.empForm.CurrentDepartments);">
                </td>
            <tr>
            <td>
        <input type='button' value='>>' onclick="move(document.empForm.CurrentDepartments, document.empForm.AvailableDepartments); sendInfo(document.empForm.current_departments_selected, document.empForm.CurrentDepartments);">
                </td>
            </tr>
            </table>
        </td>
        <td width='100%'>
        <table width='100%'>
        <tr>
            <td class=body_desc>Available:</td>
            <td>
            </td>
        </tr>
        </table>
        <select multiple size=8 name="AvailableDepartments" style='width: 200px; max-width: 200px;' TABINDEX=1>
            """)
        
        for department_list in DepartmentFactory().getActiveDepartments(serialNum):
            
            self.writeln( self.write_option(department_list.serialNum(),"%s %s" % (department_list.code(),department_list.description() ) ) ) 
            if currentDepartments.count(department_list.code()) > 0:
                self.writeln( """<script>selectAndMoveEntry('%s',document.empForm.AvailableDepartments,document.empForm.CurrentDepartments);</script>""" % ("%s %s" % (department_list.code(),department_list.description() ) ) )

        
        self.writeln("""</select>\n</td>\n</tr>\n</table>\n</td>\n</tr>""")
        self.writeln("<tr><td colspan=4 align=center><hr></td></tr>")
        
        
        self.writeln("""<tr><td align=right class=body_desc>Address: </td><td><INPUT TYPE=text NAME=Address CLASS=body_data VALUE='%s' TABINDEX=1></td><td align=right class=body_desc>Home Phone: </td><td><INPUT TYPE=text NAME=HomePhone CLASS=body_data VALUE='%s' TABINDEX=2></td></tr>""" % (self.escape(address),self.escape(homePhone)) )


        self.writeln("""<tr><td align=right class=body_desc>City: </td><td><INPUT TYPE=text NAME=City CLASS=body_data VALUE='%s' TABINDEX=1></td><td align=right class=body_desc>Cell Phone: </td><td ALIGN=left><INPUT TYPE=text NAME=CellPhone CLASS=body_data VALUE='%s' TABINDEX=2></td></tr>""" % (self.escape(city),self.escape(cellPhone)) )


        self.writeln("""<tr>\n\t<td align=right class=body_desc>State: </td>\n\t<td><select NAME=State TABINDEX=1>\n\t<option value=''></option>""")
                
        self.writeln( self.state_option(state) )
                
        self.writeln("""</select>\n\t</td>\n</tr>""")

        self.writeln("""<tr><td class=body_desc align=right>Zip Code: </td><td><INPUT CLASS=body_data TYPE=text NAME=ZipCode VALUE='%s' size=5 maxlength=5 TABINDEX=1></td></tr>"""  % self.escape( zipCode))

        self.writeln("""\t<tr><td ALIGN=right CLASS=body_desc>Notes:&nbsp;</td""")

        self.writeln("""<td ALIGN=left colspan=3><TEXTAREA NAME=Comments CLASS=body_data ROWS=4 COLS=56 TABINDEX=2>%s</TEXTAREA></td></tr>
        """ %  self.escape( notes ) )

        self.writeln("""<tr align=center height='40px'><td colspan=5>""")
        
        if (serialNum and not employee.activeLaborHed()) or not serialNum:
            self.writeln("""<INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;""")
                
        self.writeln("""<A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>""")

        self.writeln("""<script language="javascript" src="../js/jscalendar/calendar-setup.js"></script>""")
                
        self.writeln("""<script type="text/javascript">
            Calendar.setup({
                                inputField     :    "hire_date",     // id of the input field
                                ifFormat       :    "%m/%d/%Y",      // format of the input field
                                button         :    "hire_trigger",  // trigger for the calendar (button ID)
                                align          :    "Tr",           // alignment (defaults to "Bl")                                                                 
                                singleClick    :    true
                                                                                                                });
    
             Calendar.setup({
                                inputField     :    "term_date",     // id of the input field
                                ifFormat       :    "%m/%d/%Y",      // format of the input field
                                button         :    "term_trigger",  // trigger for the calendar (button ID)
                                align          :    "Tr",           // alignment (defaults to "Bl")                                       
                                singleClick    :    true
                                                                                                                });
        </script>""")

        if serialNum: self.writeln("<input type=hidden name='serialNum' value=%d>" % ( serialNum ) )
       
        self.writeln("""<input type='hidden' name='current_departments_selected'>""")      
        self.writeln("""<script>sendInfo(document.empForm.current_departments_selected,document.empForm.CurrentDepartments);</script>""")
        self.writeln("""</form>\n</table>""")
        self.writeln("""<script language='javascript'>shiftHide(document.getElementById("empForm"));hideButton(document.getElementById("empForm"));</script>""")
        self.writeln("""\t</td>\n</tr>\n</table>""")

