# vim: ts=4 et sts=4 sw=4 autoindent

from WebKit.Servlet import Servlet
from os import environ
from sndcs.AttachmentFactory import AttachmentFactory
from lib.SecureSitePage import SecureSitePage

from sndcs.EmployeeFactory import EmployeeFactory
workdir = environ["PWD"] + "/sndcs2_web"

class image_read(SecureSitePage):

    def __init__(self):
        pass #To prevent SecureSitePage.__init__() from being called

    def respond(self,trans):
        filetype,filename,filecontents = [ "image/jpeg","","" ]
        
        empId = self.returnType(trans.request().field("empId",""),int,0)
        if empId:
            attachment=EmployeeFactory().getEmployeeByEmpId(empId).picture()
            if attachment:
                filecontents = attachment.data()
                filetype = attachment.fileType()
                filename = "employee.jpg"
            else:
                empId = False
        else:
            empId = False
        
        
        if not empId:
            filetype="image/gif"
            filename=workdir + "/images/no_photo2.gif"
            file=open(filename,"rb")
            filename="no_photo2.gif"
            filecontents=file.read()
    
        trans.response().setHeader("Content-Type",filetype)
        trans.response().setHeader("Content-Length",str(len(filecontents)) )
        trans.response().setHeader("Content-Dispostion","inline; filename='%s'" % filename)
        trans.response().write(filecontents)
    
        if not empId:
            file.close()
