# vim: ts=4 et sts=4 sw=4 autoindent

from index import index
from lib.SecureSitePage import SecureSitePage
from etc import siteindex

from sndcs.UserFactory import UserFactory
from sndcs.AttachmentFactory import AttachmentFactory
from sndcs.EmployeeFactory import EmployeeFactory
from sndcs.Store import store

from datetime import datetime
currentdate = datetime.today().date()

class photo(index,SecureSitePage):
    def __init__(self):
        SecureSitePage.__init__(self,siteindex["dcs_edit_employees"],1,False,[ "../js/sndcs2_main.js" ])

    def writeJavascript(self):
        return """<script language='javascript' type='text/javascript'>
        function validOnSubmit(myForm) {
            if (myForm.filename.value=="") {
                alert('Error: Please select a valid image file');
                myForm.filename.focu`s();
                return false;
            }

        return true;
        }
        </script>"""

    def actions(self):
        return SecureSitePage.actions(self) + ["uploadphoto"]

    def uploadphoto(self):
        req = self.request()
        self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_employee" ) ) 
        
        empId = self.returnType(req.field("empId", ""),int,None)

        file = req.field("filename","")
        filename = file.filename
        filedata = file.value

        attachment = AttachmentFactory().new()
        attachment.setData(filedata)
        attachment.setDate(currentdate)
        attachment.setFileType("image/jpeg")

        store.addObject(attachment)
        store.saveChanges()

        employee = EmployeeFactory().getEmployeeByEmpId(int(empId))
        employee_photo = employee.picture()
        if employee_photo:
            employee.setPicture(None)
            store.saveChanges()
            store.deleteObject( employee_photo )

        employee.setPicture(attachment) 
        store.saveChanges()
        
        self.writeBody()

    def localTitle(self):
        return "Employee Photo"

    def writeLocalContent(self):
        req = self.request()

        width = 4 * 150 # 4:3 aspect ratio
        height = 3 * 150

        empId = self.returnType(req.field("empId",""),int,0)
        
        self.writeln("""<table width=100%">""")
        self.writeln( self.subTabs() )    
        self.writeln(self.writeJavascript())
        
        self.writeln("""<tr>\n\t<td>""")
        self.writeln("""<table width="100%">""")
        self.writeln("<form action='./photo?_action_=uploadphoto' method='post' enctype='multipart/form-data' onSubmit='return validOnSubmit(this);'>")
        self.writeln("<tr class=table_header><th>Employee Photo</th></tr>")

        self.writeln("<tr><td align=center bgcolor='#C0C0C0'><input type=file name=filename></td></tr>")

        self.writeln("<tr><td align=center><img src='./image_read.py?empId=%s' width='%d' height='%d'></td></tr>" % (empId,width,height) )
        self.writeln("<input type='hidden' name='empId' value='%s'>" % empId)
        
        self.writeln("""<tr><td height='40px' align=center height='40px'><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>""")

        self.writeln("</form>")
        self.writeln("</table>")
        self.writeln("""\t</td>\n</tr>\n</table>""")
