# vim: ts=4 et sts=4 sw=4 autoindent

from index import index
from etc import siteindex
from lib.SecureSitePage import SecureSitePage
from sndcs.EmployeeFactory import EmployeeFactory
from sndcs.DepartmentFactory import DepartmentFactory
from sndcs.Department import Department
from sndcs.Store import store

class search(index,SecureSitePage):

    def __init__(self):
        SecureSitePage.__init__(self,siteindex["dcs_edit_employees"],2,False,SecureSitePage.mainScripts + [ "../js/jscalendar/calendar.js", "../js/jscalendar/calendar-en.js" ])

    def actions(self):
        return index.actions(self) + [ "search" ]
    
    def localTitle(self):
        return "Search Employees"

    def newTab(self):
        return ["New Search","search"]

    def backPage(self):
        return "dcs_edit_employees/search"

    def search(self):
        req = self.request()
        message = ""

        message += ("""<table width="100%">""")
        message += ("""<tr><th align=right colspan=9 height='50px' class=refresh><a href='./search.py'>New Search</a></th></tr>
        <tr><th align=center class=table_header colspan=9>Search Results</th></tr>""")
        message += ( self.header )

        clauseString = req.field("clauseString","")

        if clauseString == "":
                if req.field("empId",""):
                    clauseString += " AND empId='%s'" % self.escape(req.field("empId"))
                if req.field("Lastname",""):
                    clauseString += " AND lastName LIKE '%%%s%%'" % self.escape(req.field("Lastname"))
                if req.field("Firstname",""):
                    clauseString += " AND firstName LIKE '%%%s%%'" % self.escape(req.field("Firstname"))
                if req.field("Status",""):
                    clauseString += " AND status='%s'" % self.escape(req.field("Status"))

        if not clauseString == "":
            employeeResults = EmployeeFactory().searchEmployee("WHERE %s " % clauseString[4:])
        elif req.field("Department",False):
            employeeResults = EmployeeFactory().getEmployees()
        else: employeeResults = False

        x = 0
        if employeeResults:
            self.start_color()
            for employee in employeeResults:
                if not req.field("Department", False) or store.fetchObjectsOfClass(Department,clauses = """WHERE employeeObjId=%s AND code='%s'""" % (employee.serialNum(),req.field("Department","") ) ):
                   bgcolor = self.next_color()
                   if employee.shift():
                        shiftName = employee.shift().name()
                   else: shiftName = ""

                   message += ("""
                        <tr bgcolor='%s'>
                            <td CLASS=list_data>&nbsp;%s</td>
                            <td CLASS=list_data>%s</td>
                            <td CLASS=list_data>%s</td>
                            <td CLASS=list_data align=left>%s</td>
                            <td CLASS=list_data align=left>%s</td>
                            <td align='center' width='30px'><a href='../dcs_edit_departments/task_list?employeeSerialNum=%s'><img src='../images/button4.gif' border=0></a></td>
                            <td align='center' width='30px'><a href='./photo?empId=%s'><img src='../images/button1.gif' border=0></a></td>
                            <td align='center' width='30px'><a href='./edit_employee?serialNum=%d'><img src='../images/button2.gif' border=0></a></td>
                            <td align='center' width='30px'><a href='./index?_action_=delete&serialNum=%d'><img src='../images/button3.gif' border=0></a></td>
                        </tr>""" % (bgcolor,employee.empId(),self.escape( employee.lastName() ),self.escape( employee.firstName() ),employee.status(),self.escape( shiftName ),employee.serialNum(),employee.empId(),employee.serialNum(),employee.serialNum() ) )
                   x += 1
        
        if not x:
            message += ("<tr><td colspan=8 align=center><b>No Matching Records!</b></td></tr>")

        message += ( self.header )
        message += ("""</table>""")

        self.message = message
        self.writeBody()

        self.session().setValue("backPage","search?_action_=search&clauseString=%s" % self.convertToHexString(clauseString) )
        self.setSearchResultsPage()

    def writeLocalContent(self):
       
        self.writeln("""<table width="100%">""")

        self.writeln( self.subTabs() )
        self.writeln("""<tr>\n\t<td>""")

        if self.message == "":
                self.writeln("""<table align="center" width="50%">""")
                self.writeln("""<tr CLASS=table_header><th COLSPAN=4>Search Employees</th></tr>
                <FORM METHOD='post' ACTION='./search?_action_=search'>
                <tr><td ALIGN=right CLASS=body_desc>Employee ID: </td>
                <td ALIGN=left><INPUT TYPE=text NAME=empId CLASS=body_data SIZE=15></td></tr>
                <tr><td ALIGN=right CLASS=body_desc>Last Name: </td>

                <td ALIGN=left><INPUT TYPE=text NAME=Lastname CLASS=body_data SIZE=15></td></tr>
                <tr><td ALIGN=right CLASS=body_desc>First Name: </td>
                <td ALIGN=left><INPUT TYPE=text NAME=Firstname CLASS=body_data SIZE=15></td></tr>
                <tr><td ALIGN=right CLASS=body_desc>Status: </td>
                <td ALIGN=left>
                <SELECT NAME=Status CLASS=body_data>
                      <OPTION VALUE=''>Any</OPTION>
                      <OPTION VALUE='Active'>Active</OPTION>
                      <OPTION VALUE='Terminated'>Terminated</OPTION>
                </SELECT>
                </td></tr>
                <tr><td ALIGN=right CLASS=body_desc>Department:&nbsp;</td>
                <td ALIGN=left>
                <SELECT NAME=Department CLASS=body_data>
                <option value=''></option>""")

                for department in DepartmentFactory().getDepartments():
                    self.writeln( self.write_option( department.code(),"%s %s" % (department.code(),department.description()) ) )

                self.writeln("""
                </SELECT>
                </td>
                </tr>
                
                <tr><td height='40px' colspan=2 align='center'><INPUT TYPE=image SRC="../images/search1.gif" onMouseDown="this.src='../images/search1down.gif';" onMouseOut="this.src='../images/search1.gif';" ><A HREF=./employees.py>&nbsp;<A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>
                </form></table>""")

        else:

                self.writeln( self.message)

        self.writeln("""\t</td>\n</tr>\n</table>""")
