# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from sndcs.OperationFactory import OperationFactory
from sndcs.DepartmentFactory import DepartmentFactory
from sndcs.EmployeeFactory import EmployeeFactory
from index import index
from etc import siteindex

class task_list(index,SecureSitePage):


    def localTitle(self):
        return "Open Operations"
    
    def writeLocalContent(self):
        req = self.request()
        employeeSerialNum = self.returnType(req.field("employeeSerialNum",""),int,0)
        
        if not employeeSerialNum:
            self.goToPage("dcs_edit_employees")
        
        self.writeln("""<table width=100%>""")
        self.writeln("""<tr>\n\t<td>\n\t<table align=center cellpadding=4>""")
        
        employee = EmployeeFactory().getEmployeeBySerialNum(employeeSerialNum)
        self.writeln("""<tr class=body_desc><td align=center colspan=5>Open Operations For Employee '%s - %s'</td></tr>""" % (employee.empId(), employee.properName()) )
        
        header = ("""\n<tr class=table_header>
            <th>Job #</th>
            <th>Asm. #</th>
            <th>Opr. #</th>
            <th>Due Date</th>
            <th>Description</th>
        </tr>""")

        results = []

        for department in EmployeeFactory().getDepartmentsOfEmployeeBySerialNum(employeeSerialNum):
            department = DepartmentFactory().getDepartmentByCode(department.code()) # CLEANUP IN 2.1
            results += [ (self.parseDate(x.assembly().jobHed().dueDate()),x.assembly().jobHed().number(),x.assembly().number(),x.number(),x) for x in OperationFactory().getOperationsByDepartmentSerialNum(department.serialNum()) ]

        results.sort()
        if results:
            self.writeln(header)

            for operation in results:
                self.writeln("""<tr><td>%s</td><td>%s<td>%s</td><td>%s</td><td>%s</td>""" % ( operation[1], operation[2], operation[3], operation[0], operation[-1].formattedDescription() ) )

            self.writeln(header)
        self.writeln("""\t</td>\n</tr>\n</table>""")
        
        self.writeln("""<tr><td align=center><A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>""")
    
        self.writeln("""\t</td>\n</tr>\n</table>""")
