# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from etc import siteindex
from sndcs.IndirectFactory import IndirectFactory

class index(SecureSitePage):
        
        header = ("""
        <tr CLASS=table_header ALIGN=left>
            <th align=left>&nbsp;Code&nbsp;</th>
            <th align=left WIDTH=80%%>Description</th>
            <th WIDTH='30px'>Active</th>
            <th ALIGN=center WIDTH='30px'>&nbsp;Edit</th>
            <th ALIGN=center WIDTH='30px'>&nbsp;Delete</th>
        </tr>""")


        def __init__(self):
                SecureSitePage.__init__(self,siteindex["dcs_edit_indirect"],0)

        def newTab(self):
                return ["New Indirect","indirects"]
                
        def writeJavascript(self):
                return """
                <script language='javascript'>
                // Form validation
                function validOnSubmit(myForm) {
                    
                    if ( isInteger(myForm.Code.value) == false || (myForm.Code.value=="") ) {
                        alert("Error: Please Enter A Valid Code");
                        myForm.Code.focus();
                        return false;
                    }
                                    
                    if ( myForm.Description.value=="" ) {
                        alert("Error: Please Enter A Description");
                        myForm.Description.focus();
                        return false;
                    }
                    
                    // Tests passed
                    return true;
                };
                </script>"""    

        def localTitle(self):
            return "Indirect Activities"

        def writeLocalContent(self):

                self.writeln("""<table width="100%">""")
                 
                self.writeln( self.header )

                self.start_color()
                for indirect in IndirectFactory().getIndirects():
                    bgcolor = self.next_color()
                    self.writeln("<tr bgcolor='%s'>" % bgcolor)
                
                    ActiveBool = self.ifTrueReturn(indirect.isActive(),"Yes","No")
                    
                    self.writeln("<td class=list_data>%s</td><td width=400px class=list_data>%s</td><td class=list_data align='center'>%s</td><td align='center'><a href='./indirects?serialNum=%s'><img border='0' src='../images/button4.gif'/></a></td><td align='center'><a href='./indirects?_action_=delete&serialNum=%d'><img border='0' src='../images/button3.gif'/></a></td>" % ( indirect.code(), indirect.description(), ActiveBool, indirect.serialNum(), indirect.serialNum() ) )
            
                self.writeln(self.header)
                
                self.writeln("""
                <tr>
                    <td colspan=5 align=center height='40px'><A HREF="./indirects"><IMG SRC="../images/new.gif" onMouseDown="this.src='../images/newdown.gif';" onMouseOut="this.src='../images/new.gif';" style="border-style: none;"></A></td>
                </tr>
                </table>""")
