# vim: ts=4 et sts=4 sw=4 autoindent

from index import index
from sndcs.IndirectFactory import IndirectFactory
from sndcs.Indirect import Indirect
from lib.SecureSitePage import SecureSitePage

from etc import siteindex

from sndcs.UserFactory import UserFactory

from sndcs.Store import store

class indirects(index,SecureSitePage):

        def __init__(self):
                SecureSitePage.__init__(self,siteindex["dcs_edit_indirect"],0)

        def actions(self):
                return [ "edit", "delete" ]

        def edit(self):
                req=self.request()
                serialNum = self.returnType(req.field("serialNum",""),int, None)
                
                if serialNum:
                    self.redirectIfTrue( ( self.session().value("userLoggedOn") == 1 ) and ( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_indirect" ) ) ) 
                    tmpedit = IndirectFactory().getIndirectBySerialNum(int(serialNum) )
                    tmpedit.delete()
                else:
                    self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "create_indirect" ) ) 
                    tmpedit = IndirectFactory().new( req.field("Code") )

                if store.fetchObjectsOfClass(Indirect,clauses = """WHERE Code='%s' AND serialNum<>%s""" % (req.field("Code"), tmpedit.serialNum() ) ):
                        self.message = "<b>Error:</b> A Indirect already has that code"
                        store.saveChanges()
                        self.writeBody()
                        return
                else:

                        if req.hasField("IsActive"):
                            tmpedit.setIsActive( True )
                        else:
                            tmpedit.delete()
                            tmpedit.setIsActive(False)

                        description = req.field("Description","No Description")
                        tmpedit.setDescription( description )

                        if not tmpedit.serialNum():
                            store.addObject(tmpedit)
                            if tmpedit.isActive():
                                tmpedit.add()
                        else:
                            tmpedit.edit()

                        store.saveChanges()

                self.goToPage("dcs_edit_indirect")

        def delete(self):
                req = self.request()
                serialNum = self.returnType(req.field("serialNum",""),int,None)
                self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "delete_indirect" ) ) 
               
                tmpdelete = IndirectFactory().getIndirectBySerialNum( int(serialNum) )
                if not tmpdelete.referencingObjectsAndAttrs():
                    store.deleteObject(tmpdelete)
                else:
                    tmpdelete.setIsActive(False)
                    
                tmpdelete.delete()
                store.saveChanges()
                    
                self.goToPage("dcs_edit_indirect")

        def localTitle(self):
            if self.request().hasField("serialNum"):
                return "Edit Indirect Activity"
            else:
                return "Create New Indirect Activity"

        def writeLocalContent(self):
                req = self.request()
                serialNum = self.returnType(req.field("serialNum",""),int,None)

                self.writeln("""<table width="50%">""")
                if self.message is not "":
                    self.writeln("""<tr align='center'><td colspan=3><font color='#ff0000'>%s</font></td></tr>""" % self.message)
                else:
                    greeting,code,description,active = [ "New","","","CHECKED" ]

                    if serialNum:
                            tmpread = IndirectFactory().getIndirectBySerialNum( serialNum )
                            
                            greeting = "Edit"
                            code = tmpread.code()
                            description = tmpread.description()
                            active = self.ifTrueReturn(tmpread.isActive(),"CHECKED","")

                    self.writeln( self.writeJavascript() )
                    self.writeln("""<tr CLASS=table_header><th COLSPAN=4>%s Indirect Task</th></tr>
                    <form action='./indirects?_action_=edit' onSubmit='return validOnSubmit(this)' method='post'>
                    <tr><td ALIGN=right CLASS=body_desc>&nbsp;Code:&nbsp;</td>
                    <td ALIGN=left><INPUT TYPE=text NAME=Code CLASS=body_data VALUE='%s'>&nbsp;</td></tr>
                    <tr><td ALIGN=right CLASS=body_desc>&nbsp;Description:&nbsp;</td>
                    <td ALIGN=left><INPUT TYPE=text NAME=Description CLASS=body_data VALUE='%s'>&nbsp;</td></tr>
                    <tr><td ALIGN=right CLASS=body_desc>&nbsp;Active:&nbsp;</td>
                    <td ALIGN=left><INPUT TYPE=checkbox NAME=IsActive CLASS=body_data VALUE=1 %s></td></tr>
                    <tr><td align=center colspan=2 height='40px'><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>""" % (greeting,self.escape(code),self.escape(description),active) )
                
                    if serialNum:
                        self.writeln("<input type='hidden' name='serialNum' value='%s'>" % serialNum)
                
                    self.writeln("""\t</form>""")

                self.writeln("""</table>""")
