# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from etc import siteindex
from scrapcodes import scrapcodes

from sndcs.ScrapCodeFactory import ScrapCodeFactory
from sndcs.ScrapCode import ScrapCode
from sndcs.Store import store

class edit_scrapcodes(scrapcodes,SecureSitePage):

        def localTitle(self):
                req = self.request()
                if req.hasField("serialNum"):
                    return "Edit Scrap Code"
                else:
                    return "New Scrap Code"

        def writeLocalContent(self):
                req = self.request()
                serialNum = self.returnType(req.field("serialNum",""),int,None)

                if serialNum:
                    tmpedit = ScrapCodeFactory().getScrapCodeBySerialNum(int(serialNum) )
                    greeting = "Edit"
                    code = tmpedit.code()
                    description = tmpedit.description()
                    active = self.ifTrueReturn(tmpedit.active(),"CHECKED","")
                else:
                    greeting = "Create New"
                    active = "CHECKED"
                    code = ""
                    description = ""

                self.writeln( self.writeJavascript() )
                self.writeln("""<table width="100%">""")
                self.writeln( self.subTabs() )
                self.writeln("""<tr>\n\t<td>""")

                self.writeln("""<table width="50%" align="center">""") 
                self.writeln("""
                <tr CLASS=table_header><th COLSPAN=4>%s Scrap Code </th></tr>
                <FORM METHOD="post" ACTION="./scrapcodes?_action_=edit" onSubmit='return validOnSubmit(this);'>
                <tr><td ALIGN=right CLASS=body_desc WIDTH=10%%>&nbsp;Code:&nbsp;</td>
                <td ALIGN=left><INPUT TYPE=TEXT NAME=Code CLASS=body_data VALUE="%s"></td></tr>
                <tr><td ALIGN=right CLASS=body_desc>&nbsp;Description:&nbsp;</td>
                <td ALIGN=left><INPUT TYPE=TEXT NAME=Description CLASS=body_data VALUE="%s"></td></tr>
                <tr><td ALIGN=right CLASS=body_desc>Active:</td>
                <td ALIGN=left><input type='checkbox' name='Active' VALUE=1 %s></td></tr>
                <input type='hidden' name='_action_' value='edit'>
                <tr height='40px'><td colspan=2 align=center><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./scrapcodes"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>""" % (greeting,code,description,active) );
                
                if serialNum:
                    self.writeln("<input type='hidden' name='serialNum' value=%s>" % serialNum)
                
                self.writeln("</form>\n</table>\n\t</td>\n</tr>\n</table>")


