# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from etc import siteindex
from unitsofmeasure import unitsofmeasure

from sndcs.UnitOfMeasureFactory import UnitOfMeasureFactory
from sndcs.UnitOfMeasure import UnitOfMeasure
from sndcs.Store import store

class edit_unitsofmeasure(unitsofmeasure,SecureSitePage):

        def localTitle(self):
                req=self.request()
                if req.hasField("serialNum"):
                    return "Edit Unit Of Measure"
                else:
                    return "New Unit Of Measure"

        def writeLocalContent(self):
                req=self.request()
                
                serialNum,greeting,code,description = [ False,"Create New","","" ]

                if req.hasField("serialNum"):
                    serialNum=req.field("serialNum")
                    tmpedit=UnitOfMeasureFactory().getUnitOfMeasureBySerialNum(int(serialNum) )
                    greeting="Edit"
                    code=tmpedit.code()
                    description=tmpedit.description()

                self.writeln( self.writeJavascript() )
                self.writeln("""<table width="100%">""")
                self.writeln( self.subTabs() )
                self.writeln("""<tr>\n\t<td>""")

                self.writeln("""<table width="50%" align="center">""") 
                self.writeln("""
                <tr CLASS=table_header><th COLSPAN=4>%s Unit Of Measure </th></tr>
                <FORM METHOD="post" ACTION="./unitsofmeasure.py" onSubmit='return validOnSubmit(this);'>
                <tr><td ALIGN=right CLASS=body_desc WIDTH=10%%>&nbsp;Code:&nbsp;</td>
                <td ALIGN=left><INPUT TYPE=TEXT NAME=Code CLASS=body_data VALUE="%s"></td></tr>
                <tr><td ALIGN=right CLASS=body_desc>&nbsp;Description:&nbsp;</td>
                <td ALIGN=left><INPUT TYPE=TEXT NAME=Description CLASS=body_data VALUE="%s"></td></tr>
                <input type='hidden' name='_action_' value='edit'>
                <tr height='40px'><td colspan=2 align=center><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./unitsofmeasure.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>""" % (greeting,code,description) );
                
                if serialNum:
                    self.writeln("<input type='hidden' name='serialNum' value=%s>" % serialNum)
                
                self.writeln("</form>\n</table>\n\t</td>\n</tr>\n</table>")


