# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from sndcs.BOMFactory import BOMFactory
from sndcs.ItemFactory import ItemFactory
from sndcs.Item import Item
from sndcs.RoutingFactory import RoutingFactory
from sndcs.Routing import Routing
from sndcs.UserFactory import UserFactory
from sndcs.ItemPriceByCustomer import ItemPriceByCustomer
from sndcs.ItemPriceByCustomerFactory import ItemPriceByCustomerFactory
from sndcs.CustomerFactory import CustomerFactory
from sndcs.UnitOfMeasureFactory import UnitOfMeasureFactory
from sndcs.DepartmentFactory import DepartmentFactory

from sndcs.Store import store
from etc import siteindex

class index(SecureSitePage):
    
    header = ("""\n<tr class=table_header>
            <th ALIGN=left>Item # </th>
            <th width=70% align=left>Description</th>
            <th>&nbsp;Sales Price&nbsp;</th>
            <th>&nbsp;Purchase Price&nbsp;</th>
            <th>&nbsp;Department&nbsp;</th>
            <th WIDTH='30px'>Edit&nbsp;</th>
            <th WIDTH='30px'>&nbsp;UOM&nbsp;</th>
            <th WIDTH='30px'>&nbsp;Pricing&nbsp;</th>
            <th WIDTH='30px'>&nbsp;BOM&nbsp;</th>
            <th WIDTH='30px'>&nbsp;Routing&nbsp;</th>
            <th WIDTH='30px'>&nbsp;Delete</th>
        </tr>""")

    def __init__(self):
        SecureSitePage.__init__(self,siteindex["dcs_edit_items"],1)

    def actions(self):
        return SecureSitePage.actions(self) + [ "edit","delete" ]

    def newTab(self):
        return [ "New Item","new_item" ]

    def edit(self):
        req = self.request()
        
        serialNum = self.returnType(req.field("serialNum",""),int,None)
        edit_type = req.field("edit_type",False)

        if req.hasField("new"):
            self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "create_items" ) ) 
        else:
            self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_items" ) ) 

        deleteValues = [ "x", "y", "_action_" ]
    
        if edit_type == "routing":
                if req.hasField("new"):
                        tmproute = RoutingFactory().new()
                        number = self.returnType(req.field("Number",""),int,0)
                        tmpitem = ItemFactory().getItemBySerialNum( serialNum ) 
                        
                        if store.fetchObjectsOfClass(Routing,clauses="WHERE itemObjID='%s' AND number='%s'" % (tmpitem.serialNum(),number) ):
                            self.message = "<b>Error:</b> A routing item already exists with that number"
                            self.writeBody()
                            return

                        tmproute.setItem( tmpitem )
                        tmproute.setNumber( str(number) )
                        tmproute.setDescription( req.field( "Description", "No Description" ) )

                        department = self.returnType(req.field("Department",""),int,None)
                        if department: department = DepartmentFactory().getDepartmentBySerialNum( department )
                        tmproute.setDepartment(department)
                        
                        conversionUnit = self.returnType(req.field( "ConversionUnit", ""),float,1.0)
                        tmproute.setConversionUnit(conversionUnit)

                        unitOfMeasure = self.returnType(req.field("UnitOfMeasure",""),int,None)
                        if unitOfMeasure:
                            unitOfMeasure = UnitOfMeasureFactory().getUnitOfMeasureBySerialNum( unitOfMeasure )
                        tmproute.setUnitOfMeasure(unitOfMeasure)

                        store.addObject( tmproute )
                        store.saveChanges()

                else:
                        # MULTI-ENTRY BELOW
                        for eachKey,eachNull in dict(req.fields()).items(): # Check to make sure there are no duplicate routing numbers.        
                                if eachKey.count("editRouting"):
                                        serialNum = int( eachKey.replace("editRouting","") )
                                        valueToCompare = self.returnType(req.field("Number%s" % serialNum ),int,None)
                                        lastkey = eachKey
                                        for eachKey,eachNull in dict(req.fields()).items():
                                            if not eachKey == lastkey and eachKey.count("editRouting"):
                                                serialNum = int( eachKey.replace("editRouting","") )
                                                value = self.returnType(req.field('Number%s' % serialNum, ""),int,None )
                                                if value == valueToCompare:
                                                    self.goToPage("dcs_edit_items/routing?serialNum=%s&referrentBOM=%s" % ( req.field("serialNum",0),req.field("referrentBOM",req.field("serialNum",0) ) ) )
                        
                        for eachKey,eachNull in dict(req.fields()).items():
                                if eachKey.count("editRouting"):
                                        serialNum = int( eachKey.replace("editRouting","") )
                                        tmprouting = RoutingFactory().getRoutingBySerialNum( serialNum )
                                        
                                        number = self.returnType(req.field('Number%s' % serialNum,""),int,0)
                                        if not store.fetchObjectsOfClass(Routing,clauses="WHERE number='%s' AND serialNum<>'%s'" % (number,serialNum) ):
                                            if self.isType(number,int):
                                                tmprouting.setNumber(str(number))

                                        description = req.field('Description%s' % serialNum,"")
                                        if description == "":
                                            description="No Description"
                                        tmprouting.setDescription(description)
                                        
                                        conversion_unit = self.returnType(req.field('ConversionUnit%s' % serialNum,""),float,1.0)
                                        tmprouting.setConversionUnit( conversion_unit )

                                        unit_of_measure = self.returnType(req.field('UnitOfMeasure%s' % serialNum,""),int,None)
                                        if unit_of_measure:
                                            unit_of_measure = UnitOfMeasureFactory().getUnitOfMeasureBySerialNum( unit_of_measure )
                                        tmprouting.setUnitOfMeasure(unit_of_measure)

                                        department = self.returnType(req.field('Department%s' % serialNum,""),int,None)
                                        if department:
                                            department = DepartmentFactory().getDepartmentBySerialNum( department )
                                        tmprouting.setDepartment( department )

                                        store.addObject(tmprouting)
                                        store.saveChanges()
                        self.goToPage("dcs_edit_items/routing?serialNum=%s&referrentBOM=%s" % ( req.field("serialNum"),req.field("referrentBOM",req.field("serialNum") ) ) )

        elif edit_type=="bom":
                if serialNum:
                        centerFactory = ItemFactory().getCenterBOMItemByItemSerialNum( int( serialNum ) )
                        bomadd = req.field("BomItem", False)
                        if centerFactory and bomadd:
                            tmpbom = BOMFactory().new()
                            
                            # B Reference
                            tmpbom.setItem( centerFactory )

                            # C Reference
                            tmpitem = ItemFactory().getItemBySerialNum( int( bomadd ) )

                            tmpbom.setNumber( tmpitem.number() )
                            tmpbom.setMaterial( tmpitem )
                            store.addObject(tmpbom)

                        elif bomadd:
                            # Link to central BOM ITEM first
                            tmpbom = BOMFactory().new()
                            # A Reference
                            
                            tmpmaterial = ItemFactory().getItemBySerialNum( int( bomadd ) )
                            tmpitem = ItemFactory().getItemBySerialNum( int( serialNum ) )
                            
                            store.addObject( tmpmaterial )
                            store.saveChanges()

                            tmpbom.setItem( tmpitem )
                            tmpbom.setMaterial( tmpmaterial )

                            tmpbom.setNumber( tmpmaterial.number() )
                            store.addObject(tmpbom)

                        store.saveChanges()
                        self.goToPage("dcs_edit_items/bom?serialNum=%s" % serialNum)

        elif edit_type == "customer_price":
                    if serialNum:
                            customerNumber = self.returnType(req.field("CustomerNumber",""),int,0)
                            customerPrice = self.returnType(str(req.field("CustomerPrice")).replace("$",""),float,0.00)
                            
                            if not customerPrice:
                                self.message = """<tr align=center><td><font color="#ff0000"><b>Error:</b> Invalid price entered</font></td></tr>"""
                                self.writeBody()
                                return

                            if not store.fetchObjectsOfClass(ItemPriceByCustomer,clauses="WHERE customerObjId='%s' AND itemObjId='%s'" % (customerNumber,serialNum) ):
                                tmpItemPrice = ItemPriceByCustomerFactory().new()


                                tmpItemPrice.setCustomer( CustomerFactory().getCustomerBySerialNum( customerNumber ) )
                                tmpItemPrice.setItem( ItemFactory().getItemBySerialNum( serialNum ) )
                                tmpItemPrice.setPrice( customerPrice )

                                store.addObject(tmpItemPrice)
                                store.saveChanges()

                            else:
                                self.message="""<tr align=center><td><font color="#ff0000"><b>Error:</b> Cannot create entry a item price for that customer already exists</font></td></tr>"""
                                self.writeBody()
                                return
                    else:
                            for eachKey, eachNull in dict(req.fields()).items():
                                    if eachKey.count("editItemPrice"):
                                            serialNum = self.returnType( eachKey.replace("editItemPrice",""),int,None)
                                            price = self.returnType(str(req.field('ItemPrice%s' % serialNum,"")).replace("$",""),float,0.00)
                                            
                                            tmpItemPrice = ItemPriceByCustomerFactory().getItemPriceBySerialNum( serialNum )
                                            tmpItemPrice.setPrice(price)

                                            store.addObject(tmpItemPrice)
                                            store.saveChanges()

                    self.goToPage(self.getBackPage())
        elif edit_type == "unitOfMeasure":
                    tmpedit = ItemFactory().getItemBySerialNum(int(serialNum))
                    
                    unitOfMeasure = self.returnType(req.field("UnitOfMeasure",""),int,None)
                    if unitOfMeasure:
                        unitOfMeasure = UnitOfMeasureFactory().getUnitOfMeasureBySerialNum( unitOfMeasure )
                    tmpedit.setUnitOfMeasure(unitOfMeasure)

                    store.addObject(tmpedit)
                    store.saveChanges()
                    
                    if self.session().value("searchResults",False):
                        self.goToPage("dcs_edit_items/" + self.backPage())
                    else: self.goToPage( self.backPage() )
        else:
                    if req.hasField("new"):
                            itemNumber = req.field("Number","")
                            if store.fetchObjectsOfClass(Item,clauses="WHERE number='%s'" % itemNumber ):
                                    self.message="""<b>Error:</b> Item already exists with that Item Number"""
                                    self.writeBody()
                                    return                                            

                            tmpedit = ItemFactory().new()
                            
                            tmpedit.setSalesPrice(float( str( req.field("SalesPrice") ).replace("$","") ) )
                            tmpedit.setPurchasePrice(float( str( req.field("PurchasePrice") ).replace("$","") ) )
                            
                            unitOfMeasure = self.returnType(req.field("UnitOfMeasure",""),int,None)
                            if unitOfMeasure:
                                unitOfMeasure = UnitOfMeasureFactory().getUnitOfMeasureBySerialNum( unitOfMeasure )
                            tmpedit.setUnitOfMeasure(unitOfMeasure)

                            department = self.returnType(req.field("Department",""),int,None)
                            if department:
                                department = DepartmentFactory().getDepartmentBySerialNum( department )
                            tmpedit.setDepartment(department)

                            deleteValues= [ "PurchasePrice","SalesPrice","new","_action_","y","x","edit_type","UnitOfMeasure","Department" ]

                            for key,value in dict(req.fields()).items():
                                if not key in deleteValues:
                                    self.middleKitObjectEval(tmpedit,key,value)

                            store.addObject(tmpedit)
                            store.saveChanges()
                    
                    else:
                            # MULTI-ENTRY BELOW
                            for eachKey,eachNull in dict(req.fields()).items():
                                    if eachKey.count("editItem"):
                                            serialNum = int( eachKey.replace("editItem","") )
                                            tmpitem = ItemFactory().getItemBySerialNum( serialNum )
                                            description = req.field("Description%s" % serialNum,"")
                                            if description == "":
                                                description = "No Description"
                                            tmpitem.setDescription(description)

                                            purchaseprice = self.returnType( str( req.field("PurchasePrice%s" % serialNum,"") ).replace("$",""),float,0.00 )
                                            tmpitem.setPurchasePrice( purchaseprice )

                                            salesprice = self.returnType( str( req.field("SalesPrice%s" % serialNum,"") ).replace("$",""), float,0.00 )
                                            tmpitem.setSalesPrice( salesprice )

                                            department = self.returnType(req.field("Department%s" % serialNum,""),int,None)
                                            if department:
                                                department = DepartmentFactory().getDepartmentBySerialNum( int( department ) )
                                            tmpitem.setDepartment(department)

                                            store.addObject(tmpitem)
                                            store.saveChanges()
            
        self.goToPage(self.backPage())

    def delete(self):
            req = self.request()
            self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "delete_items" ) ) 
    
            serialNum = self.returnType(req.field("serialNum",""),int,None)
            delete_type = req.field("delete_type","")

            if delete_type == "routing":
                tmpdelete = RoutingFactory().getRoutingBySerialNum( int( req.field("serialNum") ) )
                if not tmpdelete.referencingObjectsAndAttrs():
                    store.deleteObject(tmpdelete)
                    store.saveChanges()
            elif delete_type=="bom": 
                tmpdelete = BOMFactory().getBOMBySerialNum( int( serialNum ) )
                if not tmpdelete.referencingObjectsAndAttrs():
                    store.deleteObject(tmpdelete)
                    store.saveChanges()

            elif delete_type == "itemPriceByCustomer":
                tmpdelete = ItemPriceByCustomerFactory().getItemPriceBySerialNum( int( req.field("serialNum") ) )
                if not tmpdelete.referencingObjectsAndAttrs():
                    store.deleteObject(tmpdelete)
                    store.saveChanges()
            else: 
                    tmpdelete = ItemFactory().getItemBySerialNum( int( serialNum ) )
                        
                    for test in tmpdelete.referencingObjectsAndAttrs():
                            if str(test[0])[:6]=="JobHed":
                                self.message=("""<b>Error:</b> Cannot delete a Item that is referenced by a JobHed/Item/BOM""")
                                self.writeBody()
                                return
                    
                    for tmpdeleteBOM in BOMFactory().getBOMsByItemSerialNum( int( serialNum ) ):
                                
                            for tmpdeleteRouting in RoutingFactory().getRoutingsByBOMSerialNum( tmpdeleteBOM.serialNum() ):
                                    if tmpdeleteRouting.referencingObjectsAndAttrs():
                                        store.deleteObject( tmpdeleteRouting )
                                        store.saveChanges()
                                    
                            if not tmpdeleteBOM.referencingObjectsAndAttrs():
                                store.deleteObject(tmpdeleteBOM)
                                store.saveChanges()
                        
                    for tmprouting in RoutingFactory().getRoutingsByBOMSerialNum( tmpdelete.serialNum() ):
                        if not tmprouting.referencingObjectsAndAttrs(): 
                            store.deleteObject( tmprouting )
                            store.saveChanges()
                            
                    if tmpdelete.referencingObjectsAndAttrs():
                        store.deleteObject( tmpdelete )
                        store.saveChanges()
                    else:
                        self.message="""<b>Error:</b> Cannot delete an Item that is referenced by an Item/BOM/JobHed"""
                        self.writeBody()
                        return
                            
            self.goToPage(self.backPage())

    def writeJavascript(self,section=""):
        if section=="routing":
                return """
                <script language='javascript' type='text/javascript'>
                <!--
                function validOnSubmit(myForm) {

                        if ( (myForm.Number.value == "" ) || ( isInteger( myForm.Number.value ) == "false") ) {
                            alert('Error: Please enter an Routing Number');
                            myForm.Number.focus();
                            return false;
                        }

                        if ( myForm.Description.value == "") {
                            alert('Error: Please enter an Routing Description');
                            myForm.Description.focus();
                            return false;
                        }


                };
                // -->
                </script>"""

        elif section=="hideUnhide":
                return """
                <script language='javascript' type='text/javascript'>
                function checkIfOpen(MyCheckbox,Number,Description) {
                    if (MyCheckbox.checked) {
                        if (Number) {
                            Number.disabled=false;
                        }
                        Description.disabled=false;
                    }
                    else {
                        if (Number) {
                            Number.disabled=true;
                        }
                        Description.disabled=true;
                    }
                }
                </script>"""

        elif section=="hideUnhidePrice":
                return """
                <script language='javascript' type='text/javascript'>
                function checkIfOpen(MyCheckbox,ItemPrice) {
                    if (MyCheckbox.checked) {
                        if (ItemPrice) {
                            ItemPrice.disabled=false;
                            return false;
                        }
                    }
                    ItemPrice.disabled=true;
                }
                </script>
                """

        elif section=="customer_price":
                return """
                <script language='javascript' type='text/javascript'>
                function validOnSubmit(myForm) {
                    if ( (myForm.CustomerNumber.value == "") ) {
                        alert('Error: Please select a Customer');
                        myForm.CustomerNumber.focus();
                        return false;
                    }

                    if ( (myForm.CustomerPrice=="") ) {
                        alert('Error: Please enter a valid Price');
                        myForm.CustomerPrice.focus();
                        return false;
                    }
                return true;
                }
                </script>"""
        
        elif section=="item":
                return """
                <script language='javascript' type='text/javascript'>
                <!--
                function validOnSubmit(myForm) {
                        
                        if ( (myForm.Number.value == "") || ( isFloat( myForm.Number.value ) == "false") ) {
                            alert('Error: Please enter an Item number');
                            myForm.Number.focus();
                            return false;
                        }

                        if ( myForm.Description.value == "") {
                            alert('Error: Please enter an Item Description');
                            myForm.Description.focus()
                            return false;
                        }


                };
                // -->
                </script>"""


        else:
                
                return """
                <script language='javascript' type='text/javascript'>
                <!--
                function checkIfOpen(MyCheckbox,Description,SalesPrice,PurchasePrice,Department) {
                    if (MyCheckbox.checked) {
                        Description.disabled = false;
                        SalesPrice.disabled = false;
                        PurchasePrice.disabled = false;
                        Department.disabled = false;
                    }
                    else {
                        Description.disabled = true;
                        SalesPrice.disabled = true;
                        PurchasePrice.disabled = true;
                        Department.disabled = true;
                    }
                }
                // -->
                </script>"""

    def backPage(self):
        return "dcs_edit_items"

    def localTitle(self):
        return "Items"

    def subTabs(self,colspan=1):
        subtab1 = self.write_div(id="subtab1",classname="subtab",text="Main", construct = [ 1, siteindex["dcs_edit_items"], "index" ]);
        subtab2 = self.write_div(id="subtab2",classname="subtab",text="Search", construct = [ 2, siteindex["dcs_edit_items"], "search" ]);
        subtab3 = self.write_div(id="subtab3",classname="subtab",text="Units Of Measure", construct = [  3, siteindex["dcs_edit_items"], "unitsofmeasure" ])
        subtab4 = self.write_div(id="subtab4",classname="subtab",text="Scrap Codes", construct = [  4, siteindex["dcs_edit_items"], "scrapcodes" ])
        
        return """<tr><td colspan='%s'><table align="left"><tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr></table></td></tr>""" % (colspan,subtab1,subtab2,subtab3,subtab4)

    def writeLocalContent(self):
  
        self.writeln("""<table width="100%">""")
        self.writeln( self.subTabs(9) )
        self.writeln("""<tr>\n\t<td>""") 
        if self.message == "":
            self.writeln("""<table width="100%">""")
            self.writeln("""<form action='./index?_action_=edit&edit_type=item' method='post'>""")

            self.writeln( self.header )
            
            self.start_color()
            for item in ItemFactory().getItems():
                    bgcolor = self.next_color()
                    itemDepartment = item.department()
                    if itemDepartment:
                        itemDepartment = itemDepartment.serialNum()
                    
                    number = BOMFactory().getBOMsByMaterialSerialNum( item.serialNum() )
                    if number:
                        number = number[0].number()
                        fontcolor = "#ff0000"
                    else:
                        number = "N/A"
                        fontcolor = "#6699cc"
                        number = item.number()

                    self.writeln("""
                    <tr bgcolor='%s' style='color: %s;'>
                        <td class='list_data'>%s</td>
                        <td align='center' class='list_data'><input disabled type='text' name='Description%s' value=%s size=45></td>
                        <td align='center' class='list_data'><input disabled type='text' name='SalesPrice%s' value=$%.2f size=6></td>
                        <td align='center' class='list_data'><input disabled type='text' name='PurchasePrice%s' value=$%.2f size=6></td>
                        <td align='center' class='list_data'><select disabled name='Department%s'>\n\t<option value=''></option>""" % (bgcolor,fontcolor,number,item.serialNum(),self.quoted_escape(item.description()),item.serialNum(),float( self.quoted_escape( item.salesPrice(),"0.00" ) ),item.serialNum(),float( self.quoted_escape(item.purchasePrice(),"0.00" ) ),item.serialNum() ) )

                    for department in DepartmentFactory().getDepartments():
                        self.writeln( self.write_option(department.serialNum(),"%s %s" % (department.code(),department.description() ),( department.serialNum() == itemDepartment ) ) ) 
                        
                    self.writeln("""
                    </select></td>
                    <td class=list_data align=center><input type='checkbox' name='editItem%s' value=1 onClick='checkIfOpen(this,this.form.Description%s,this.form.SalesPrice%s,this.form.PurchasePrice%s,this.form.Department%s);'></td>
                    <td align=center><a href='./select_unit_of_measure?serialNum=%s'><img src='../images/button2.gif' border=0></a></td>
                    <td align=center><a href='./price_by_customer?serialNum=%s'><img src='../images/button4.gif' border=0></a></td>
                    <td align=center><a href='./bom?serialNum=%s'><img src='../images/button1.gif' border=0></a></td>
                    <td align=center><a href='./routing?serialNum=%s&referrentBOM=%s'><img src='../images/button2.gif' border=0></a></td>
                    <td align='center'><a href='./index?_action_=delete&delete_type=item&serialNum=%s'><img src='../images/button3.gif' border=0></a></td>
                    </tr>""" % (item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum() ) )


            self.writeln( self.header )
            
            self.writeln("""
            <tr>
                <td colspan=9 height='40px' align=center><A HREF="./new_item"><IMG SRC="../images/new.gif" onMouseDown="this.src='../images/newdown.gif';" onMouseOut="this.src='../images/new.gif';" style="border-style: none;"></A>&nbsp;<INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';" </td>
            </tr>
        </form>
        </table>
            """)

            self.writeln( self.writeJavascript() )
        else:
            self.writeln("""<tr align=center><td><font color='#ff0000'>%s</font></td></tr>""" % self.message)

        self.writeln("""\t</td>\n</tr>\n</table>""")
