# vim: ts=4 et sts=4 sw=4 autoindent
from index import index
from lib.SecureSitePage import SecureSitePage
from etc import siteindex

from sndcs.UnitOfMeasureFactory import UnitOfMeasureFactory
from sndcs.DepartmentFactory import DepartmentFactory

class new_item(index,SecureSitePage):
    
    def __init__(self):
        SecureSitePage.__init__(self, siteindex["dcs_edit_items"], 1)

    def writeJavascript(self):
        return """
        <script language='javascript' type='text/javascript'>
        <!--
        function validOnSubmit(myForm) {
                
                if ( myForm.Number.value == "" ) {
                    alert('Error: Please enter an Item number');
                    myForm.Number.focus();
                    return false;
                }

                if ( myForm.Description.value == "") {
                    alert('Error: Please enter an Item Description');
                    myForm.Description.focus()
                    return false;
                }
        };
    // -->
    </script>"""

    def localTitle(self):
        return "New Item"

    def writeLocalContent(self):

        self.writeln("""<table width="100%">""")
        self.writeln("""<tr>\n\t<td>""")

        self.writeln( self.subTabs() )
        
        self.writeln("""\n\t<td>\n</tr>\n<tr>\n\t<td>""")
        
        self.writeln("""<table align=center width="50%">""")
    
        self.writeln("""<form action='./index' method='post' onSubmit='return validOnSubmit(this);'>
        <tr class=table_header><th align=center colspan=4>Create New Item/BOM</th></tr>
        <tr><td class=body_desc>Item Number:&nbsp;</td><td class=body_desc align=left colspan=3><input type='text' name='Number' size=10></td></tr>
        <tr><td class=body_desc>Item Description:&nbsp;</td><td class=body_desc align=left colspan=3><input type='text' name='Description' size=25 maxlength=100></td></tr>

        <tr><td colspan=4 align=center><hr/></td></tr>

        <tr><td class=body_desc>Purchase Price:&nbsp;</td><td class=body_desc><input type='text' name='PurchasePrice' size=10 value="$0.00"></td><td class=body_desc>Sales Price:&nbsp;</td><td class=body_desc><input type='text' name='SalesPrice' size=10 value="$0.00"></td></tr>

        <tr><td class=body_desc>Unit Of Measure:&nbsp;</td>
        <td><select name=UnitOfMeasure>
        <option value=''></option>
         """)

         
        for unit in UnitOfMeasureFactory().getUnitOfMeasures():
                self.writeln( self.write_option(unit.serialNum(),("%s - %s" %  (unit.code(),unit.description())) ) )

        self.writeln("""\t</select>\n</td>\n\t<td class=body_desc>Department:&nbsp;</td>\n\t<td><select name='Department'>\n<option value=''></option>""")
        
        for department in DepartmentFactory().getDepartments():
                self.writeln( self.write_option(department.serialNum(),("%s - %s" %  (department.code(),department.description())) ) )

        self.writeln("""
        </select>
        </td>
        </tr>
        <tr><td colspan=4 align=center height='40px'><INPUT TYPE=image SRC='../images/submit1.gif' onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>
        <input type='hidden' name='new' value=1>
        <input type='hidden' name='edit_type' value='item'>
        <input type='hidden' name='_action_' value='edit'>
        </form>

        </table>
        
            </td>
        </tr>

        </table>""")

        self.writeln( self.writeJavascript() )
