# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from index import index
from etc import siteindex

from sndcs.ItemFactory import ItemFactory
from sndcs.DepartmentFactory import DepartmentFactory
from sndcs.UnitOfMeasureFactory import UnitOfMeasureFactory
from sndcs.RoutingFactory import RoutingFactory

class routing(index,SecureSitePage):
    def __init__(self):
        SecureSitePage.__init__(self,siteindex["dcs_edit_items"],1,False,( SecureSitePage.mainScripts ),clearSearchResults=False)

    def newTab(self):
        req=self.request()
        serialNum=req.field("serialNum",False)
        referrentBOM=req.field("referrentBOM",0)
        if serialNum:
            return ["New Routing","routing?new=1&serialNum=%s&referrentBOM=%s" % ( serialNum,referrentBOM ) ]
        else:
            return index.newTab(self)

    def writeJavascript(self,section="validOnSubmit"):
        
        if section=="validOnSubmit":
            
            return """
            <script language='javascript' type='text/javascript'>
            <!--
            function validOnSubmit(myForm) {

                    if ( (myForm.Number.value == "" ) || ( isInteger( myForm.Number.value ) == "false") ) {
                        alert('Error: Please enter an Routing Number');
                        myForm.Number.focus();
                        return false;
                    }

                    if ( myForm.Description.value == "") {
                        alert('Error: Please enter an Routing Description');
                        myForm.Description.focus();
                        return false;
                    }

                    if ( isPosFloat( myForm.ConversionUnit.value ) == false ) {
                        alert('Error: Please enter an valid Conversion Unit');
                        myForm.ConversionUnit.focus();
                        return false;
                    }
            };
            // -->
            </script>

            """
        else:
            return """
            <script language='javascript' type='text/javascript'>
            function checkIfOpen(MyCheckbox,Number,Description,Department,Unit,Conversion) {
                if (MyCheckbox.checked) {
                    if (Number) {
                        Number.disabled=false;
                    }
                    Description.disabled=false;
                    Department.disabled=false;
                    Unit.disabled=false;
                    Conversion.disabled=false;
                }
                else {
                    if (Number) {
                        Number.disabled=true;
                    }
                    Description.disabled=true;
                    Department.disabled=true;
                    Unit.disabled=true;
                    Conversion.disabled=true;
                }
            }
            </script>"""

    def backPage(self):
        req=self.request()
        serialNum=req.field("item_number",False)
        if not serialNum:
            serialNum=req.field("serialNum",False)
        if serialNum:
            return "dcs_edit_items/routing?serialNum=%s" % ( serialNum )
        else:
            return "dcs_edit_items"

    def localTitle(self):
        req=self.request()
        if req.hasField("new"):
            return "Create New Routing"
        else:
            return "Edit Routing"

    def writeLocalContent(self):
        req=self.request()
        serialNum=req.field("serialNum","")
        if self.isType(serialNum,int):
            referrentBOM = req.field("referrentBOM",serialNum)
        else:
            self.goToPage("dcs_edit_items")

        self.writeln("""<table width="100%">""")
        self.writeln( self.subTabs() )
        self.writeln("""<tr align="center">\n\t<td>""")

        if self.message=="":
            if req.hasField("new"):

                    self.writeln("""<table width="50%">""")
                    self.writeln("""<form action='./routing?_action_=edit&edit_type=routing&new=1' method='post' onSubmit='return validOnSubmit(this);'>
                    <tr class=table_header><th colspan=2>Create New Routing Item</th></tr>
                    <tr><td class=body_desc>&nbsp;Unit Of Measure&nbsp;</td>
                        <td><select name="UnitOfMeasure">
                        <option value=''></option>
                        """)
                    for unit in UnitOfMeasureFactory().getUnitOfMeasures():
                        self.writeln( self.write_option(unit.serialNum(),"%s %s" % (unit.code(),unit.description() ) ) )
                    
                    self.writeln("""
                        </select>
                        </td></tr>
                    <tr><td class=body_desc>&nbsp;Conversion Unit&nbsp;</td><td align=left><input type='text' name='ConversionUnit' size=5 value='1.0'></td></tr>
                    <tr><td colspan=2 align=center><hr></td></tr>
                    <tr><td class=body_desc>&nbsp;Number:&nbsp;</td><td align=left><input type='text' name='Number' size=10></td></tr>
                    <tr><td class=body_desc>&nbsp;Department:&nbsp;</td><td align=left>
                    <select name='Department'>
                    <option value=''></option>""")
                    
                    for department in DepartmentFactory().getDepartments():
                        self.writeln( self.write_option( department.serialNum(),"%s %s" % (department.code(),department.description() ) ) )
                    
                    self.writeln("""
                    </select>
                    </td></tr>
                    <tr><td class=body_desc>&nbsp;Description:&nbsp;</td><td><textarea name='Description' style='width: 400px;height: 125px;'></textarea></td></tr> 
                    <tr><td colspan=2 align=center height='40px'><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./routing?serialNum=%s&referrentBOM=%s"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>
                    <input type='hidden' name='referrentBOM' value='%s'>
                    <input type='hidden' name='serialNum' value='%s'>
                    </form>
                    </table>""" % ( serialNum,req.field("referrentBOM",0),req.field("referrentBOM",0),serialNum ) )
                    
                    self.writeln( self.writeJavascript("validOnSubmit") )

            else:  
                    
                    self.writeln("""<table width="100%">""")
                    self.writeln("""<form action='./routing?_action_=edit&edit_type=routing' method='post'>\n<tr class=table_header><th colspan=8>Routings</th></tr>""")

                    header = ("""<tr class=table_header><th WIDTH=10% align=left>&nbsp;Number&nbsp;</th><th align=left width=75%>Description</th><th width=10%>Department&nbsp;</th><th width=10%>Unit Of Measure&nbsp;</th><th></th><th width=15%>&nbsp;Conversion Unit&nbsp;</th><th WIDTH='30px'>Edit</th><th WIDTH='30px'>Delete</th></tr>
                    """)

                    self.writeln( header )

                    self.start_color()
                    for tmprouting in RoutingFactory().getRoutingsByBOMSerialNum( int( serialNum ) ):
                            bgcolor=self.next_color()
                            self.writeln("""
                            <tr bgcolor='%s'>
                                <td class=list_data><input disabled type='text' name='Number%s' value='%s' size=3></td>
                                <td class=list_data align=left><input disabled type='text' name='Description%s' value='%s' size=70></td>
                                <td class=list_data>\n<select disabled name='Department%s'>\n<option value='0'></option>""" % (bgcolor,tmprouting.serialNum(),tmprouting.number(),tmprouting.serialNum(),tmprouting.description(),tmprouting.serialNum() ) )

                            if tmprouting.department(): department = tmprouting.department().serialNum()
                            else: department = 0
 
                            for x in DepartmentFactory().getActiveDepartments():
                                  self.writeln( self.write_option( x.serialNum(), "%s - %s" % ( x.code(), x.description() ), x.serialNum() == department ) )
                            
                            self.writeln("""<td class=list_data align=center><select name='UnitOfMeasure%s' disabled>
                                <option value='0'></option>
                            """ % (tmprouting.serialNum() ) )

                            if tmprouting.unitOfMeasure():
                                tmpUnit = tmprouting.unitOfMeasure().serialNum()
                            else: tmpUnit = 0
                            
                            for unit in UnitOfMeasureFactory().getUnitOfMeasures():
                                    self.writeln( self.write_option(unit.serialNum(),("%s - %s" % (unit.code(),unit.description())), tmpUnit == unit.serialNum() ) )

                            item = ItemFactory().getItemBySerialNum(int(serialNum))
                            if item.unitOfMeasure():
                                itemUnit = item.unitOfMeasure().description()
                            else: itemUnit = ""

                            self.writeln("""
                                </select></td>
                                <td class=list_data align=center>&nbsp;=&nbsp;</td><td class=list_data align=center><input disabled type='text' name='ConversionUnit%s' size=5 value=%s>&nbsp;%s</td>
                                <td align=center><input type='checkbox' name='editRouting%s' value=1 onClick='checkIfOpen(this,this.form.Number%s,this.form.Description%s,this.form.Department%s,this.form.UnitOfMeasure%s,this.form.ConversionUnit%s);'></td><td align=center><a href='./routing?_action_=delete&delete_type=routing&item_number=%s&serialNum=%s'><img src='../images/button3.gif' border=0></a></td>
                            </tr>""" % ( tmprouting.serialNum(),self.quoted_escape(tmprouting.conversionUnit()),self.escape(itemUnit),tmprouting.serialNum(), tmprouting.serialNum(),tmprouting.serialNum(),tmprouting.serialNum(),tmprouting.serialNum(), tmprouting.serialNum(),serialNum,tmprouting.serialNum() ) )

                    
                    self.writeln("""
                    <input type='hidden' name='serialNum' value='%s'>
                    <tr>
                        <td colspan=7 align=center height='40px'><A HREF="./routing?serialNum=%s&new=1&referrentBOM=%s"><IMG SRC="../images/new.gif" onMouseDown="this.src='../images/newdown.gif';" onMouseOut="this.src='../images/new.gif';" style="border-style: none;"></A>&nbsp;<INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';" >&nbsp;<A HREF="./bom?serialNum=%s"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td>
                    </tr>
                    </form>
                    </table>""" % (serialNum,serialNum,referrentBOM,referrentBOM) )
                
            
                    self.writeln( self.writeJavascript("editValidation") )

        else:
            self.writeln("""<font color='#ff0000'>%s</font>""" % self.message )

        self.writeln("""\t</td>\n</tr>\n</table>""")
