# vim: ts=4 et sts=4 sw=4 autoindent

from index import index
from lib.SecureSitePage import SecureSitePage
from sndcs.ItemFactory import ItemFactory
from sndcs.DepartmentFactory import DepartmentFactory
from sndcs.UnitOfMeasureFactory import UnitOfMeasureFactory
from etc import siteindex

class search(index,SecureSitePage):

        def __init__(self):
                SecureSitePage.__init__(self,siteindex["dcs_edit_items"],2)

        def actions(self):
                return index.actions(self) + [ "search" ]
    
        def localTitle(self):
                return "Search Items"

        def backPage(self):
                return self.session().value("backPage","dcs_edit_items/search")
        
        def newTab(self):
                return [ "New Search", "search" ]

        def search(self):
                req = self.request()
                deleteValues = [ "x","y","_action_", "clauseString" ]
                clauseString = req.field("clauseString","")

                if req.field("unitOfMeasure",""):
                    deleteValues.append("unitOfMeasure")
                    if not req.field("unitOfMeasure") == "0":
                        clauseString=" unitOfMeasureObjId=%s AND" % req.field("unitOfMeasure")

                searchfields = { "purchasePrice": 0.00,"salesPrice": 0.00,"description": "" }
                for key,value in dict(req.fields()).items():
                    if not key in deleteValues:
                        if key.count("Price") and self.isType(str(value).replace("$",""),float):
                            searchfields[key] = self.returnType(str(value).replace("$",""),float,0)
                        elif value: searchfields[key] = value

                if clauseString == "":
                    for key, value in searchfields.items():
                        if key.count("Price") and self.isType(str(value).replace("$",""),float):
                            clauseString +=" %s='%s' AND" % (key,self.escape(self.returnType(str(value),float,0.00)))
                        elif not key.count("Price") and value: clauseString+=" %s LIKE '%%%s%%' AND" % (key,self.escape(value)) 

                if clauseString:
                    tmpsearch = ItemFactory().searchItems("WHERE %s" % clauseString[:-4])
                else:
                    tmpsearch = None
                
                self.message += ( self.writeJavascript() )
                                
                self.message += ("""<table align="center">""") 
                self.message += ("""<form action='./search?_action_=edit&edit_type=item' method='post'>\n<tr><th colspan=11 height='50px' align=right class=refresh><a href='./search.py'>New Search</a></th></tr>\n<tr class=table_header><th align=center colspan=11>Search Results</th></tr>""")

                self.message += ( self.header )
    
                if not tmpsearch:
                    self.message += ("""<tr><td colspan=11 align=center><b>No Search Results!</b></td></tr>""")
                else:
                    self.start_color()
                    for item in tmpsearch:
                          bgcolor = self.next_color()
                    
                          itemDepartment = item.department()
                          if itemDepartment:
                              itemDepartment = itemDepartment.serialNum()
                              
                          self.message += ("""
                <tr bgcolor='%s'><td class='list_data'>%s</td>
                <td align='center' class='list_data'><input disabled type='text' name='Description%s' value='%s' size=50 maxlength=100></td>
                <td align='center' class='list_data'><input disabled type='text' name='SalesPrice%s' value='$%.2f' size=6></td>
                <td align='center' class='list_data'><input disabled type='text' name='PurchasePrice%s' value='$%.2f' size=6></td>
                <td align='center' class='list_data'><select disabled name='Department%s'>\n\t<option value=''></option>""" % (bgcolor,item.number(),item.serialNum(),item.description(),item.serialNum(),self.returnType(item.salesPrice(),float,0.00),item.serialNum(),self.returnType(item.purchasePrice(),float,0.00) ,item.serialNum() ) )

                          for department in DepartmentFactory().getDepartments():
                              self.message += ( self.write_option(department.serialNum(),"%s %s" % (department.code(),department.description() ),( department.serialNum() == itemDepartment ) ) ) 
                        
                          self.message += ("""\t</select>\n\t</td>
                <td class=list_data align=center><input type='checkbox' name='editItem%s' value=1 onClick='checkIfOpen(this,this.form.Description%s,this.form.SalesPrice%s,this.form.PurchasePrice%s,this.form.Department%s);'></td>
                <td align='center'><a href='./select_unit_of_measure?serialNum=%s'><img src='../images/button2.gif' border=0></a></td>
                <td align='center'><a href='./price_by_customer?serialNum=%s'><img src='../images/button4.gif' border=0></a></td>
                <td align='center'><a href='./bom?_action_=assemblydialog&serialNum=%s'><img src='../images/button1.gif' border=0></a></td>
                <td align='center'><a href='./routing?serialNum=%s'><img src='../images/button2.gif' border=0></a></td>
                <td align='center'><a href='./index?_action_=delete&delete_type=item&serialNum=%s'><img src='../images/button3.gif' border=0></a></td></tr>""" % (item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(),item.serialNum(), item.serialNum() ) ) 

                    self.message += ( self.header )
                
                    self.message += ("""<tr>\n\t<td colspan=9 height='40px' align=center><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';" ></td>\n</tr>""")
                
                self.message += ("""</table>\n</form>""")

                self.writeBody()
                self.session().setValue("backPage","dcs_edit_items/search?_action_=search&x=&y=&clauseString=%s" % self.convertToHexString(clauseString) )
                self.setSearchResultsPage()
                

        def writeLocalContent(self):
        
                self.writeln("""<table width="100%">""")

                self.writeln( self.subTabs() )
        
                self.writeln("""<tr>\n\t<td>""")

                if self.message == "":
                        self.writeln("""<table align="center" width="25%">""")
                        self.writeln("""
                        <form action='./search' method='post'>
                        <tr class=table_header><th colspan=4>Search Items</th></tr>
                        <tr>
                            <td class=body_desc>Sales Price:&nbsp;</td><td><input type='text' name='salesPrice' size=5 value='$0.00'></td>
                        </tr>
                            <tr><td class=body_desc>Purchase Price:&nbsp;</td><td><input type='text' name='purchasePrice' size=5 value='$0.00'></td></tr>
                        <tr>
                            <td class=body_desc>Description:&nbsp;</td><td colspan=3><input type='text' name='description'></td>
                        </tr>
                            <input type='hidden' name='_action_' value='search'>
                        <tr>
                            <td class=body_desc>Unit Of Measure:&nbsp;</td><td colspan=3><select name='unitOfMeasure'>
                            <option value='0'></option>""")
                        
                        for unit in UnitOfMeasureFactory().getUnitOfMeasures():
                            self.writeln( self.write_option( unit.serialNum(),"%s %s" % (unit.code(),unit.description())  ) )
                        
                        self.writeln("""
                            </select>
                            </td>
                        </tr>
                        <tr>
                            <td colspan=4 height=50px align=center> <INPUT TYPE=image SRC="../images/search1.gif" onMouseDown="this.src='../images/search1down.gif';" onMouseOut="this.src='../images/search1.gif';" >&nbsp;<A HREF="./index"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>

                        </form>
                        </table>""")
                else:
                        self.writeln( self.message )

                self.writeln("""\n\t</td>\n</tr>\n</table>""")

