# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from index import index
from etc import siteindex
from sndcs.UnitOfMeasureFactory import UnitOfMeasureFactory
from sndcs.ItemFactory import ItemFactory

class select_unit_of_measure(index,SecureSitePage):
  
    def __init__(self):
        SecureSitePage.__init__(self,siteindex["dcs_edit_items"],1,False,( SecureSitePage.mainScripts ),clearSearchResults=False)

    def localTitle(self):
        return "Select Unit Of Measure"

    def backPage(self):
        if self.session().value("backPage","").count("search"):
            return self.session().value("backPage")
        else:
            return "dcs_edit_items"

    def writeLocalContent(self):
        req = self.request()
        serialNum = self.returnType(req.field("serialNum",""),int,None)
        
        if not serialNum:
            self.goToPage("dcs_edit_items")
        
        self.writeln("""<table width="100%">""")
        self.writeln( self.subTabs() )
        
        self.writeln("""<tr>\n\t<td>""")
        self.writeln("""<table align=center width="50%">""")
    
        self.writeln("""<form action='./select_unit_of_measure' method='post' onSubmit='return validOnSubmit(this);'>
        <tr class=table_header><th align=center colspan=2>Select Unit Of Measure</th></tr>
        <tr><td class=body_desc align=left>Unit Of Measure:&nbsp;
        <select name=UnitOfMeasure>
        <option value=''></option>
         """)

        item = ItemFactory().getItemBySerialNum(serialNum)
        if item.unitOfMeasure():
            itemUnit = item.unitOfMeasure().serialNum()
        else: itemUnit = 0
        
        for unit in UnitOfMeasureFactory().getUnitOfMeasures():
            self.writeln( self.write_option(unit.serialNum(),("%s - %s" % (unit.code(),unit.description())) , itemUnit == unit.serialNum() ) )

        self.writeln("""
        </select>
        
        <tr><td colspan=4 align=center height='40px'><INPUT TYPE=image SRC='../images/submit1.gif' onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>
        <input type='hidden' name='serialNum' value='%s'>
        <input type='hidden' name='edit_type' value='unitOfMeasure'>
        <input type='hidden' name='_action_' value='edit'>
        </form>

        </table>
        
            </td>
        </tr>

        </table>""" % serialNum)
