# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from etc import siteindex
from index import index

from sndcs.UserFactory import UserFactory
from sndcs.UnitOfMeasureFactory import UnitOfMeasureFactory
from sndcs.UnitOfMeasure import UnitOfMeasure
from sndcs.Store import store

class unitsofmeasure(index,SecureSitePage):

        def __init__(self):
                SecureSitePage.__init__(self,siteindex["dcs_edit_items"],3)

        def writeJavascript(self):
                return """<script language='javascript' type='text/javascript'>
                <!--
                function validOnSubmit(myForm) {
                    if ( myForm.Code.value == "" ) {
                        alert('Error: Enter a valid code.');
                        myForm.Code.focus();
                        return false;
                    }
                    
                    if ( myForm.Description.value == "" ) {
                        alert('Error: Enter a valid description.');
                        myForm.Description.focus();
                        return false;
                    }

                }
                //-->
                </script>"""


        def actions(self):
                return SecureSitePage.actions(self) + [ "edit", "delete", ]

        def newTab(self):
                return [ "New Unit Of Measure", "edit_unitsofmeasure" ]
        
        def edit(self):
                req = self.request()
                serialNum = self.returnType(req.field("serialNum",""),int,None)

                if serialNum:
                    tmpedit = UnitOfMeasureFactory().getUnitOfMeasureBySerialNum(serialNum)
                    self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_items" ) ) 
                else:
                    self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "create_items" ) ) 
                    tmpedit=UnitOfMeasureFactory().new()
                
                if store.fetchObjectsOfClass(UnitOfMeasure,clauses="WHERE code='%s' AND serialNum<>%s" % (req.field("Code"),tmpedit.serialNum() ) ):
                        self.message = '<b>Error:</b> An Unit Of Measure already has that code.'
                        self.message = """<table><tr align='center' width="100%%"><td><font color='#ff0000'>%s</font></td></tr></table>""" % self.message
                        self.writeBody()
                        return
                else:
                        code = req.field("Code",0)
                        description = req.field("Description","No Description") 
                        
                        if code and description:
                            tmpedit.setCode(code)
                            tmpedit.setDescription(description)

                        store.addObject(tmpedit)
                        store.saveChanges()
                self.goToPage("dcs_edit_items/unitsofmeasure")

        def delete(self):
                req = self.request()
                serialNum = self.returnType(req.field("serialNum",""),int,0)

                self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "delete_items" ) ) 
                if serialNum:
                    tmpdelete = UnitOfMeasureFactory().getUnitOfMeasureBySerialNum(serialNum)
                    if tmpdelete.referencingObjectsAndAttrs():
                        store.deleteObject(tmpdelete)
                    else:
                        self.message = ("""<b>Error:</b> Cannot delete a Unit Of Measure that is referenced by a Item/JobHed/Routing/Operation""")
                        self.message = """<table><tr align='center' width="100%%"><td><font color='#ff0000'>%s</font></td></tr></table>""" % self.message
                        self.writeBody()
                        return

                    store.saveChanges()

                self.goToPage("dcs_edit_items/unitsofmeasure")

        def localTitle(self):
                return "Unit Of Measure's"

        def writeLocalContent(self):

                self.writeln("""<table width="100%">""")

                self.writeln( self.subTabs() )
                self.writeln("""<tr align='center'>\n\t<td>""")
                
                if self.message:

                    self.writeln( self.message )

                else:
                    self.writeln("""<table width="100%">""")
                    self.writeln("""<form action='./unitofmeasure?_action_=edit' method='post'>
                    <tr class=table_header><th width=10% align=left>&nbsp;Code</th><th align=left>Description</th><th WIDTH='30px'>Edit&nbsp;</th><th WIDTH='30px'>&nbsp;Delete</th></tr>""")

                    self.start_color()
                    for unit in UnitOfMeasureFactory().getUnitOfMeasures():
                            bgcolor=self.next_color()
                            self.writeln("""<tr class=list_data bgcolor='%s'><td align="left">&nbsp;%s</td><td align=left>%s</td><td align=center><a href="./edit_unitsofmeasure.py?serialNum=%s"><img border=0 src='../images/button4.gif'></a></td><td align=center><a href="./unitsofmeasure.py?_action_=delete&serialNum=%s"><img border=0 src='../images/button3.gif'></a></td></tr>""" % ( bgcolor, unit.code(),self.escape( unit.description() ),unit.serialNum(),unit.serialNum() ) )

                    self.writeln("""<tr class=table_header><th width=10% align=left>&nbsp;Code</th><th align=left>Description</th><th WIDTH='30px'>Edit&nbsp;</th><th WIDTH='30px'>&nbsp;Delete</th></tr>
                
                 <tr>
                        <td height='40px' colspan=5 align=center><A HREF="./edit_unitsofmeasure.py"><IMG SRC="../images/new.gif" onMouseDown="this.src='../images/newdown.gif';" onMouseOut="this.src='../images/new.gif';" style="border-style: none;"></A>
                     </td>
                    </tr>
                    </table>
                    """)

                self.writeln("""\t</td>\n</tr>\n</table>""")
