# vim: ts=4 et sts=4 sw=4 autoindent

from index import index
from etc import siteindex
from lib.SecureSitePage import SecureSitePage

from sndcs.UserFactory import UserFactory
from sndcs.AssemblyFactory import AssemblyFactory
from sndcs.OperationFactory import OperationFactory
from sndcs.JobHedFactory import JobHedFactory
from sndcs.ItemFactory import ItemFactory

from sndcs.Store import store

class assembly(index,SecureSitePage):

    def __init__(self):
        index.__init__(self)
        SecureSitePage.__init__(self,siteindex["dcs_edit_jobs"], 1,clearSearchResults = False)

    def newTab(self):
        req=self.request()
        serialNum=req.field("serialNum",False)
        if serialNum:
            return ["New Assembly","assembly?new=1&serialNum=%s" % serialNum]
        else:
            return index.newTab(self)

    def backPage(self):
            req=self.request()
            serialNum=req.field("job_number",False)
            if not serialNum:
                serialNum=req.field("serialNum",False)
            if serialNum:
                return "dcs_edit_jobs/assembly?serialNum=%s" % serialNum
            else: return "dcs_edit_jobs"
   
    def localTitle(self):
        req=self.request()
        if req.hasField("new"):
            return "Create New Assembly"
        else:
            return "Edit Assemblies"

   
    def writeLocalContent(self):
        req = self.request()
        serialNum = self.returnType(req.field("serialNum",""),int,None)
        
        if not serialNum:
            self.goToPage("dcs_edit_jobs")

        self.writeln("""<table width="100%">""")
        self.writeln( self.subTabs() )
        self.writeln("""<tr align="center">\n\t<td>""")

        if self.message == "":
            if req.hasField("new"):
                        self.writeln( self.writeJavascript("assembly") )
                        if not self.admin_global.newAssemblies():
                            self.writeln("""<tr><td align="center"><font color="#ff0000"><b>Error:</b> Creation of New Assemblies is disallowed</font></td></tr>""")
                        else:
                            self.writeln("""<table width="50%">""")
                            self.writeln( self.writeJavascript( "assemblyItem" ) )
                            self.writeln( self.writeJavascript( "assembly" ) )

                            self.writeln("""<form action='./assembly?_action_=edit&new=1&edit_section=assembly' method='post' onSubmit='return validOnSubmit(this);'>
                            <tr class=table_header><th align=center colspan=2>Create New Assembly</th></tr>
                            <tr><td class=body_desc>&nbsp;BOM Item:&nbsp;</td><td align=left><select name='BOMItem' onChange='assemblyItem(this.form)'>
                            <option value=''></option>""")
                            
                            for item in ItemFactory().getItems():
                                    self.writeln( self.write_option(item.serialNum(),"%s %s" % (item.number(),item.description() ) ) )
                            
                            self.writeln("""
                            </select></td>
                            </tr>
                            <tr>
                                <td class=body_desc>&nbsp;Number:&nbsp;</td>
                                <td align=left><input type='text' name='Number' size=10></td>
                            </tr>
                            <tr>
                                <td class=body_desc>&nbsp;Price:&nbsp;</td>
                                <td align=left><input type='text' name='ItemPrice' size=5 value='$0.00'></td>
                            </tr>
                            <tr>
                                <td class=body_desc>&nbsp;Description:&nbsp;</td>
                                <td><textarea name='Description' style='width: 400px;height: 125px;'></textarea></td>
                            </tr>
                            
                            <tr height='40px'><td colspan=2 align=center><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./assembly?serialNum=%s"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>
                            <input type='hidden' name='serialNum' value='%s'>
                            </form>
                            </table>""" % (serialNum, serialNum) )
                            
            else:     
                        self.writeln("""<table width="100%">""")
                        self.writeln("""<form action='./assembly?_action_=edit&edit_section=assembly'  method='post'>\n<tr class=table_header><th colspan=6>Assemblies</th></tr>""")

                        header = ("""<tr class=table_header><th align=left width='10%%'>&nbsp;Number</th><th width='75%%' align=left>Description</th><th align=left>&nbsp;Price&nbsp;</th><th width='30px'>&nbsp;Edit&nbsp;</th><th width='30px'>&nbsp;Ops.</th><th width='30px'>&nbsp;Delete</th></tr>""")
                        self.writeln( header )

                        self.start_color()
                        for tmpassembly in AssemblyFactory().getAssembliesByJobHedBySerialNum( int( serialNum ) ):
                            bgcolor = self.next_color()
                                
                            self.writeln("""
                            <tr bgcolor='%s'>
                                <td class=list_data align=left>&nbsp;<input disabled type='text' name='Number%s' size=3 value=%s></td><td class=list_data align=left><input disabled type='text' name='Description%s' value=%s size=110></td><td class=list_data align=left><input disabled type='text' name='ItemPrice%s' size=5 value='$%.2f'></td>""" % (bgcolor, tmpassembly.serialNum(),tmpassembly.number(),tmpassembly.serialNum(),self.quoted_escape(tmpassembly.description()),tmpassembly.serialNum(),float( self.quoted_escape(tmpassembly.itemPrice(),"0.00") ) ) ) 
                            self.writeln("""
                                <td align=center><input type='checkbox' name='editAssembly%s' value=1 onClick='checkIfOpen(this,this.form.Number%s,this.form.Description%s,this.form.ItemPrice%s);'></td><td align=center><a href='./operation?serialNum=%s&assembly=%s'><img src='../images/button1.gif' border=0></td><td align=center><a href='./assembly?_action_=delete&delete_type=assembly&serialNum=%s&job_number=%s'><img src='../images/button3.gif' border=0></a></td>
                            </tr>""" % (tmpassembly.serialNum(), tmpassembly.serialNum(), tmpassembly.serialNum(), tmpassembly.serialNum(), tmpassembly.serialNum(), serialNum, tmpassembly.serialNum(), serialNum ) )

                        
                        self.writeln("""
                        <input type='hidden' name='serialNum' value='%s'>
                        <tr><td height='40px' colspan=5 align=center><A HREF="./assembly?serialNum=%s&new=1"><IMG SRC="../images/new.gif" onMouseDown="this.src='../images/newdown.gif';" onMouseOut="this.src='../images/new.gif';" style="border-style: none;"></A>&nbsp;<INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';" >&nbsp;<A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>
                        </form>
                        </table>""" % (serialNum,serialNum) )

                        self.writeln( self.writeJavascript("hideUnhide") )
        else:
                self.writeln( "<font color='#ff0000'>",self.message,"</font>")

        self.writeln("""\t</td>\n<tr>""")
        self.writeln("""</table>""")
