# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from sndcs.AdminGlobalFactory import AdminGlobalFactory
from sndcs.LastUsedFactory import LastUsedFactory

from etc import siteindex
from sndcs.UserFactory import UserFactory
from sndcs.AssemblyFactory import AssemblyFactory
from sndcs.OperationFactory import OperationFactory
from sndcs.JobHed import JobHed
from sndcs.JobHedFactory import JobHedFactory
from sndcs.NoteByJobHedFactory import NoteByJobHedFactory

from sndcs.DepartmentFactory import DepartmentFactory
from sndcs.CustomerFactory import CustomerFactory
from sndcs.ItemFactory import ItemFactory
from sndcs.ItemPriceByCustomerFactory import ItemPriceByCustomerFactory
from sndcs.Operation import Operation
from sndcs.UnitOfMeasureFactory import UnitOfMeasureFactory

from sndcs.Assembly import Assembly
from sndcs.Store import store

import datetime

class index(SecureSitePage):
    def __init__(self):
        SecureSitePage.__init__(self,siteindex["dcs_edit_jobs"],1,False, self.mainScripts + [ "../js/jscalendar/calendar.js", "../js/jscalendar/calendar-en.js", "../js/jscalendar/calendar-setup.js"])
        self.admin_global = AdminGlobalFactory().adminGlobal()

    def actions(self):
        return SecureSitePage.actions(self) + [ "delete", "edit" ]

    def newTab(self):
        return ["New Job","new_job"]

    def edit(self):
        req = self.request()
        deleteValues = [ "x", "y", "_action_","edit_section","Notes" ]

        edit_flag = UserFactory().checkPriv(self.session().value("userLoggedOn"),"edit_jobs")
        create_flag = UserFactory().checkPriv(self.session().value("userLoggedOn"),"create_jobs")

        serialNum = self.returnType(req.field("serialNum",""),int,None)
        edit_section = req.field("edit_section",False)
        
        if not edit_section: 
            self.goToPage("dcs_edit_jobs")

        if edit_section == "assembly":
                            if req.hasField("new"):
                                    if not create_flag:
                                            self.goToPage("dcs_login/priv_error")
                                            return

                                    if not self.admin_global.newAssemblies():
                                            self.message = """<b>Error:</b> Creation of New Assemblies is disallowed"""
                                            self.writeBody()
                                            return
                                    else:
                                            bomItem = self.returnType(req.field("BOMItem",""),int,None)
                                            if bomItem:
                                                tmpitem = ItemFactory().getItemBySerialNum( bomItem )
                                                tmpedit = JobHedFactory().getJobHedBySerialNum( int( serialNum ) )

                                                description = tmpitem.description()   
                                                tmpassembly = AssemblyFactory().new()

                                                number = 10
                                                while store.fetchObjectsOfClass(Assembly,clauses="WHERE jobHedObjId='%s' AND number='%s'" % (tmpedit.serialNum(),number) ):
                                                    number += 10 #Add 10 till free assembly number is found...
                                                
                                                tmpassembly.setNumber( str(number) )
                                                tmpassembly.setDescription( description )
                                                tmpassembly.setJobHed( tmpedit )


                                                itemprice = tmpitem.salesPrice()
                                                if tmpedit.customer():
                                                    pricecheck = ItemPriceByCustomerFactory().getItemPriceByCustomerAndItemSerialNum( tmpitem.serialNum(), tmpedit.customer().serialNum() )
                                                    if pricecheck:
                                                        itemprice=pricecheck[0].price()

                                                tmpassembly.setItemPrice( itemprice )
                                                if not len(tmpitem.routing()):
                                                    OperationFactory().new(assembly = tmpassembly, number = "0", description = tmpassembly.description(), department = tmpitem.department() )

                                                store.addObject(tmpassembly)
                                                store.saveChanges()
                                                
                                                for tmproute in tmpitem.routing():
                                                    tmpoperation = OperationFactory().new(tmpassembly, tmproute.number(), tmproute.description(),department = tmproute.department())

                                                alreadyAddedBom = []
                                                for tmpBOM in tmpitem.bom(): 
                                                    number += self.unpackBOMS(tmpBOM,tmpedit,number,alreadyAddedBom)
                                                    alreadyAddedBom.append(tmpBOM.material().serialNum())
                                                
                                                self.goToPage(self.backPage())
                                            
                                            else:
                                                if store.fetchObjectsOfClass(Assembly,clauses = """WHERE jobHedObjId='%s' AND number='%s'""" % ( serialNum, req.field("Number","") ) ):
                                                    self.message = """<b>Error:</b> An Assembly already exists with the same number"""
                                                    self.writeBody()
                                                    return
                                                        
                                                tmpassembly = AssemblyFactory().new()
                                                tmpassembly.setNumber( req.field("Number","") )
                                                tmpassembly.setDescription( req.field("Description","No Description") )

                                                itemPrice = self.returnType(str(req.field("ItemPrice","")).replace("$",""), float, 0.00)
                                                tmpassembly.setItemPrice( itemPrice )

                                                tmpassembly.setJobHed( JobHedFactory().getJobHedBySerialNum( int( serialNum ) ) )

                                                store.addObject(tmpassembly)

                                                OperationFactory().new(tmpassembly, "0", description = req.field("Description","No Description"), conversion_unit = 1.0) # Create default Operation
                                                store.saveChanges()

                                                self.goToPage(self.backPage())
                            else:
                                    # MULTI-ENTRY BELOW
                                    if not edit_flag:
                                        self.goToPage("dcs_login/priv_error")

                                    for eachKey,eachNull in dict(req.fields()).items(): # Check to make sure there are no duplicate assembly numbers
                                            if eachKey.count("editAssembly") and not eachKey in deleteValues:
                                                    serialNum=int( eachKey.replace("editAssembly","") )
                                                    valueToCompare = self.returnType(req.field('Number%s' % serialNum,"" ),int,None )
                                                    lastkey = eachKey
                                                    for eachKey,eachNull in dict(req.fields()).items():
                                                        if not eachKey == lastkey and eachKey.count("editAssembly"):
                                                            serialNum = int( eachKey.replace("editAssembly","") )
                                                            value = req.field('Number%s' % serialNum,"" )
                                                            if value == valueToCompare:
                                                                self.goToPage(self.backPage())


                                    for eachKey,eachNull in dict(req.fields()).items():
                                            if eachKey.count("editAssembly"):
                                                    serialNum = self.returnType( eachKey.replace("editAssembly",""), int, None )
                                                    tmpassembly = AssemblyFactory().getAssemblyBySerialNum( serialNum )
                                                    number = self.returnType(req.field("Number%s" % serialNum,""),int,None)
            
                                                    if not store.fetchObjectsOfClass(Assembly,clauses = """WHERE number='%s' AND serialNum<>'%s'""" % (number,serialNum) ):
                                                        if number and ( (not int(tmpassembly.number()) == 0 and not number == 0) or len(tmpassembly.jobHed().assemblies()) > 1 ):
                                                            tmpassembly.setNumber(str(number))
                                                    
                                                    description = req.field("Description%s" % serialNum,"")
                                                    if description == "":
                                                        description = "No Description"
                                                    tmpassembly.setDescription(description)

                                                    if not tmpassembly.jobHed().isClosed(): # Completed Job
                                                        self.updateOperations(tmpassembly)
                                                    
                                                    itemprice = self.returnType(req.field("ItemPrice%s" % serialNum,"").replace("$",""),float,0.00)
                                                    tmpassembly.setItemPrice(itemprice)

                                                    store.saveChanges()

                                    self.goToPage(self.backPage())
        elif edit_section == "operation":
                            if req.hasField("new"):
                                    if not create_flag:
                                            self.goToPage("dcs_login/priv_error")

                                    if not self.admin_global.newOperations():
                                            self.message = """<b>Error:</b> Creation of New Operations is disallowed"""
                                            self.writeBody()
                                            return
                                    
                                    if store.fetchObjectsOfClass(Operation,clauses = """WHERE assemblyObjId='%s' AND number='%s'""" % (serialNum, req.field("Number") ) ):
                                            self.message="""<b>Error:</b> An Operation already exists with the same number"""
                                            self.writeBody()
                                            return
                                            
                                    number = req.field("Number","")
                                    description = req.field("Description","No Description")

                                    conversion_unit = self.returnType(req.field( "ConversionUnit", ""),float,1.0)

                                    unitOfMeasure = self.returnType(req.field("UnitOfMeasure",""),int,None)
                                    if unitOfMeasure:
                                        unitOfMeasure = UnitOfMeasureFactory().getUnitOfMeasureBySerialNum( int(unitOfMeasure) )

                                    department = self.returnType(req.field("Department",""),int,None)
                                    if department:
                                        department = DepartmentFactory().getDepartmentBySerialNum( department )
                                    
                                    assembly = AssemblyFactory().getAssemblyBySerialNum( int( serialNum ) )
                                    OperationFactory().new(assembly, number, description, unitOfMeasure, conversion_unit, department=department)

                                    self.goToPage(self.backPage())
                            else:
                                    # MULTI-ENTRY BELOW
                                    if not edit_flag:
                                            self.goToPage("dcs_login/priv_error")

                                    for eachKey,eachNull in dict(req.fields()).items():
                                            if eachKey.count("editOperation"):
                                                    serialNum = int( eachKey.replace("editOperation","") )
                                                    valueToCompare = self.returnType(req.field('Number%s' % serialNum,""),int,None)
                                                    lastkey = eachKey
                                                    for eachKey,eachNull in dict(req.fields()).items():
                                                        if not eachKey == lastkey and eachKey.count("editOperation"):
                                                            serialNum = int( eachKey.replace("editOperation","") )
                                                            value = self.returnType(req.field('Number%s' % serialNum,""),int,None)
                                                            if value == valueToCompare: # Check to make sure there are no duplicate operation numbers
                                                                    self.goToPage(self.backPage())

                                    for eachKey,eachNull in dict(req.fields()).items():
                                            if eachKey.count("editOperation"):
                                                    serialNum = int( eachKey.replace("editOperation","") )

                                                    tmpoperation = OperationFactory().getOperationBySerialNum( serialNum )
                                                    if not tmpoperation.assembly().jobHed().isClosed():
                                                        tmpoperation.delete() # PYRO Event to remove from clients

                                                    description = req.field("Description%s" % serialNum,"")
                                                    if description == "":
                                                        description="No Description"
                                                    
                                                    number = self.returnType(req.field("Number%s" % serialNum,""),int,None)
                                                    department = self.returnType(req.field("Department%s"% serialNum,""),int,None)
                                                    if department:
                                                        department = DepartmentFactory().getDepartmentBySerialNum( int(department) ) 
                                                    tmpoperation.setDepartment(department)

                                                    if number and  not store.fetchObjectsOfClass(Operation,clauses="WHERE number='%s' AND serialNum<>'%s'" % (number,serialNum) ):
                                                        if not ( int(tmpoperation.number()) == 0 and not number and tmpoperation.assembly().number == 0 ):
                                                            tmpoperation.setNumber(str(number))
                                                            
                                                    tmpoperation.setDescription(description)
                                                    conversion_unit = self.returnType(req.field("ConversionUnit%s" % serialNum,""),float,1.0)
                                                    tmpoperation.setConversionUnit(float(conversion_unit))
                                                    unit_of_measure = self.returnType(req.field("UnitOfMeasure%s" % serialNum,""),int,None)
                                                    if unit_of_measure:
                                                        unit_of_measure = UnitOfMeasureFactory().getUnitOfMeasureBySerialNum( unit_of_measure )
                                                    tmpoperation.setUnitOfMeasure(unit_of_measure)
                                                    complete = bool( req.hasField("Complete%s" % serialNum) or tmpoperation.assembly().jobHed().isClosed() ) # Operation is completed if JobHed is closed/completed...

                                                    if complete and not tmpoperation.complete():
                                                        tmpoperation.setCompleteStamp( datetime.datetime.today() ) #The Operation was deleted above....
                                                        store.saveChanges()                                    
                                                    elif not complete and not tmpoperation.assembly().jobHed().isClosed():
                                                        tmpoperation.add() #Add PYRO Event

                                                    tmpoperation.setComplete(complete)
                                                    store.saveChanges()
                                    self.goToPage("dcs_edit_jobs/operation?serialNum=%s"  % req.field("serialNum") )  
        else:
                if req.hasField("new"):
                        if not create_flag:
                                self.goToPage("dcs_login/priv_error")

                        number = self.returnType(req.field("Number",""),int,None)
                        deleteValues += [ "new","CustomerNumber","ItemNumber","Priority","QtyRequired", "Number", "CustomItemDescription" ]
                        if store.fetchObjectsOfClass(JobHed,clauses = """WHERE number='%s'""" % number ):
                                if self.admin_global.jobNumbering() == "user":
                                    self.message = ("""<b>Error:</b> There is an existing Job with that number""")
                                    self.writeBody()
                                    return
                                else:
                                    while store.fetchObjectsOfClass(JobHed,clauses = """WHERE number='%s'""" % number ):
                                        number += 1


                        tmpedit = JobHedFactory().new()
                        tmpedit.setOpenDate(self.convertToDateTime(date = self.currentdate()))
                    
                        if self.admin_global.jobNumbering() == "auto":
                            LastUsedFactory().setNextJobNumber( number )

                        if self.admin_global.usePrefix():
                            number = "%s%s" % ( self.admin_global.prefix(), number)

                        if self.admin_global.useSuffix():
                            number = "%s%s" % ( number, self.admin_global.suffix() )
                        
                        tmpedit.setNumber(str(number))

                        if not req.field("DueDate","") in [ "", "N/A" ]:
                            datestamp = self.convertToDateTime(date = req.field("DueDate","").replace("/","-") )
                            tmpedit.setDueDate(datestamp)

                        tmpedit.setQtyRequired(self.returnType(req.field("QtyRequired",""),float,0.00))
                        tmpedit.setPriority(self.returnType(req.field("Priority",""),int,0))

                        tmpedit.setQtyScrap(0) # Change None to Int()
                        tmpedit.setQtyComplete(0) # Change None to Int()

                        tmpitem = ItemFactory().getItemBySerialNum( self.returnType(req.field("ItemNumber",""),int,None) ) # Template Item
                        tmpedit.setItem( tmpitem )

                        if not req.field("CustomItemDescription","") == "":
                            tmpedit.setItemDescription( req.field("CustomItemDescription") )
                        else:
                            tmpedit.setItemDescription( tmpitem.description() )
                        
                        description = tmpitem.description()
                        tmpedit.setItemNumber( tmpitem.number() )
      
                        tmpcustomer = self.returnType(req.field("CustomerNumber",""),int,None)
                        if tmpcustomer:
                            tmpcustomer = CustomerFactory().getCustomerBySerialNum( tmpcustomer )
                        tmpedit.setCustomer(tmpcustomer)

                        itemprice = tmpitem.salesPrice()
                        if tmpedit.customer():
                            pricecheck = ItemPriceByCustomerFactory().getItemPriceByCustomerAndItemSerialNum( tmpitem.serialNum(), tmpedit.customer().serialNum() )
                            if pricecheck:
                                itemprice = pricecheck[0].price()

                        for key,value in dict(req.fields()).items():
                            if not key in deleteValues:
                                self.middleKitObjectEval(tmpedit,key,value)

                        number = 10
                        if not len(tmpitem.bom()):
                            tmpassembly = AssemblyFactory().new() # Create First Assembly
                            tmpassembly.setNumber( str(number) )
                            tmpassembly.setDescription( description )
                            tmpassembly.setItemPrice( itemprice )
                            tmpassembly.setJobHed( tmpedit )
                            store.addObject(tmpassembly)
                            store.saveChanges()

                            if tmpitem.routing():
                                for tmproute in tmpitem.routing():
                                    tmpoperation = OperationFactory().new(tmpassembly, tmproute.number(), tmproute.description(), tmproute.unitOfMeasure(), tmproute.conversionUnit(), department=tmproute.department() )
                            else:
                                tmpoperation = OperationFactory().new(tmpassembly, "0", tmpassembly.description(), None, 1.0, tmpitem.department() ) # Create default Operation

                        alreadyAddedBom = []
                        for tmpBOM in tmpitem.bom():
                                number += self.unpackBOMS(tmpBOM,tmpedit,number,alreadyAddedBom)
                                alreadyAddedBom.append(tmpBOM.material().serialNum())
                        
                        store.addObject(tmpedit)

                        notes = req.field("Notes","")
                        if notes:
                            note = NoteByJobHedFactory().new(body = notes, jobhed = tmpedit)
                            store.addObject(note)
                        store.saveChanges()

                        self.goToPage("dcs_edit_jobs/search?_action_=search&serialNum=%s&x=&y=" % tmpedit.serialNum() )

                else:
                        # MULTI-ENTRY EDIT
                        if not edit_flag:
                                self.goToPage("dcs_login/priv_error")

                        for eachKey,eachNull in dict(req.fields()).items():
                                if eachKey.count("editJob"):
                                        serialNum = int( eachKey.replace("editJob","") )
                                        tmpjob = JobHedFactory().getJobHedBySerialNum( serialNum )

                                        itemDescription = req.field('ItemDescription%s' % serialNum,"")
                                        duedate = str(req.field('DueDate%s' % serialNum,"")).replace("/","-")
                                        qtyreq = self.returnType(req.field('QtyRequired%s' % serialNum,""),float,0)
                                        qtycomp = self.returnType(req.field('QtyCompleted%s' % serialNum,""),float,0)
                                        qtyscrap = self.returnType(req.field('QtyScrap%s' % serialNum,""),float,0)
                                        priority = self.returnType(req.field('Priority%s' % serialNum,""),int,0)
                                        
                                        dateStamp = self.returnTrueOrDefault( self.convertToDateTime(date = duedate ), None)
                                        tmpjob.setDueDate(dateStamp)

                                        tmpjob.setItemDescription(itemDescription)
                                        tmpjob.setPriority(priority)
                                        tmpjob.setQtyRequired(qtyreq)
                                        tmpjob.setQtyComplete(qtycomp)
                                        tmpjob.setQtyScrap(qtyscrap)
                                        
                                        complete = self.returnType(req.field("Complete%s" % serialNum,""), int, 0)
                                        hidden = self.returnType(req.hasField("Hidden%s" % serialNum), int, 0) 

                                        if not tmpjob.isClosed() and ( hidden or complete ):
                                            self.closeAllOperations(tmpjob)
                                        elif tmpjob.isClosed() and not ( hidden or complete ):
                                            self.openAllOperations(tmpjob)
                                         
                                        tmpjob.setComplete(complete)
                                        tmpjob.setHidden( hidden )                                      
                                        
                                        if not hidden and not complete:
                                            self.updateOperations(tmpjob)
                                       
                                        store.saveChanges()

                self.goToPage(self.backPage())

    def unpackBOMS(self,tmpBOM,tmpedit,number,bomAlreadyAdded = []):
        
        while store.fetchObjectsOfClass(Assembly,clauses = "WHERE jobHedObjId='%s' AND number='%s'" % (tmpedit.serialNum(),number) ):
            number+=10 # Add 10 till free assembly number is found

        if tmpBOM.material() and bomAlreadyAdded.count(tmpBOM.material().serialNum() )==0:
            bomAlreadyAdded.append(tmpBOM.material().serialNum())
            tmpassembly = AssemblyFactory().new()
            tmpassembly.setJobHed( tmpedit )
            tmpassembly.setNumber( str(number) )
            tmpassembly.setDescription( tmpBOM.material().description() )
            tmpassembly.setItemPrice( tmpBOM.material().salesPrice() )
            store.addObject(tmpassembly)
            store.saveChanges()
        else: return 10

        number = 10
        routingObj = tmpBOM.material().routing()

        if routingObj:
            for tmpRouting in routingObj:
                    tmpoperation = OperationFactory().new(tmpassembly, tmpRouting.number(), tmpRouting.description(), department = tmpRouting.department() )
        else:
                tmpoperation = OperationFactory().new(tmpassembly, "0", tmpBOM.material().description(), department = tmpBOM.material().department() ) # No Routing(s) with BOM have to create default "0"
                
        for tmpOBJ in tmpBOM.material().bom():
                if bomAlreadyAdded.count(tmpBOM.material().serialNum())==0: continue
                bomAlreadyAdded.append(tmpBOM.material().serialNum())
                number+=self.unpackBOMS(tmpOBJ,tmpedit,number,bomAlreadyAdded)

        return number

    def delete(self):
        req = self.request()
        serialNum = self.returnType(req.field("serialNum",""),int,None)
                
        self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "delete_jobs" ) ) 
        
        delete_section = req.field("delete_type","job")

        if delete_section == "assembly":
            tmpdelete = AssemblyFactory().getAssemblyBySerialNum( int( serialNum ) )

            if len( tmpdelete.jobHed().assemblies() ) > 1: #You cannot delete the last Operation from an Assembly
                    for deleteOperation in OperationFactory().getOperationsByAssemblySerialNum( int( serialNum ) ):
                        if not deleteOperation.referencingObjectsAndAttrs():
                            store.deleteObject(deleteOperation)
                            store.saveChanges()
                            
                            if not deleteOperation.complete(): # PYRO event was already sent out...
                                deleteOperation.delete()
                    
                    if not tmpdelete.referencingObjectsAndAttrs():
                        store.deleteObject(tmpdelete)
                        store.saveChanges()
                    else:
                        self.message = "<b>Error:</b> Cannot delete an Assembly that a LaborDtl/Operation references"
                        self.writeBody()
                        return

                    self.goToPage(self.backPage())

        elif delete_section == "operation":
            tmpdelete = OperationFactory().getOperationBySerialNum( int( serialNum ) )
            if len( tmpdelete.assembly().operations() ) > 1:
                    if not tmpdelete.referencingObjectsAndAttrs():
                        store.deleteObject( tmpdelete )
                        store.saveChanges()
                        tmpdelete.delete()
                    else:
                        self.message = "<b>Error:</b> Cannot delete an Operation that a LaborDtl references"
                        self.writeBody()
                        return
                    self.goToPage(self.backPage())
        else:
            tmpdelete = JobHedFactory().getJobHedBySerialNum( int( serialNum ) )
        
            tmpdelete.setComplete(True)
            tmpdelete.setCompleteStamp( datetime.datetime.today() )

            store.saveChanges()
            self.closeAllOperations(tmpdelete)
        
        self.goToPage(self.backPage())

    def closeAllOperations(self,tmpdelete,complete = True,onlyPyroEvent = False): # If onlyPyroEvent is set then the operation.complete() status is not changed...
        def closeAssembliesOperation(data):
            for operation in data.operations():
                if not onlyPyroEvent: operation.setComplete(complete)
                if complete: operation.delete() #Send out PYRO event that this was done.
                else: operation.add()
        
        if Assembly == type(tmpdelete):
            closeAssembliesOperation(tmpdelete)
        else:
            for test in tmpdelete.assemblies():
                closeAssembliesOperation(test)
                
    def openAllOperations(self,tmpdelete,onlyPyroEvent = False):
        self.closeAllOperations(tmpdelete,complete = False, onlyPyroEvent = onlyPyroEvent)

    def updateOperations(self,tmpjob):
        self.closeAllOperations(tmpjob,onlyPyroEvent = True)
        self.openAllOperations(tmpjob,onlyPyroEvent = True)

    def writeStyleSheet(self):
        SecureSitePage.writeStyleSheet(self,linkStyle=True)
        self.writeln("""<link rel="stylesheet" type="text/css" media="all" href="%scss/calendar-blue.css" title="blue" />""" % (self.siteRoot()))
       
    def writeJavascript(self,section=""):
        if section == "assembly":
            return """<script language='javascript' type='text/javascript'>
            function validOnSubmit(myForm) {
                if ( !isInteger( myForm.Number.value ) || (myForm.Number.value == "") && (myForm.BOMItem.value == "") ) {
                    alert('Error: Enter a valid assembly number');
                    myForm.Number.focus();
                    return false;
                }

                if ( (myForm.Description.value == "" ) && (myForm.BOMItem.value == "") ) {
                    alert('Error: Enter a valid description');
                    myForm.Description.focus()
                    return false;
                }

            return true;
            }
            </script>"""

        elif section == "operation":
            return """<script language='javascript' type='text/javascript'>
            function validOnSubmit(myForm) {
                if ( !isInteger( myForm.Number.value ) || (myForm.Number.value == "") ) {
                    alert('Error: Enter a valid operation number');
                    myForm.Number.focus();
                    return false;
                }

                if ( myForm.Description.value == "" ) {
                    alert('Error: Enter a valid description');
                    myForm.Description.focus()
                    return false;
                }

                if ( isPosFloat( myForm.ConversionUnit.value ) == false ) {
                    alert('Error: Please enter an valid Conversion Unit');
                    myForm.ConversionUnit.focus();
                    return false;
                }
            return true;
            }
            </script>"""

        elif section == "job":
            return """<script language='javascript' type='text/javascript'>
            function validOnSubmit(myForm) {

                if (myForm.CustomerNumber.value == "") {
                    alert('Error: Select a valid customer');
                    myForm.CustomerNumber.focus();
                    return false;
                }

                if (myForm.ItemNumber.value == "") {
                    alert('Error: Select a valid item');
                    myForm.ItemNumber.focus();
                    return false;
                }

                if ( (myForm.Number.value == "") || (isInteger(myForm.Number.value) == false ) ) {
                    alert('Error: There is no valid Job Number defined');
                    myForm.Number.focus();
                    return false;
                }
                
                if ( (myForm.DueDate.value != "") && !isDate(myForm.DueDate.value) ) {
                    alert('Error: Enter a valid Due Date');
                    myForm.DueDate.focus();
                    return false;
                }


                if ( (myForm.Priority.value == "" ) || (isInteger(myForm.Priority.value) == false ) ) {
                    alert('Error: Enter a valid Priority value');
                    myForm.Priority.focus();
                    return false;
                }
                
                if ( (myForm.QtyRequired.value == "") || (isFloat(myForm.QtyRequired.value) == false ) ) {
                    alert('Error: Enter a valid QtyRequired');
                    myForm.QtyRequired.focus();
                    return false;
                }

            return true;
            }
            </script>"""

        elif section == "assemblyItem":
            return """
            <script language='javascript' type='text/javascript'>
            function assemblyItem(myForm) {
                if (myForm.BOMItem.value=="") {
                    myForm.Number.disabled = false;
                    myForm.ItemPrice.disabled = false;
                    myForm.Description.disabled = false;
                }
                else {
                    myForm.Number.disabled = true;
                    myForm.ItemPrice.disabled = true;
                    myForm.Description.disabled = true;
                }

            }

            </script>"""
        
        elif section == "hideUnhide":
            return """
            <script language='javascript' type='text/javascript'>
            function checkIfOpen(MyCheckbox,Number,Description,Department,Complete,Unit,Conversion) {
                        if (MyCheckbox.checked) {
                            Number.disabled=false;
                            Description.disabled=false;
                            Department.disabled=false;
                            Complete.disabled=false; 
                            Unit.disabled=false;
                            Conversion.disabled=false;
                        }
                        else {
                            Number.disabled=true;
                            Description.disabled=true;
                            Department.disabled=true;
                            Complete.disabled=true;
                            Unit.disabled=true;
                            Conversion.disabled=true;
                        }
                    }
            </script>"""
        
        else:

            return """
            <script language='javascript' type='text/javascript'>
            function checkIfOpen(MyCheckbox,Priority,DueDate,QtyRequired,QtyComplete,QtyScraped,Complete,Hide,DueDateTrigger,ItemDescription) {
                    if ( MyCheckbox.checked ) {
                        Priority.disabled = false;
                        DueDate.disabled = false;
                        if (DueDateTrigger) {
                            DueDateTrigger.style.visibility='visible';
                        }
                        QtyRequired.disabled = false;
                        QtyComplete.disabled = false;
                        QtyScraped.disabled = false;
                        if (Complete != 0) {
                            Complete.disabled = false;
                        }
                        if (Hide !=0 ) {
                            Hide.disabled = false;
                        }
                        ItemDescription.disabled = false;
                    }
                    else {
                        Priority.disabled = true;
                        DueDate.disabled = true;
                        if (DueDateTrigger) {
                            DueDateTrigger.style.visibility='hidden';
                        }
                        QtyRequired.disabled = true;
                        QtyComplete.disabled = true;
                        QtyScraped.disabled = true;
                        if (Complete != 0) {
                            Complete.disabled = true;
                        }
                        if (Hide != 0 ) {
                            Hide.disabled = true;
                        }
                        ItemDescription.disabled = true;
                    }
                }
                </script>"""


    def backPage(self):
        return "dcs_edit_jobs"

    def localTitle(self):
        return "Jobs"

    def subTabs(self,add = ""):
        subtab1 = self.write_div(id="subtab1",classname="subtab",text="Main", construct = [ 1, siteindex["dcs_edit_jobs"], "./index" ]);
        subtab2 = self.write_div(id="subtab2",classname="subtab",text="Search", construct = [ 2, siteindex["dcs_edit_jobs"], "./search" ]);

        return """<tr><td><table align="left"><tr><td>%s</td></tr></table></td></tr>""" % ("</td><td>".join([subtab1,subtab2,add]))

    def writeLocalContent(self):
        req = self.request()
        self.writeln("""<table width="100%">""")
        
        self.writeln( self.subTabs() )
        self.writeln("""<tr>\n\t<td>""")
         
        if self.message == "":
                lastNum = self.returnType(req.field("lastNum",""),int,0)
                if lastNum > 0: prevNum = lastNum - 1
                else: prevNum = 0

                pageCount = 250
                self.writeln("""<table width="100%">""")
                sortDict={ "number" : "ASC", "customerObjId" : "DESC", "itemObjId" : "DESC","openDate" : "DESC", "dueDate" : "DESC",  "qtyRequired" : "DESC", "qtyComplete" : "DESC", "qtyScrap": "DESC", "priority" : "DESC" }
                
                arrayBefore = req.field("sortBy","number ASC").split()
                if len(arrayBefore) == 2:
                    for key,value in sortDict.items():
                        if arrayBefore[0] == key:
                            sortDict[key] = self.ifTrueReturn(arrayBefore[1] == "DESC","ASC","DESC")
               
                tmp = JobHedFactory().getJobHedsByPage(numberOfLastOne = lastNum,pageCount = pageCount,sortBy = arrayBefore[0],order = arrayBefore[1] == "ASC" )

                header = ("""
                <form action='./index?_action_=edit&edit_section=job' method='post'>
                <tr CLASS=table_header ALIGN=center><th ALIGN=left width=40%%><a href="./index?lastNum=0&sortBy=number %s">&nbsp;Job #&nbsp;</a></th>
                <th width=20%% align=left><a href="./index?lastNum=0&sortBy=customerObjId %s">&nbsp;&nbsp;Customer #&nbsp;</a></th>
                <th width=20%% align=left><a href="./index?lastNum=0&sortBy=itemObjId %s">&nbsp;Item #&nbsp;</a></th>
                <th align=left width=15%%><a href="./index?lastNum=0&sortBy=openDate %s">Open Date</a></th>
                <th align=left width=15%%>&nbsp;<a href="./index?lastNum=0&sortBy=dueDate %s">Due Date</a></th>
                <th width=10%%><a>Status</a></th>
                <th><a href="./index?lastNum=0&sortBy=qtyRequired %s">&nbsp;Qty Req.</a></th>
                <th><a href="./index?lastNum=0&sortBy=qtyComplete %s">&nbsp;Qty Cmp.</a></th>
                <th><a href="./index?lastNum=0&sortBy=qtyScrap %s">&nbsp;Qty. Scp.</th>
                <th><a href="./index?lastNum=0&sortBy=priority %s">&nbsp;Priority</a></th>
                <th ALIGN=center>&nbsp;Hide</th>
                <th ALIGN=center>&nbsp;Edit</th>
                <th ALIGN=center>&nbsp;Asm.</th>
                <th ALIGN=center>&nbsp;Notes</th>
                <th ALIGN=center>&nbsp;Close</th>
                </tr>""" % (sortDict["number"],sortDict["customerObjId"],sortDict["itemObjId"],sortDict["openDate"],sortDict["dueDate"],sortDict["qtyRequired"],sortDict["qtyComplete"],sortDict["qtyScrap"],sortDict["priority"]) )
                
                self.writeln( header )
                self.start_color()
                
                results = tmp[0]
                #if arrayBefore[1] == "DESC":
                #    results.reverse()

                for job in results:
                    bgcolor = self.next_color()

                    if job.customer(): customerfield = "%s" % self.escape(job.customer().name())
                    else: customerfield = ""
                    
                    if job.item(): itemfield = "<b>%s</b>: %s" % (self.escape(job.item().number()),self.escape(job.item().description()))
                    else: itemfield = "DCS 1.0 Import" #Probably safe to remove.

                    openDate = self.parseDate(job.openDate() )
                    dueDate = self.parseDate(job.dueDate() )
                    jobHide = self.ifTrueReturn(job.hidden(),"CHECKED","")

                    self.writeln("""\t<tr bgcolor='%s'>
                    <td class=list_data align=left><nobr><b>%s</b>&nbsp;<input disabled type='text' name ='ItemDescription%s' size='25' maxlength='100' value="%s"></nobr></td>
                    <td class=list_data align=left><b>%s</b>&nbsp;&nbsp</td>
                    <td class=list_data align=left>%s&nbsp;&nbsp;</td>
                    <td class=list_data align=left><nobr>%s</nobr></td>
                    <td class=list_data align=left><nobr><input disabled type='text' id='due_date%s' name='DueDate%s' size=10 maxlength=10 value='%s'><IMG ID='due_trigger%s' name='due_trigger%s' STYLE='visibility: hidden;' SRC=../images/button1.gif CLASS=pointer border=0></nobr></td> 
                    <td class=list_data align=center><b>%s</b></td>
                    <td class=list_data align=center><input disabled type='text' name='QtyRequired%s' size=5 value='%s'></td>
                    <td class=list_data align=center><input disabled type='text' name='QtyCompleted%s' size=5 value='%s'></td>
                    <td class=list_data align=center><input disabled type='text' name='QtyScrap%s' size=5 value='%s'></td>
                    <td class=list_data align=center><input disabled type='text' size=4 maxlength=10 name='Priority%s' value='%s'></td>
                    <td class=list_data align=center><input disabled type='checkbox' name='Hidden%s' value=1 %s></td>
                    <td align=center><input type='checkbox' name='editJob%s' value=1 onClick='checkIfOpen(this,this.form.Priority%s,this.form.DueDate%s,this.form.QtyRequired%s,this.form.QtyCompleted%s,this.form.QtyScrap%s,0,this.form.Hidden%s,this.form.due_trigger%s,this.form.ItemDescription%s);'></td>
                    <td align=center><a href='./assembly?serialNum=%s'><img src='../images/button1.gif' border=0></a></td>
                    <td align=center><a href='./notes?serialNum=%s'><img src='../images/button2.gif' border=0></a></td>
                    <td align=center><a href='./index?_action_=delete&serialNum=%s'><img src='../images/button3.gif' border=0></a></td></tr>""" % (bgcolor,job.number(),job.serialNum(),self.escape(job.itemDescription()),customerfield,itemfield,openDate,job.serialNum(),job.serialNum(),dueDate,job.serialNum(),job.serialNum(),"Open",job.serialNum(),self.quoted_escape( job.qtyRequired() ),job.serialNum(),self.quoted_escape( job.qtyComplete() ),job.serialNum(),self.quoted_escape( job.qtyScrap() ),job.serialNum(),self.quoted_escape(job.priority()),job.serialNum(),jobHide,job.serialNum(),job.serialNum(),job.serialNum(),job.serialNum(),job.serialNum(),job.serialNum(),job.serialNum(),job.serialNum(),job.serialNum(),job.serialNum(),job.serialNum(),job.serialNum() ) )
                    self.writeln("""
                          <script langauge="javascript">
                           Calendar.setup({
                                inputField     :    "due_date%s",     // id of the input field
                                ifFormat       :    "%%m/%%d/%%Y",      // format of the input field
                                button         :    "due_trigger%s",  // trigger for the calendar (button ID                  
                                align          :    "Tl",           // alignment (defaults to "Bl")
                                singleClick    :    true
                            });
                            </script>""" % (job.serialNum(),job.serialNum() ) )

                self.writeln( header )

                self.writeln("""<tr>\n\t<td colspan=6 align=left>""")
                
                if not prevNum == lastNum: # Check if there is a previous page.
                    self.writeln("""\t<a href="./index?lastNum=%s&sortBy=%s"><b>Prev Page</b></a>""" % (prevNum,req.field("sortBy","number ASC") ) )

                self.writeln("""\t</td>\n\t<td align=right colspan=8>""")

                if tmp[1]:
                    self.writeln("""\t<a href="./index?lastNum=%s&prevNum=%s&sortBy=%s"><b>Next Page</b></a>""" % (tmp[1],lastNum,req.field("sortBy","number ASC") ) )
                
                self.writeln("</td></tr>")
                
                self.writeln("""
                <tr><td align="center" height='40px' colspan=13><A HREF="./new_job"><IMG SRC="../images/new.gif" onMouseDown="this.src='../images/newdown.gif';" onMouseOut="this.src='../images/new.gif';" style="border-style: none;"></A>&nbsp;<INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';" ></td></tr>

                </form>
                </table>""")
               
                self.writeln("""\t</td>\n</tr>\n</table>""")
                self.writeln( self.writeJavascript() )

        else:
                self.writeln("""<font color='#ff0000'>%s</font>""" % self.message)
