# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from index import index
from etc import siteindex

from sndcs.LastUsedFactory import LastUsedFactory
from sndcs.OperationFactory import OperationFactory
from sndcs.CustomerFactory import CustomerFactory
from sndcs.ItemFactory import ItemFactory

class new_job(index,SecureSitePage):


        def __init__(self):
                index.__init__(self)
                SecureSitePage.__init__(self,siteindex["dcs_edit_jobs"],1,False,SecureSitePage.mainScripts + [ "../js/jscalendar/calendar.js", "../js/jscalendar/calendar-en.js" ])


        def writeLocalContent(self):

                self.writeln("""<table width="100%">""")
                self.writeln( self.subTabs() )

                self.writeln("""<tr>\n\t<td align=center>""")
                # Check if Job Creation is blocked
                if not self.admin_global.newJobs():
                        # Display popup window and redirect
                        self.writeln("""<font color='#ff0000'><b>Error:</b> Cannot create new jobs</font>""")

                else:

                        self.writeln( self.writeJavascript("job") )
                        self.writeln("""<table width="50%">""")

                        self.writeln("""
                        <form action='./new_job?_action_=edit&edit_section=job&new=1' method='post' onSubmit='return validOnSubmit(this);'>
                        <tr class=table_header>
                            <th align=center colspan=4>Create New Job</th>
                        </tr>
                        <tr>
                            <td class='body_desc'>&nbsp;Customer:&nbsp;</td><td align=right colspan=3><select style='width: 250px;' size=10 name='CustomerNumber'>""")


                        for customerName in CustomerFactory().getCustomers():
                                self.writeln( self.write_option(customerName.serialNum(),"%s" % (customerName.name() ) ) )
                        
                        
                        self.writeln("""
                                </select>
                            </td>
                        </tr>
                        <tr><td colspan=4><hr/></td></tr>
                        <tr>
                            <td class='body_desc'>&nbsp;Item:&nbsp;</td><td align=right colspan=3>
                                <select style='width:250px;' size=10 name='ItemNumber'>""")

                        
                        for itemName in ItemFactory().getItems():
                                self.writeln( self.write_option(itemName.serialNum(),"%s - %s" % (itemName.number(),itemName.description() ) ) )
                        
                        
                        if self.admin_global.jobNumbering() == "user":
                                valueAttrib = [ "", "" ]
                        else:
                                valueAttrib = [ ( int( LastUsedFactory().getNextJobNumber() )), "READONLY" ]
                                
                        # Prefix and suffix add later 
                        
                        self.writeln("""</select></td></tr> 
                                        <tr><td colspan=4><hr/></td></tr>
                                        <tr><td  colspan=2 class=body_desc>&nbsp;Custom Item Description:&nbsp;</td><td colspan=2><input type='text' size=30 name='CustomItemDescription'></td></tr>

                                        <tr><td class=body_desc>&nbsp;Job Number:&nbsp;</td><td><input type='text' size=10 name='Number' value='%s' %s></td>
                                        <td class=body_desc>&nbsp;Due Date:&nbsp;</td><td><input type='text' name='DueDate' size=10 maxlength=10 ID='due_date' value=''>&nbsp;<img src='../images/button1.gif' class='pointer' border=0 ID='due_trigger'></td></tr>
                                        
                                        <tr><td class=body_desc>&nbsp;Priority:&nbsp;</td><td><input type='text' size=10 name='Priority' value=0></td><td class=body_desc>&nbsp;Qty. Required:&nbsp;</td><td><input type=text size=3 name='QtyRequired' value='1.0'></td></tr>
                                        <tr><td class=body_desc>&nbsp;Notes:&nbsp;</td><td colspan=4><textarea cols=40 rows=10 name='Notes'></textarea></td></tr>
                                        
                                        <tr height='40px'><td align=center colspan=4><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';" >&nbsp;<A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>
                                        </form>
                                        </table>""" % (valueAttrib[0],valueAttrib[1]) )

                        self.writeln("""<script language="javascript" src="../js/jscalendar/calendar-setup.js"></script>""")
                        
                        self.writeln("""<script type="text/javascript">
                            Calendar.setup({
                                                inputField     :    "due_date",     // id of the input field
                                                ifFormat       :    "%m/%d/%Y",      // format of the input field
                                                button         :    "due_trigger",  // trigger for the calendar (button ID)
                                                align          :    "Tl",           // alignment (defaults to "Bl")
                                                singleClick    :    true
                                        });
                                        </script>""")

                self.writeln("""\t</td>\n</tr>\n</table>""")
