# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from index import index
from etc import siteindex

from sndcs.LastUsedFactory import LastUsedFactory
from sndcs.OperationFactory import OperationFactory
from sndcs.CustomerFactory import CustomerFactory
from sndcs.DepartmentFactory import DepartmentFactory
from sndcs.ItemFactory import ItemFactory
from sndcs.UnitOfMeasureFactory import UnitOfMeasureFactory

class operation(index,SecureSitePage):
    def __init__(self):
        index.__init__(self)
        SecureSitePage.__init__(self,siteindex["dcs_edit_jobs"], 1,clearSearchResults = False)

    def localTitle(self):
        req=self.request()
        if req.hasField("new"):
            return "Create New Operation"
        else:
            return "Edit Operations"

    def newTab(self):
        req = self.request()
        serialNum = self.returnType(req.field("serialNum",""),int,None)
        if serialNum:
            return ["New Operation","operation?new=1&serialNum=%s" % serialNum]
        else:
            return index.newTab(self)


    def backPage(self):
            req = self.request()
            serialNum = self.returnType(req.field("job_number",""),int,None)
            
            if not serialNum:
                serialNum = self.returnType(req.field("serialNum",""),int,None)
            
            if serialNum:
                return "dcs_edit_jobs/operation?serialNum=%s" % serialNum
            else: return "dcs_edit_jobs"

    def writeLocalContent(self):
            req = self.request()
            serialNum = self.returnType(req.field("serialNum",""),int,None)
         
            if not serialNum:
                self.goToPage("dcs_edit_jobs")

            self.writeln("""<table width="100%">""")
            self.writeln( self.subTabs() )
            self.writeln("""<tr align="center">\n\t<td>""")

            if self.message == "":
                if req.hasField("new"):

                            if not self.admin_global.newOperations():
                                self.writeln("""<font color="#ff0000"><b>Error:</b> Creation of New Operations is disallowed</font>""")

                            else:

                                self.writeln( self.writeJavascript("operation") )
                                
                                self.writeln("""<table width="50%">""")
                                self.writeln("""
                                <form action='./operation?_action_=edit&edit_section=operation&new=1' method='post' onSubmit='return validOnSubmit(this);'>
                                <tr class=table_header><th colspan=2>Create New Operation</th></tr>
                                <tr><td class=body_desc>&nbsp;Unit Of Measure&nbsp;</td><td><select name="UnitOfMeasure">
                                <option value='0'></option>""")

                                
                                for unit in UnitOfMeasureFactory().getUnitOfMeasures():
                                    self.writeln( self.write_option(unit.serialNum(),"%s %s" % (unit.code(),unit.description() ) ) )
                                

                                self.writeln("""
                                   </select>
                                   </td></tr>
                                <tr><td class=body_desc>&nbsp;Conversion Unit&nbsp;</td><td align=left><input type='text' name='ConversionUnit' size=5 value='1.0'></td></tr>
                                <tr><td colspan=2 align=center><hr></td></tr>
                                <tr><td class=body_desc>&nbsp;Number:&nbsp;</td><td align=left><input type='text' name='Number' size=10></td></tr>
                                <tr><td class=body_desc>&nbsp;Department:</td><td align=left><select name='Department'>
                                <option value=''></option>
                                """)

                                for department in DepartmentFactory().getDepartments():
                                    self.writeln( self.write_option(department.serialNum(), "%s - %s" % (department.code(), department.description() ) ) )

                                self.writeln("""
                                </select>\n\t</td>\n</tr>
                                <tr><td class=body_desc>&nbsp;Description:&nbsp;</td><td><textarea name='Description' style='width: 400px;height: 125px;'></textarea></td></tr>
                                
                                <tr><td colspan=2 align=center><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./operation?serialNum=%s"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>
                                <input type='hidden' name='serialNum' value='%s'>
                                </form>
                                </table>""" % (serialNum,serialNum) )

                else:

                                self.writeln( self.writeJavascript("hideUnhide") )
                                
                                self.writeln("""<table width="100%">""")
                                self.writeln("""<form action='./operation?_action_=edit&edit_section=operation' method='post'>
                                <tr class=table_header><th colspan=10>Operations</th></tr>
                                <tr class=table_header><th WIDTH=10%% align=left>Number</th>
                                    <th align=left>Description</th>
                                    <th align=left>Department</th>
                                    <th>&nbsp;Unit Of Measure&nbsp;</th>
                                    <th></th><th width=15%>&nbsp;Conversion Unit&nbsp;</th><th WIDTH='30px'>&nbsp;Comp.</th><th WIDTH='30px'>Edit</th><th WIDTH='30px'>Delete</th></tr>
                                """)

                                self.start_color()
                                for tmpoperation in OperationFactory().getOperationsByAssemblySerialNum( int( serialNum ) ):
                                        bgcolor = self.next_color()
                                        completed = self.ifTrueReturn(tmpoperation.complete(),"CHECKED","")

                                        self.writeln("""
                                        <tr bgcolor='%s'>
                                            <td class=list_data><input disabled type='text' name='Number%s' value='%s' size=3></td>
                                            <td class=list_data><nobr><input disabled type='text' name='Description%s' value=%s size=60>&nbsp;</nobr></td>
                                            <td class=list_data>\n<select disabled name='Department%s'>\n<option value='0'></option>""" % (bgcolor,tmpoperation.serialNum(),tmpoperation.number(), tmpoperation.serialNum(),self.quoted_escape(tmpoperation.description()), tmpoperation.serialNum() ) )
                                        if tmpoperation.department():
                                            department = tmpoperation.department().serialNum()
                                        else: department = None

                                        for x in DepartmentFactory().getActiveDepartments():
                                            self.writeln( self.write_option( x.serialNum(), "%s - %s" % ( x.code(), x.description() ), x.serialNum() == department ) )

                                        self.writeln("""\n</select>\n\t</td>\n\t<td class=list_data align='center'>\n\t<select disabled name='UnitOfMeasure%s'>\n\t<option value='0'></option>""" % ( tmpoperation.serialNum() ) ) 

                                        if tmpoperation.unitOfMeasure(): unitOfMeasure = tmpoperation.unitOfMeasure().serialNum()
                                        else: unitOfMeasure = None
                                        
                                        for unit in UnitOfMeasureFactory().getUnitOfMeasures():
                                            self.writeln( self.write_option(unit.serialNum(),("%s - %s" % (unit.code(),unit.description())) , unitOfMeasure == unit.serialNum() ) )
                                        
                                        unitOfMeasure = tmpoperation.assembly().jobHed().item()
                                        if unitOfMeasure and unitOfMeasure.unitOfMeasure(): unitOfMeasure = unitOfMeasure.unitOfMeasure().description()
                                        else: unitOfMeasure = ""

                                        self.writeln("""
                                            </select>\n\t</td>
                                            <td class=list_data align=center>&nbsp;=&nbsp;</td><td class=list_data align=center><input disabled type='text' name='ConversionUnit%s' size=5 value=%s>%s</td>
                                            <td align=center><input type='checkbox' name='Complete%s' disabled value=1 %s></td><td align=center><input type='checkbox' name='editOperation%s' value=1 onClick='checkIfOpen(this,this.form.Number%s,this.form.Description%s,this.form.Department%s,this.form.Complete%s,this.form.UnitOfMeasure%s,this.form.ConversionUnit%s);'></td>
                                            <td align=center><a href='./operation?_action_=delete&delete_type=operation&serialNum=%s&job_number=%s'><img src='../images/button3.gif' border=0></a></td>
                                        </tr>""" % ( tmpoperation.serialNum(), self.quoted_escape(tmpoperation.conversionUnit()),unitOfMeasure,tmpoperation.serialNum(), completed, tmpoperation.serialNum(), tmpoperation.serialNum(), tmpoperation.serialNum(),tmpoperation.serialNum(), tmpoperation.serialNum(),tmpoperation.serialNum(),tmpoperation.serialNum(),tmpoperation.serialNum(),serialNum ) )
                                
                                self.writeln("""
                                <input type='hidden' name='serialNum' value='%s'>
                                <tr>
                                    <td height='40px' colspan=6 align=center><A HREF="./operation?serialNum=%s&new=1"><IMG SRC="../images/new.gif" onMouseDown="this.src='../images/newdown.gif';" onMouseOut="this.src='../images/new.gif';" style="border-style: none;"></A>&nbsp;<INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./assembly?serialNum=%s"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td>
                                </tr>
                                
                                </form>
                                </table>""" % (serialNum,serialNum,req.field("assembly",0) ) )
            else:
                self.writeln("""<font color="#ff0000">%s</font>""" % self.message )


            self.writeln("""\t</td>\n</tr>""")
            self.writeln("""</table>""")
