# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from labordtl import labordtl

from etc import siteindex

from sndcs.JobHedFactory import JobHedFactory
from sndcs.IndirectFactory import IndirectFactory
from sndcs.LaborHedFactory import LaborHedFactory
from sndcs.LaborDtlFactory import LaborDtlFactory

class edit_labordtl(labordtl,SecureSitePage):

        def localTitle(self):
            return "Edit LaborDtl Record"

        def writeLocalContent(self):
                req = self.request()
                serialNum = self.returnType( req.field("serialNum",""),int,None )
                tmpread = LaborHedFactory().getLaborHedBySerialNum(serialNum)

                endStamp = str(tmpread.endStamp() )
                startStamp = str(tmpread.startStamp() )

                endDate = self.parseDate( str( endStamp[:10] ) )
                startDate = self.parseDate( str( startStamp[:10] ) )
                
                endStamp = "%s %s" % (endDate,endStamp[11:19])
                startStamp = "%s %s" % (startDate,startStamp[11:19])

                self.writeln( self.writeJavascript("labordtl") )

                self.writeln("""<table width="50%">""")
                self.writeln("""<form action='./labordtl?_action_=edit&serialNum=%s' method='post' name='laborDtlForm' id='laborDtlForm' onSubmit='return validOnSubmit(this);'>
                <td align=right colspan=4 class=title><a class=hyperlink href='javascript:window.close()'>Close Window</a></td></tr>
                <tr class=table_header><th align=center colspan=4>Create New LaborDtl</th></tr>
                <tr><td class=body_desc>Job Type:&nbsp;</td>
                    <td><select id=jobType name=jobType onChange='hideOption(this.form);'>
                    <option value="Indirect" SELECTED>Indirect
                    <option value="Production">Production
                    <option value="Setup">Setup
                </select>
                </td>""" % serialNum)
                
                self.writeln("<td align=right colspan=2><select name=Indirects size=10 style='width: 550px;'>")
                for indirect in IndirectFactory().getAllActiveIndirects():
                    self.writeln( self.write_option(indirect.serialNum(), "%s %s" % ( indirect.code(), indirect.description() ) ) )

                self.writeln("</select><select name=JobItem multiple style='width: 550px;' size=10 align=right disabled>")

                for jobItem in JobHedFactory().getActiveJobHeds():
                    self.writeln( self.write_option(jobItem.serialNum(), jobItem.formattedDescription() ) )

                self.writeln("""</select></td>
                
                </tr>
                <tr><td colspan=2 class=body_desc>Enter JobHed Number: </td><td colspan=2><input type='text' id='JobHedNumber' name='jobHedNumber' size=6 disabled></td></tr>
                <tr><td colspan=4><hr></td></tr>

                <tr align='center'>
                    <td colspan=4>
                <table>

                <tr>
                    <td class=body_desc>Start Stamp:&nbsp;</td>
                    <td class=body_desc>&nbsp;<input type='text' size=19 maxlength=19 name='startStamp' id='startStamp' value='%s'><IMG ID=start_trigger SRC=../images/button1.gif CLASS=pointer border=0></td>
                </tr>

                <tr height='40px'>
                    <td class=body_desc>End Stamp:&nbsp;</td>
                    <td class=body_desc>&nbsp;<input type='text' size=19 maxlength=19 name='endStamp' id='endStamp' value='%s'><IMG ID=end_trigger SRC=../images/button1.gif CLASS=pointer border=0></td>
                </tr>
               
                    </table>
                    </td>
                </tr>

                <tr><td align=center colspan=4><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./labordtl?serialNum=%s"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>""" % (startStamp,endStamp,serialNum) )

                self.writeln("""<script language="javascript" src="../js/jscalendar/calendar-setup.js"></script>""")
                
                self.writeln("""<script langauge="javascript">
                    Calendar.setup({
                                        inputField     :    "startStamp",     // id of the input field
                                        ifFormat       :    "%m/%d/%Y %H:%M:%S",      // format of the input field
                                        button         :    "start_trigger",  // trigger for the calendar (button ID)
                                        align          :    "Bl",           // alignment (defaults to "Bl")
                                        showsTime      :    true,
                                        singleClick    :    true
                                        });
                    </script>

                <script language="javascript">
                     Calendar.setup({
                                        inputField     :    "endStamp",     // id of the input field
                                        ifFormat       :    "%m/%d/%Y %H:%M:%S",      // format of the input field
                                        button         :    "end_trigger",  // trigger for the calendar (button ID)
                                        align          :    "Bl",           // alignment (defaults to "Bl")
                                        showsTime      :    true,
                                        singleClick    :    true
                                        });
                </script>""")
                
                
                self.writeln("""</form>\n</table>""")
                self.writeln("""<script language="javascript">hideOption(document.getElementById("laborDtlForm"));</script>""")

