# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from index import index

from etc import siteindex
from sndcs.Store import store
from sndcs.EmployeeFactory import EmployeeFactory

class edit_time(index,SecureSitePage):
    
    def __init__(self):
        SecureSitePage.__init__(self,siteindex["dcs_edit_time"],1,False,[ "../js/sndcs2_main.js", "../js/jscalendar/calendar.js", "../js/jscalendar/calendar-en.js" ])

    def writeStyleSheet(self):
        SecureSitePage.writeStyleSheet(self)
        self.writeln("""<link rel="stylesheet" type="text/css" media="all" href="%scss/calendar-blue.css" title="blue" />""" % (self.siteRoot()))

    def writeLocalContent(self):

        self.writeln( self.writeJavascript("validOnSubmit") )
        
        self.writeln("""<table width="100%">""")
        self.writeln("""<tr align="center">\n\t<td>""")

        self.writeln("""<table width="50%">""")
        self.writeln("""
        <form action='./edit_time?_action_=edit&new=1' method='post' onSubmit='return validOnSubmit(this);'>
        <tr class=table_header><th align=center colspan=4>Create New LaborHed Record</th></tr>
        <tr><td class=body_desc>Employee:&nbsp;</td>
        <td class=body_desc colspan=3>
        <SELECT NAME=employee>""")
    
        for employee in EmployeeFactory().searchEmployee("ORDER BY lastName,firstName"):
            if employee.properName().strip()<>",":
                self.writeln( self.write_option(employee.serialNum(),str(employee.empId())+" "+employee.properName(),False) )
    
        self.writeln("</select>\n\t</td>\n</tr>")
            
        self.writeln("""<tr><td colspan=4><hr></td></tr>
        <tr><td class=body_desc>Start Stamp:&nbsp;</td><td class=body_desc><input type='text' name='startStamp' id=startStamp size=19 maxlength=19 value='%s 00:00:00'><IMG ID=start_trigger SRC=../images/button1.gif CLASS=pointer border=0></td></td></tr>
        
        <tr><td class=body_desc>End Stamp:&nbsp;</td><td class=body_desc><input type='text' name='endStamp' id=endStamp size=19 maxlength=19 value='%s 00:00:00'><IMG ID=end_trigger SRC=../images/button1.gif CLASS=pointer border=0></td></tr>

        <tr height='40px'><td colspan=4 align=center><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./index.py"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>""" % (self.currentdate(), self.currentdate()) )
            
            
        self.writeln("""<script language="javascript" src="../js/jscalendar/calendar-setup.js"></script>""")
            
        self.writeln("""
                <script type="text/javascript">
                Calendar.setup({
                                    inputField     :    "startStamp",     // id of the input field 
                                    ifFormat       :    "%m/%d/%Y %H:%M:%S",      // format of the input field
                                    button         :    "start_trigger",  // trigger for the calendar (button ID)
                                    align          :    "Bl",           // alignment (defaults to "Bl")
                                    showsTime      :    true,
                                    singleClick    :    true
                                    });
                </script>

                <script type="text/javascript">
                 Calendar.setup({
                                    inputField     :    "endStamp",     // id of the input field
                                    ifFormat       :    "%m/%d/%Y %H:%M:%S",      // format of the input field
                                    button         :    "end_trigger",  // trigger for the calendar (button ID)
                                    align          :    "Bl",           // alignment (defaults to "Bl")
                                    showsTime      :    true,
                                    singleClick    :    true
                                    });
                </script>""")

        self.writeln("""
        </form>
        </table>
            </td>
        </tr>
        
        </table>""")

