# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from etc import siteindex
from sndcs.UserFactory import UserFactory
from sndcs.LaborHedFactory import LaborHedFactory
from sndcs.LaborDtlFactory import LaborDtlFactory
from sndcs.EmployeeFactory import EmployeeFactory
from sndcs.Store import store

class index(SecureSitePage):
    
        def __init__(self):
            SecureSitePage.__init__(self,siteindex["dcs_edit_time"],0,False,[ "../js/sndcs2_main.js", "../js/jscalendar/calendar.js", "../js/jscalendar/calendar-en.js","../js/jscalendar/calendar-setup.js"])

        def actions(self):
            return SecureSitePage.actions(self) + [ "delete","edit","post_all" ]

        def newTab(self):
            return ["New LaborHed","edit_time"]

        def writeStyleSheet(self):
            SecureSitePage.writeStyleSheet(self)
            self.writeln("""<link rel="stylesheet" type="text/css" media="all" href="%scss/calendar-blue.css" title="blue" />""" % (self.siteRoot()))
       
        def writeJavascript(self,section="",serialNum=""):
                if section == "validOnSubmit":
                    return """
                    <script language='javascript' type='text/javascript'>
                    function validOnSubmit(myForm) {
                            if ( (myForm.startStamp.value == "") || !( myForm.startStamp.value.split(" ").length == 2 ) || !isDate(myForm.startStamp.value.split(" ")[0]) || !isValidTime(myForm.startStamp.value.split(" ")[1]) ) {
                                alert('Error: Enter a valid Start Stamp');
                                myForm.startStamp.focus();
                                return false;
                            }

                            if ( (myForm.endStamp.value == "") || !( myForm.endStamp.value.split(" ").length == 2 ) || !isDate(myForm.endStamp.value.split(" ")[0]) || !isValidTime(myForm.endStamp.value.split(" ")[1]) ) {
                                alert('Error: Enter a valid End Stamp');
                                myForm.endStamp.focus();
                                return false;
                            }

                            if ( strComp(myForm.startStamp.value,myForm.endStamp.value) ==1) {
                                alert('Error: Start Stamp cannot be greater than End Stamp');
                                return false;
                            }



                        return true;
                    }
                    </script>"""

                elif section=="assembly":
                    return """<script language='javascript' type='text/javascript'>
                    function validOnSubmit(myForm) {
                        if (myForm.assembly.value=="") {
                            alert('Error: You must select an assembly');
                            return false;
                        }
                        return true;
                    }
                    </script>"""

                elif section=="operation":
                    return """<script language='javascript' type='text/javascript'>
                    function validOnSubmit(myForm) {
                        if (myForm.operation.value=="") {
                            alert('Error: You must select an operation');
                            return false;
                        }
                        return true;
                    }
                    </script>"""
                
                elif section=="labordtl":
                    return """<script language='javascript' type='text/javascript'>
                    function validOnSubmit(myForm) {
                        if (myForm.jobType.value == "Indirect" ) {
                            if (myForm.Indirects.value == "" ) {
                                alert('Error: Select an Indirect task');
                                myForm.Indirects.focus();
                                return false;
                            }

                        }
                        else {
                            if (myForm.JobItem.value == "" && myForm.JobHedNumber.value == "") {
                                alert('Error: Select an Job task');
                                myForm.JobItem.focus();
                                return false;
                            }
                        }

                        
                            if ( (myForm.startStamp.value == "") || !( myForm.startStamp.value.split(" ").length == 2 ) || !isDate(myForm.startStamp.value.split(" ")[0]) || !isValidTime(myForm.startStamp.value.split(" ")[1]) ) {
                                alert('Error: Enter a valid Start Stamp');
                                myForm.startStamp.focus();
                                return false;
                            }

                            if ( (myForm.endStamp.value == "") || !( myForm.endStamp.value.split(" ").length == 2 ) || !isDate(myForm.endStamp.value.split(" ")[0]) || !isValidTime(myForm.endStamp.value.split(" ")[1]) ) {
                                alert('Error: Enter a valid End Stamp');
                                myForm.endStamp.focus();
                                return false;
                            }

                            
                            if ( strComp(myForm.startStamp.value,myForm.endStamp.value) ==1) {
                                alert('Error: Start Stamp cannot be greater than End Stamp');
                                return false;
                            }

                    return true;
                    }
                    
                    function hideOption(myForm) {
	                if (myForm.jobType.value=="Indirect"){
		                myForm.Indirects.disabled = false;
		                myForm.JobItem.disabled = true;
                        myForm.JobHedNumber.disabled = true;
	                }
	                else {
		                myForm.Indirects.disabled = true;
		                myForm.JobItem.disabled = false;
                        myForm.JobHedNumber.disabled = false;
	                }
                    }		
                    
                    </script>
                    """

                elif section=="checkIfOpen":
                    return """<script language='javascript' type='text/javascript'>
                    function checkIfOpen(MyCheckbox,StartStamp,EndStamp,ActPercent,QtyComplete,QtyScrap,StartTrigger,EndTrigger) {
                        if ( MyCheckbox.checked ) {
                            StartStamp.disabled = false;
                            EndStamp.disabled = false;
                            ActPercent.disabled = false;
                            QtyComplete.disabled = false;
                            QtyScrap.disabled = false;
                            StartTrigger.style.visibility='visible';
                            EndTrigger.style.visibility='visible';
                        }
                        else {
                            StartStamp.disabled = true;
                            EndStamp.disabled = true;
                            ActPercent.disabled = true;
                            QtyComplete.disabled = true;
                            QtyScrap.disabled = true;
                            StartTrigger.style.visibility='hidden';
                            EndTrigger.style.visibility='hidden';
                        }

                    }
                    </script>"""    

                elif section=="dateDisplay":
                    return """
                    <script langauge="javascript">
                    Calendar.setup({
                                        inputField     :    "startStamp%s",     // id of the input field
                                        ifFormat       :    "%%m/%%d/%%Y %%H:%%M:%%S",      // format of the input field
                                        button         :    "start_trigger%s",  // trigger for the calendar (button ID)
                                        align          :    "Bl",           // alignment (defaults to "Bl")
                                        singleClick    :    true,
                                        showsTime      :    true
                                        });
                    </script>

                    <script language="javascript">
                     Calendar.setup({
                                        inputField     :    "endStamp%s",     // id of the input field
                                        ifFormat       :    "%%m/%%d/%%Y %%H:%%M:%%S",      // format of the input field
                                        button         :    "end_trigger%s",  // trigger for the calendar (button ID)
                                        align          :    "Bl",           // alignment (defaults to "Bl")
                                        singleClick    :    true,
                                        showsTime      :    true
                                        });
                    </script>""" % (serialNum,serialNum,serialNum,serialNum)
                    
                else:
                    ### Checkbox validation
                    return """<script language='javascript' type='text/javascript'>
                    function checkIfOpen(MyCheckbox,StartStamp,EndStamp,StartTrigger,EndTrigger) {
                        if ( MyCheckbox.checked ) {
                            StartStamp.disabled = false;
                            EndStamp.disabled = false;
                            StartTrigger.style.visibility='visible';
                            EndTrigger.style.visibility='visible';
                        }
                        else {
                            StartStamp.disabled = true;
                            EndStamp.disabled = true;
                            StartTrigger.style.visibility='hidden';
                            EndTrigger.style.visibility='hidden';
                        }

                    }
                    </script>"""

        def ParseValues(self,savefields,outputType = True, deleteValues = [] ):
                parsePOST = ""
                for key,value in savefields.items():
                    if not key in [ "x","y","_action_" ] + deleteValues:
                        if outputType:
                            parsePOST += "&%s=%s" % (key,value)
                        else:
                            parsePOST += "<input type='hidden' name='%s' value='%s'>\n" % (key,value)
                return parsePOST

        def delete(self):
                req = self.request()
                serialNum = self.returnType(req.field("serialNum",""),int,None)
           
                self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_time" ) ) 
        
                tmpdelete = LaborHedFactory().getLaborHedBySerialNum( serialNum )
                store.deleteObject(tmpdelete)
                store.saveChanges()

                self.goToPage("dcs_edit_time")
        
        def edit(self):
                req = self.request()

                if req.hasField("new"):
                    self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "create_time" ) ) 
                    self.parseEdit(req.field("startStamp"), req.field("endStamp"), req.field("employee") )
                else:
                    self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_time" ) ) 
                    for key,value in req.fields().items():
                        if key.count("editHed"):
                            editNum=key.replace("editHed","")
                            self.parseEdit(req.field("startStamp%s" % editNum ), req.field("endStamp%s" % editNum ),0,int( editNum ) )
                self.goToPage("dcs_edit_time")

        def parseEdit(self,startStamp,endStamp,employee = False,editNum = False):
                if editNum:
                    tmpedit = LaborHedFactory().getLaborHedBySerialNum( int(editNum) )
                else:
                    tmpedit = LaborHedFactory().new()
                    tmpedit.setEmployee( EmployeeFactory().getEmployeeBySerialNum(int( employee ) ) )
                
                if cmp(startStamp,endStamp) <= 0:
                    startStamp = self.convertToDateTime(timestamp = startStamp)
                    endStamp = self.convertToDateTime(timestamp = endStamp)

                    if startStamp and endStamp:
                        tmpedit.setStartStamp(startStamp)
                        tmpedit.setEndStamp(endStamp)

                    if employee: #Change startTerminal only for new entries
                        tmpedit.setStartTerminal(self.terminalName)
                
                    tmpedit.setEndTerminal(self.terminalName)
                
                    store.addObject(tmpedit)
                
                store.saveChanges()
        
        def post_all(self):
                req=self.request()
                beginTime=req.field("beginTime","")
                stopTime=req.field("stopTime","")
                
                beginTime = self.convertToDateTime(timestamp = beginTime)
                stopTime = self.convertToDateTime(timestamp = stopTime)
                
                self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_time" ) ) 
                
                #for laborhed in LaborHedFactory().getUnpostedLaborHeds(startStamp = beginTime, endStamp = stopTime):
                #    if laborhed.endStamp(): # Check for activeLaborHed's
                #        laborhed.setPosted(True)
                #        for labordtl in laborhed.laborDtls():
                #            labordtl[0].setPosted(True)
                
                #The above code is way too slow....
                LaborHedFactory().postUnpostedLaborHeds( startStamp = beginTime, endStamp = stopTime)

                store.saveChanges()
                self.goToPage("dcs_edit_time")
                   
        def localTitle(self):
            return "Employee Time"

        def writeLocalContent(self):
                
                self.writeln( self.writeJavascript("checkboxValidation") )

                self.writeln("""<table width="100%">""")
                self.writeln("""<tr><td class=title align=center colspan=10>LaborHed Records</td></tr>""")

                header = ("""
                <tr class=table_header style='font-size: 8pt;'>
                    <th align=left>Emp ID</th>
                    <th align=left>&nbsp;First Name</th>
                    <th align=left>&nbsp;Last Name</th>
                    <th align=left>&nbsp;Start Stamp</th>
                    <th width='10%'></th>
                    <th align=left>&nbsp;End Stamp</th>
                    <th width='10%'>&nbsp;Edit LaborHed</th>
                    <th width='10%'>&nbsp;Edit LaborDtl</th>
                    <th width='10%'>&nbsp;Delete</th>
                </tr>""")
                self.writeln( header )

                self.start_color()

                testDate = []

                self.writeln("<form action='./index' method='post'>")

    
                minBeginTime,maxStopTime = ["N/A","N/A"]
                for laborHed in LaborHedFactory().getUnpostedLaborHeds():
                        if laborHed.employee():
                                    employee = laborHed.employee()
                                    startDate = self.parseDate( str(laborHed.startStamp() )[:10] )
                                    bgcolor = self.next_color()
                                        
                                    if not testDate.count(startDate):
                                            self.writeln("<tr bgcolor='#acaaac' class=list_data><td align=left colspan=11><u>%s</u></td></tr>" % startDate)
                                            testDate.append(startDate)
                                        
                                    endDate = self.parseDate( str(laborHed.endStamp() )[:10] )
                                    
                                    if not endDate == "N/A" or not laborHed.activeTrans(): # Don't display active LaborHed's
                                    
                                        if cmp( ("%s %s" % (startDate,str(laborHed.startStamp())[11:19] ) ), minBeginTime )==-1 or minBeginTime == "N/A": minBeginTime = "%s %s" % (startDate,str(laborHed.startStamp())[11:19]) 
                                        if cmp( ("%s %s" % (endDate,str(laborHed.endStamp())[11:19] ) ), maxStopTime )==1 or maxStopTime == "N/A": maxStopTime = "%s %s" % (endDate,str(laborHed.endStamp())[11:19])
                                        
                                        self.writeln("""
                                        <tr bgcolor='%s'>
                                                <td class=list_data>%s</td><td class=list_data>&nbsp;%s</td>
                                                <td class=list_data>&nbsp;%s</td><td align=left class=list_data><input type='text' id='startStamp%s' name='startStamp%s' value='%s' size=19 maxlength=40 disabled><IMG ID=start_trigger%s STYLE='visibility: hidden;' SRC=../images/button1.gif CLASS=pointer border=0></td></td>
                                                <td>&nbsp;</td>
                                                <td align=left class=list_data><input type='text' id='endStamp%s' name='endStamp%s' value='%s' size=19 maxlength=19 disabled><IMG ID=end_trigger%s STYLE='visibility: hidden;' SRC=../images/button1.gif CLASS=pointer border=0></td></td>
                                                 <td align=center><input type='checkbox' name='editHed%s' value=1 onClick='checkIfOpen(this,this.form.startStamp%s,this.form.endStamp%s,this.form.start_trigger%s,this.form.end_trigger%s);'></td><td align=center><img class=pointer onClick="window.open('./labordtl.py?serialNum=%s');" src='../images/button2.gif' border=0></td><td align=center><a href='./index.py?_action_=delete&serialNum=%s'><img src='../images/button3.gif' border=0></a></td>
                                        </tr>
                                        """ % (bgcolor,employee.empId(),employee.firstName(),employee.lastName(),laborHed.serialNum(),laborHed.serialNum(),("%s %s" % (startDate,str(laborHed.startStamp())[11:19]) ),laborHed.serialNum(),laborHed.serialNum(),laborHed.serialNum(),("%s %s" % (endDate,str(laborHed.endStamp())[11:19]) ),laborHed.serialNum(),laborHed.serialNum(),laborHed.serialNum(),laborHed.serialNum(),laborHed.serialNum(), laborHed.serialNum(), laborHed.serialNum(),laborHed.serialNum() ) )
                                
                                        self.writeln( self.writeJavascript(serialNum = laborHed.serialNum(),section = "dateDisplay") )
               
                self.writeln("""
                <tr height='40px'>
                    <td colspan=10 align=center><A HREF="./edit_time"><IMG SRC="../images/new.gif" onMouseDown="this.src='../images/newdown.gif';" onMouseOut="this.src='../images/new.gif';" style="border-style: none;"></A>&nbsp;<INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';" ></td></tr>
                    <input type='hidden' name='_action_' value='edit'></td>
                </tr>
                </form>
                <tr>
                    <td colspan=10 align=center>
                    <form action='./index?_action_=post_all' method=post>
                <br><br>
                <input type='submit' value="Post Labor Transactions">
                <br><br>
                    </td>
                </tr>
                <tr>
                    <td colspan=10 align=center>
                    <input name='beginTime' type='text' size=19 maxlength=19 id='beginTime' onChange='getElementById("beginTimePosted").value=this.value;' value='%s'><IMG ID=begin_trigger SRC=../images/button1.gif CLASS=pointer border=0>&nbsp;<input name='stopTime' type='text' size=19 maxlength=45 id='stopTime' value='%s' onChange='getElementById("stopTimePosted").value=this.value;'><IMG ID=stop_trigger SRC=../images/button1.gif CLASS=pointer border=0>
                    </td>
                    
                    </form>
                    <script langauge="javascript">
                    Calendar.setup({
                                        inputField     :    "beginTime",     // id of the input field
                                        ifFormat       :    "%%m/%%d/%%Y %%H:%%M:%%S",      // format of the input field
                                        button         :    "begin_trigger",  // trigger for the calendar (button ID)
                                        align          :    "Bl",          // alignment (defaults to "Bl")
                                        singleClick    :    true,
                                        showsTime      :    true
                                        });
                    </script>

                    <script language="javascript">
                     Calendar.setup({
                                        inputField     :    "stopTime",     // id of the input field
                                        ifFormat       :    "%%m/%%d/%%Y %%H:%%M:%%S",      // format of the input field
                                        button         :    "stop_trigger",  // trigger for the calendar (button ID)
                                        align          :    "Bl",           // alignment (defaults to "Bl")
                                        singleClick    :    true,
                                        showsTime      :    true
                                        });
                    </script>
                    
                </tr>
                <tr>
                    <td>&nbsp;</td>
                </tr>
                <tr>
                    <td colspan=10 align=center>""" % (minBeginTime,maxStopTime) )

                if UserFactory().checkPriv(self.session().value("userLoggedOn"),"edit_time"):
                        self.writeln("""
                        <form action='./recover_posted' method=post>
                        <input type='hidden' name=beginTimePosted id=beginTimePosted value='%s'>
                        <input type='hidden' name=stopTimePosted id=stopTimePosted value='%s'>
                        <input type='submit' value='Recover Posted Labor Transactions'>
                        <br><br>
                        </form>""" % (minBeginTime,maxStopTime) )
                
                self.writeln("""\t</td>\n</tr>\n</table>""")
