from lib.SecureSitePage import SecureSitePage
from sndcs.LaborDtlFactory import LaborDtlFactory
from sndcs.NoteByLaborDtlFactory import NoteByLaborDtlFactory
from sndcs.LaborDtlFactory import LaborDtlFactory
from sndcs.Store import store
from sndcs.UserFactory import UserFactory
from labordtl import labordtl

class notes(labordtl):

        def backPage(self):
            req = self.request()
            serialNum = LaborDtlFactory().getLaborDtlBySerialNum(int(req.field("serialNum"))).laborHed().serialNum()
            return "dcs_edit_time/labordtl?serialNum=%s" % serialNum

        def localTitle(self):
            req = self.request()
            return "LaborDtl #%s Note" % req.field("serialNum",0)

        def actions(self):
            return labordtl.actions(self) + [ "change" ]

        def change(self):
            req = self.request()
            serialNum = self.returnType(req.field("serialNum",""),int,False)
            if serialNum:
                self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_time" ) ) 
                    
                note = NoteByLaborDtlFactory().findNote( int(serialNum) )
                body = req.field("Notes","")
    
                labordtl = LaborDtlFactory().getLaborDtlBySerialNum( int(serialNum) ) 
                if not labordtl.jobType() == "Indirect":
                    if not note and not body == "":
                        note = NoteByLaborDtlFactory().new(body = body, labordtl = labordtl)
                        store.addObject(note)
                    else:
                        note[0].note().setBody( body )
                    store.saveChanges()

            self.goToPage(self.backPage())

        def writeLocalContent(self):
            req = self.request()

            serialNum = self.returnType(req.field("serialNum",""),int,0)
            jobType = req.field("jobType","")
            
            if not serialNum or not jobType:
                self.goToPage(self.backPage())
            
            laborHedSerialNum = LaborDtlFactory().getLaborDtlBySerialNum(int(serialNum)).laborHed().serialNum()
            self.writeln("""<table width="50%" align="center">""")    

            if jobType == "Indirect":
                self.writeln("""
                <tr>
                    <td align=center><font color='#ff0000'><b>Error:</b> Indirect LaborDtl's cannot have notes.</font></td>
                </tr>
                <tr>
                    <td align=center><a href="./labordtl?serialNum=%s"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></a>
</td>
                </tr>
                """ % laborHedSerialNum )

            else:

                note = NoteByLaborDtlFactory().findNote( serialNum )
                if note: body = note[0].note().body()
                else: body = ""

                self.writeln("""
                <form method='post' action='./notes?_action_=change&serialNum=%s'>
                <tr width="100%%">
                    <td class=body_desc>Notes:&nbsp;</td><td><textarea name="Notes" rows="10" cols="50">%s</textarea></td>
                </tr>
                <tr>
                    <td colspan=2 align=center>
                    <INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./labordtl?serialNum=%s"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A>
                     </td>
                </tr>
                </form>
                """ % ( serialNum,body,laborHedSerialNum) )
            self.writeln("""</table>""")
