# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from index import index
from etc import siteindex

from sndcs.OperationFactory import OperationFactory
from sndcs.AssemblyFactory import AssemblyFactory
from sndcs.JobHedFactory import JobHedFactory


class operation(index,SecureSitePage):

            def __init__(self):
                SecureSitePage.__init__(self,0,0,False,[ "../js/sndcs2_main.js", "../js/jscalendar/calendar.js", "../js/jscalendar/calendar-en.js" ])

            def writeLocalContent(self):
                req = self.request()

                assembly = self.returnType(req.field("assembly",""),int,None)
                percentLeft = self.returnType(req.field("PercentLeft",""),float,100.0)
                
                if assembly:
                    tmpoperation = OperationFactory().getOperationsByAssemblySerialNum( assembly )
                else:
                    self.goToPage("dcs_edit_time")
                    
                self.writeln("""<table width="50%">""")
                if not tmpoperation:
                    self.writeln("""
                    <tr><td><font color='#ff0000'><b>Error: That JobHed doesn't have any Operations defined</b></font></td></tr>
                    </table>""")
                    return

                self.writeln( self.writeJavascript("operation") )
                jobItem = JobHedFactory().getJobHedBySerialNum( self.returnType(req.field("JobItem",""),int,None) ).number()

                self.writeln("""
                <form action='./labordtl?_action_=post_labor_dtl' method='post' onSubmit='return validOnSubmit(this);'>
                <tr> <th colspan=3 align=center>JobHed #%s</th>     
                <th align=center colspan=2><a class=hyperlink href='javascript:window.close()'>Close Window</a></th></tr>
                <tr class=table_header><th colspan=6 align=center>Select Operation</th></tr>
                <tr><td colspan=6 class=body_desc align=center><select name='operation' size=10 style='width: 100%%;'>""" % jobItem)

                for operation in tmpoperation:
                    self.writeln( self.write_option(operation.serialNum(),"%s %s" % (operation.number(), operation.description() ) ) )
                
                self.writeln("""</select>\n\t</td>\n</tr>""")

                moreJob = self.returnType(self.checkBoolean(req.field("moreJob","")),[int,list], False )
                
                sendUrl = self.ParseValues(dict(req.fields()),False,[ "moreJob","ActivityPercentage" ])
                if self.isType(moreJob,list):
                    for job in moreJob:
                        sendUrl += "<input type='hidden' name='moreJob' value='%s'>\n" % job
                    activityPercentage = percentLeft / ( len(moreJob) + 1 )
                else:
                    sendUrl += "<input type='hidden' name='moreJob' value='%s'>\n" % moreJob

                    if moreJob:
                        activityPercentage = percentLeft / 2
                    else:
                        activityPercentage = percentLeft

                self.writeln( sendUrl )
                
                self.writeln("""
                <tr><td class=body_desc width='100px'>Activity Percentage&nbsp;</td> <td><input type='text' size=5 name='ActivityPercentage' value='%s'>
                <td class=body_desc width='100px'>&nbsp;Qty Completed:&nbsp;</td> <td><input type='text' size=3 name='QtyComplete' value='0.0'></td>
                <td class=body_desc width='100px'>&nbsp;Qty Scrap:&nbsp;</td> <td><input type='text' size=3 name='QtyScrap' value='0.0'></td> </tr>
                <tr><td colspan=3 class=body_desc>Note: <input name='Note' type='text' size=36></td><td><td class=body_desc align=left>&nbsp;Comp.?&nbsp;&nbsp</td><td class=body_desc align="center"><input type='checkbox' name='Complete' value=1></td></tr>
                <tr><td colspan=5 height='40px' align=center><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';">&nbsp;<A HREF="./edit_labordtl?serialNum=%s"><IMAGE SRC="../images/back1.gif" onMouseDown="this.src='../images/back1down.gif';" onMouseOut="this.src='../images/back1.gif';" BORDER=0></A></td></tr>
                <input type='hidden' name='PercentLeft' value='%s'>
                <tr><td>
                </form>
                </table>""" % ( activityPercentage, req.field("serialNum",""),percentLeft ) )
        

