# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from index import index

from sndcs.LaborHedFactory import LaborHedFactory
from sndcs.LaborDtlFactory import LaborDtlFactory
from sndcs.UserFactory import UserFactory
from sndcs.Store import store

class recover_posted(index,SecureSitePage):
        
    def actions(self):
            return SecureSitePage.actions(self) + ["recover_posted"]
    
    def recover_posted(self):
            req = self.request()    
            self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_time" ) ) 

            for key,value in dict(req.fields()).items():
                    if key.count("recover"):
                        numberToRecover = int( key.replace("recover","") )
                        print numberToRecover
                        tmprecover = LaborHedFactory().getLaborHedBySerialNum(numberToRecover)
                        tmprecover.setPosted(0)

                        store.addObject(tmprecover)
                        store.saveChanges()

                        for tmprecoverdtl in LaborDtlFactory().getLaborDtlsByLaborHedSerialNum(numberToRecover): #Now recover all laborDtls with that record
                                tmprecoverdtl.setPosted(0)
                                store.addObject(tmprecoverdtl)
                                store.saveChanges()
            self.goToPage("dcs_edit_time")

    def writeLocalContent(self):
            req = self.request()
            self.writeln("""<table width="100%">""")

            beginTime = req.field("beginTimePosted","")
            stopTime = req.field("stopTimePosted","")
            
            if beginTime.strip() in [ "","N/A","False" ]:
                beginTime = False
            else:
                beginTime = self.convertToDateTime(timestamp = beginTime)
                
            if stopTime.strip() in [ "","N/A","False" ]:
                stopTime = False
            else:
                stopTime = self.convertToDateTime(timestamp = stopTime)
            
            self.redirectIfTrue( UserFactory().redirectIfAccessDenied( self.session().value("userLoggedOn"), "edit_time" ) ) 
            page = self.returnType(req.field("page",""),int,0)
            results = LaborHedFactory().getPostedLaborHedsByPage(page,startStamp = beginTime, endStamp = stopTime)
            
            self.writeln("""
            <form action='./recover_posted?_action_=recover_posted' method='post'>
            <tr><td class=title align=center colspan=10>Recover Posted LaborHed Records</td></tr>
            <tr class=refresh><td colspan=5 align=left>""")

            if page > 0: self.writeln("""<a style='color: #0000ff;' href="./recover_posted?page=%s&beginTimePosted=%s&stopTimePosted=%s"><b>Prev Page</b></a>""" % (page - 1, beginTime, stopTime) )
            self.writeln("""\t</td>\n\t<td colspan=5 align=right>""")

            if results[1]: self.writeln("""<a style='color: #0000ff;' href="./recover_posted?page=%s&beginTimePosted=%s&stopTimePosted=%s"><b>Next Page</b></a>""" % (page + 1, beginTime, stopTime) )

            self.writeln("""
            </td></tr>
            <tr class=table_header style='font-size: 8pt;'><th align=left>Emp ID</th><th align=left>&nbsp;First Name</th><th align=left>&nbsp;Last Name</th>
            <th align=left>&nbsp;Start Date</th><th align=left>&nbsp;Start Time</th><th width='50px'></th><th align=left>&nbsp;End Date</th><th align=left>End Time</th>
            <th width='30'>&nbsp;Recover&nbsp;&nbsp;</th></tr>
            """)

            testDate = []
            self.start_color()
            for laborHed in results[0]:
                employee=laborHed.employee()
                startDate=str(laborHed.startStamp() )[:10].split("-")
                startDate="%s/%s/%s" % (startDate[1],startDate[2],startDate[0])         

                if not testDate.count(startDate):
                    self.writeln("<tr bgcolor='#acaaac' class=list_data><td align=left colspan=11><u>%s</u></td></tr>" % startDate)
                    testDate.append(startDate)
                            
                endDate=str(laborHed.endStamp() )[:10].split("-")
                endDate="%s/%s/%s" % (endDate[1],endDate[2],endDate[0])
                                    
                bgcolor=self.next_color()
                self.writeln("""
                <tr bgcolor='%s'><td class=list_data>%s</td><td class=list_data>&nbsp;%s</td>
                <td class=list_data>&nbsp;%s</td><td align=left class=list_data>%s</td>                                             <td align=left class=list_data>%s</td>
                <td>&nbsp;</td>
                <td align=left class=list_data>%s</td>
                <td align=left class=list_data>%s</td>
                <td align=center><input type='checkbox' name='recover%s' value=1 CHECKED></td></tr>""" % (bgcolor,employee.empId(),employee.firstName(),employee.lastName(),startDate,str(laborHed.startStamp())[11:19],endDate,str(laborHed.endStamp())[11:19],laborHed.serialNum() ) )
            
            self.writeln("""<tr class=refresh><td colspan=5>""")

            if page > 0: self.writeln("""<a style='color: #0000ff;' href="./recover_posted?page=%s&beginTimePosted=%s&stopTimePosted=%s"><b>Prev Page</b></a>""" % (page - 1, beginTime, stopTime) )


            self.writeln("""</td>\n\t<td colspan=5 align=right>""")

            if results[1]: self.writeln("""<a style='color: #0000ff;' href="./recover_posted?page=%s&beginTimePosted=%s&stopTimePosted=%s"><b>Next Page</b></a>""" % (page + 1, beginTime, stopTime) )
            self.writeln("""
            </td>\n</tr>
            <tr><td colspan=8 height='70px' align=center><INPUT TYPE=image SRC="../images/submit1.gif" onMouseDown="this.src='../images/submit1down.gif';" onMouseOut="this.src='../images/submit1.gif';" ></td></tr>
            </form>
            </table>
            """)
            

