# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SecureSitePage import SecureSitePage
from etc import siteindex
from sndcs.EmployeeFactory import EmployeeFactory
from sndcs_common.PyroProxyMixin import PyroProxyMixin
from sndcs.Config import config
import Pyro.core

class index(SecureSitePage,PyroProxyMixin):
    def __init__(self):
        SecureSitePage.__init__(self,siteindex["dcs_employee_list"],1,True)

    def localTitle(self):
        return "Active Employees List"

    def subTabs(self):
        subtab1 = self.write_div(id="subtab1",classname="subtab",text="Main", construct = [ 1, siteindex["dcs_employee_list"], "index" ]);
        subtab2 = self.write_div(id="subtab2",classname="subtab",text="Global", construct = [ 2, siteindex["dcs_employee_list"], "globalindirect" ]);

        return """<tr><td><table align="left"><tr><td>%s</td><td>%s</td></tr></table></td></tr>""" % (subtab1,subtab2)

    def writeLocalContent(self):
        self.writeln("""<table width="100%">""")
        self.writeln( self.subTabs() )

        self.writeln("""<tr>\n<td>""")
        self.writeln("""<table width="100%">""")
        header = ("""<tr CLASS='table_header' ALIGN='left'><th align=left>&nbsp;Employee Name</th><th align=left>&nbsp;Activity</th></tr>""")
        self.writeln(header)

        self.start_color()  
        
        employee_object = Pyro.core.getProxyForURI(self.formatPyronameString(self.namespace, ["Employee"]))
        lastShiftName = ""
        for employee in employee_object.getActiveEmployeeAndActivityData():
            employeeJobString, className = [ "","" ]
        
            activities = employee["activities"]
            if len(activities) > 1:
                employeeJobString="*** GANGED ***"
                className="ganged"
            elif not len(activities):
                continue
            
            bgcolor = self.next_color()
            for activity in activities:
                if not className:
                    className = activity["type"]
                else:
                    employeeJobString+="<br>"
                employeeJobString+=self.escape(activity["description"])
            
            if employee["shift"] and not lastShiftName == employee["shift"]:
                self.writeln("<tr bgcolor='#acaaac' class=list_data><td colspan=2><b>Shift: </b>%s</td></tr>" % employee["shift"] )
                lastShiftName = employee["shift"]
            elif not employee["shift"] and not lastShiftName == "Misc":
                self.writeln("<tr bgcolor='#acaaac' class=list_data><td colspan=2><b>Shift:</b> Misc.</td></tr>")
                lastShiftName="Misc"
           
            if ( employee["shift"] and employee["clocked_in_stamp"] ) and cmp(self.returnTime(str(employee["shift_start_time"])),str( self.returnTime( employee["clocked_in_stamp"].time ) )) == -1:
                bgcolor="#ee998a" # Employee clocked in late...

            self.writeln(""" <tr class='%s' bgcolor='%s'> <td width='250px'>%s</td><td>%s</td> </tr>""" % (className,bgcolor,employee["properName"],employeeJobString))
        
        self.writeln(header)
        self.writeln("""</table>\n\t</td>\n</tr>\n</table>""")
