# vim: ts=4 et sts=4 sw=4 autoindent

from lib.SitePage import SitePage
from sndcs.UserFactory import UserFactory
from etc import salt

class login(SitePage):
    
    def __init__(self):
        SitePage.__init__(self,0)
    
    def actions(self):
        return SitePage.actions(self) + ["Login", "Logout"]

    def Login(self):
        req = self.request()
        if req.hasField("password") and req.hasField("username"):
            username = self.escape(req.field("username","").replace("'",""))
            password = self.escape(req.field("password","").replace("'",""))
            testuser = UserFactory().validateUser(username,"%s%s" % (salt,password) )
            
            if testuser:
                self.session().setValue("userLoggedOn",testuser[0].serialNum())
                if self.session().hasValue("backPage") and not sum( [ self.session().value("backPage").count(x) for x in [ "search", "labordtl" ] ]):
                    backPage=self.session().value("backPage")
                    if backPage[:3]=="../":
                        backPage=backPage[3:]
                    self.goToPage(backPage)
                else:
                    self.goToPage("dcs_employee_list")
            else:
                self.message="Error: Invalid Username and/or Password"
                self.writeBody()
    def Logout(self):
            self.session().setValue("userLoggedOn",0)
            self.session().setValue("backPage","dcs_employee_list")
            self.writeBody()

    def localTitle(self):
        return "Login"

    def writeLocalContent(self):
        if self.session().value("userLoggedOn",0):
            self.goToPage("dcs_employee_list")

        self.writeln("""
        <table>
        <tr CLASS=title><td colspan=2 align=center><font color='#FF0000'>%s</font></td></tr>
        <form action=login method=post>
        <tr class='body_desc'><td WIDTH='50px'>Username:&nbsp;&nbsp;</td><td><input type="text" name="username" size=20></td></tr>

        <tr class='body_desc'><td WIDTH='50px'>Password:&nbsp;&nbsp;</td><td><input type="password" name="password" size=20></td></tr>

        <input name="_action_" value="Login" type="hidden">

        <tr><td align='center' height='40px' colspan=2><INPUT TYPE=image SRC="../images/submit2.gif" onMouseDown="this.src='../images/submit2down.gif';" onMouseOut="this.src='../images/submit2.gif';"></td></tr>
        
        </form>
        </table>
        """ % self.message)



        
