# vim: ts=4 et sts=4 sw=4 autoindent

from lib.WapSecureSitePage import SecureSitePage
#from sndcs.EmployeeFactory import EmployeeFactory
#from sndcs.Employee import Employee
from sndcs_common.PyroProxyMixin import PyroProxyMixin 
import Pyro.core

class index(SecureSitePage, PyroProxyMixin):
    def __init__(self):
        SecureSitePage.__init__(self,0)

    def actions(self):
        return SecureSitePage.actions(self) + ["clockIn", "clockOut"]
        
    def localTitle(self):
        req = self.request()
        if (req.hasField("serialNum")):
            serialNo = req.field("serialNum")
            
        employee_factory = Pyro.core.getProxyForURI(self.formatPyronameString(self.namespace, ["Employee"]))
        employeeInfo = employee_factory.setEmployeeBySerialNum( int(serialNo) )
        if employeeInfo.isClockedIn():
            employeeInfo.disconnect()
            return "Clock Out"
        else:
            employeeInfo.disconnect()
            return "Clock In"

    def clockIn(self):
        req = self.request()
        if (req.hasField("serialNum")):
            serialNo = req.field("serialNum")
            
        employee_factory = Pyro.core.getProxyForURI(self.formatPyronameString(self.namespace, ["Employee"]))
        employeeInfo = employee_factory.setEmployeeBySerialNum( int(serialNo) )
        employeeInfo.clockIn(terminal_id = self.terminal_name)
        employeeInfo.disconnect()

        self.goToPage("./dcs_current_activity/index?serialNum=" + serialNo)

        
    def clockOut(self):
        req = self.request()
        if (req.hasField("serialNum")):
            serialNum = req.field("serialNum")

        employee_factory = Pyro.core.getProxyForURI(self.formatPyronameString(self.namespace, ["Employee"]))
        employee = employee_factory.setEmployeeBySerialNum( int(serialNum) )
        employee.clockOut(terminal_id = self.terminal_name)
        employee.disconnect()
        
        self.goToPage("dcs_employee_list")

    def writeLocalContent(self):

        req = self.request()
        if req.hasField("serialNum"):
            serialNo = req.field("serialNum")
        else:
           self.goToPage("dcs_employee_list") 
        
        employee_factory = Pyro.core.getProxyForURI(self.formatPyronameString(self.namespace, ["Employee"]))
        employeeInfo = employee_factory.setEmployeeBySerialNum( int(serialNo) )

        self.writeln("""<form method=post action=index><table width=100%>""")

        if employeeInfo.isClockedIn():
            self.writeln("<tr class=list_data><td>&nbsp;</td><td align=right><a href='../dcs_current_activity/index?serialNum=%s'>back</a></td></tr>" % serialNo)
        else:
            self.writeln("<tr class=list_data><td>&nbsp;</td><td align=right><a href='../dcs_employee_list'>back</a></td></tr>")

        self.writeln("""<tr class=body_data><td valign=top>Name:</td><td>%s</td></tr>""" % employeeInfo.properName())

        self.writeln("""<input name='serialNum' value='%s' type='hidden'>""" % serialNo)
        
        if employeeInfo.isClockedIn():
            self.writeln("""<input name='_action_' value='clockOut' type='hidden'>""")
            self.writeln("""<tr class=body_data><td colspan=2 align=center><input type=submit value='Clock Out' class='submit'></td></tr>""")
        else:
            self.writeln("""<input name='_action_' value='clockIn' type='hidden'>""")
            self.writeln("""<tr class=body_data><td colspan=2 align=center><input type=submit value='Clock In' class='submit'></td></tr>""")
            
        self.writeln("""</table></form>""")

        employeeInfo.disconnect()
