# vim: ts=4 et sts=4 sw=4 autoindent


from lib.WapSecureSitePage import SecureSitePage
from sndcs.EmployeeFactory import EmployeeFactory

class index(SecureSitePage):
    def __init__(self):
        SecureSitePage.__init__(self,0)

    def localTitle(self):
        return "Current Activities"

    def backPage(self):
        req = self.request()
        return "../wap/dcs_current_activity/index?serialNum=%s" % req.field("serialNum",0)

    def actions(self):
        return SecureSitePage.actions(self) + ["search", "view"]

    def view(self):
        req = self.request()
        if req.hasField("serialNum"):
            serialNum = req.field("serialNum")
        self.goToPage("view")
    
    def writeLocalContent(self):
        req = self.request()
        if req.hasField("serialNum"):
            serialNum = req.field("serialNum")
        else:
            self.goToPage("dcs_employee_list")
        
        if req.hasField("narrow"):
            narrow = req.field("narrow")
        else:
            narrow = ''
            
        employee = EmployeeFactory().getEmployeeBySerialNum(int(serialNum))
        
        self.writeln("""<table width="100%">""")
        self.writeln("""<tr class=list_data><td><font color="#FF0000">%s</font></td></tr>""" % self.message)
        self.writeln("""<tr class=list_data><td>Name: %s</td></tr>""" % employee.properName())
        activities = employee.getActivities()
        for activity in activities:
            className=activity["type"]
            classDesc=activity["description"]

        if not activities:
            self.goToPage("dcs_clock_in/index?_action_=clockIn&serialNum=%s" % serialNum )

        if className == "idle":
            self.writeln("""<tr bgcolor='#FFFFFF' class='%s'><td align=center>%s</td></tr>""" % (className, classDesc))
        elif (className != "idle" and classDesc == 'Lunch' or classDesc == 'Break'):
            self.writeln("""<tr bgcolor='#FFFFFF' class='%s'><td align=center>%s</td></tr>""" % (className, classDesc))
        else:
            self.writeln("""<tr bgcolor='#FFFFFF' class=list_data><td><a href="view?serialNum=%s" class="%s">%s</a><br><br></td></tr>""" % (serialNum, className, classDesc))
        

        self.writeln("""<tr class=list_data><td><a href="start_indirect?serialNum=%s">Indirect</a></td></tr>""" % serialNum)
        self.writeln("""<tr class=list_data><td><a href="../dcs_lunch_break/index?_action_=breakin&serialNum=%s">Break In/Out</a></td></tr>""" % serialNum)
        self.writeln("""<tr class=list_data><td><a href="../dcs_lunch_break/index?_action_=lunch&serialNum=%s">Lunch In/Out</a></td></tr>""" % serialNum)
        self.writeln("""<tr class=list_data><td><a href="../dcs_clock_in/index?serialNum=%s">Clock Out</a></td></tr>""" % serialNum)
        self.writeln("""<tr class=list_data><td><a href="../dcs_employee_list">Main</a></td></tr>""")
        self.writeln("""<form method=post action=search>
        <input type=hidden name="_action_" value="searchResults"><input type=hidden name="serialNum" value="%s">
        <table width="100%%"><tr class=list_data><td align=center><br><input type="text" name="inquiry" tabindex=1 value="%s"> <input type="submit" value="Search Jobs" class="submit" tabindex=2></td></tr></table>""" % (serialNum, narrow))
        self.writeln("</table>")
