# vim: ts=4 et sts=4 sw=4 autoindent

from sndcs.EmployeeFactory import EmployeeFactory
from lib.WapSecureSitePage import SecureSitePage
from sndcs.JobHedFactory import JobHedFactory
from sndcs.AssemblyFactory import AssemblyFactory
from sndcs.OperationFactory import OperationFactory
from sndcs.ItemFactory import ItemFactory
from sndcs.CustomerFactory import CustomerFactory

class search(SecureSitePage):
    def __init__(self):
        SecureSitePage.__init__(self,0)
        

    def localTitle(self):
        req = self.request()
        if (req.hasField("inquiry")):
            searchFor = req.field("inquiry")

        if not searchFor:
            searchFor = 'all'

        title = "Search For '" + searchFor + "'"
        return title

    def actions(self):
        return SecureSitePage.actions(self) + ["search"]

    def search(self):
        return True


    def writeLocalContent(self):
    
        req = self.request()
        if (req.hasField("serialNum")):
            serialNum = req.field("serialNum")
            searchFor = req.field("inquiry")
            
        if not searchFor:
            tmp = JobHedFactory().getActiveJobHeds()
        else:
            try:
                isInt = int(searchFor)
                tmp = JobHedFactory().searchJobHeds(" WHERE number LIKE '%%%s%%'" % isInt)
            except ValueError:
                searchFor = searchFor
                custs = CustomerFactory().getCustomers()
                customerList = ''
                for cust in custs:
                    if searchFor.lower() in cust.name().lower():
                        customerList = customerList + " OR customerObjId = '%s'" % cust.serialNum()
                
                tmp = JobHedFactory().searchJobHeds(" WHERE itemDescription LIKE '%%%s%%' %s" % (searchFor, customerList))
        

        self.writeln("""<table width="100%%"><tr class=list_data><td align=center>&nbsp;</td><td align=right><a href="index?serialNum=%s&narrow=%s">back</a></td></tr>""" % (serialNum, searchFor))

        self.start_color()

        if not tmp:
            bgcolor=self.next_color()
            self.writeln("""<tr class=list_data bgcolor="%s"><td align=center colspan=2>No Results</td></tr>""" % bgcolor)
        else:
        
            self.writeln("""<table width="100%%">""")
            
            for job in tmp:
                if not job.complete():
                    for assembly in AssemblyFactory().getAssembliesByJobHedBySerialNum(int(job.serialNum())):
                        for operation in OperationFactory().getOperationsByAssemblySerialNum(int(assembly.serialNum())):
                            if not operation.complete():
                                bgcolor=self.next_color()
                                self.writeln("""
                                <tr bgcolor="%s" class=list_data><td align=right><span style="float:left">Cust.</span> -</td>
                                <td valign=top rowspan=4 class=list_data style="font-size:10pt"><a href="start_job?job=%i&assembly=%s&operation=%i&serialNum=%i">
                                %s<br> 
                                %s<br>
                                %s<br>
                                %s</a>
                                <br>
                                <a href="start_job?job=%i&assembly=%s&operation=%i&serialNum=%i&jobType=Setup">
                                Setup Job</a>
                                </td>
                                </tr>
                                <tr bgcolor="%s" class=list_data>
                                <td align=right><span style="float:left">Job</span> %i -</td></tr>
                                <tr bgcolor="%s" class=list_data>
                                <td align=right><span style="float:left">Asm.</span> %i -</td></tr>
                                <tr bgcolor="%s" class=list_data>
                                <td align=right><span style="float:left">Op.</span> %i -</td></tr>""" % (bgcolor, 
                                int(job.number()), 
                                int(assembly.number()), 
                                int(operation.serialNum()), 
                                int(serialNum),
                                job.customer().name(), 
                                job.itemDescription(), 
                                assembly.description(), 
                                operation.description(),
                                int(job.number()),
                                int(assembly.number()), 
                                int(operation.serialNum()), 
                                int(serialNum),
                                bgcolor, 
                                int(job.number()), 
                                bgcolor, 
                                int(assembly.number()), 
                                bgcolor, 
                                int(operation.number()))) 

            self.writeln("</table>")


        self.writeln("</table>")
