# vim: ts=4 et sts=4 sw=4 autoindent

from lib.WapSecureSitePage import SecureSitePage
from sndcs_common.PyroProxyMixin import PyroProxyMixin 
import Pyro.core

class start_indirect(SecureSitePage, PyroProxyMixin):
    def __init__(self):
        SecureSitePage.__init__(self,0)

    def localTitle(self):
        return "Indirect List"

    def actions(self):
        return SecureSitePage.actions(self) + ["indirect"]

    def indirect(self):
        req = self.request()
        if req.hasField("serialNum") and req.hasField("inid"):
            inid = req.field("inid")
            serialNum = req.field("serialNum")

        employee_factory = Pyro.core.getProxyForURI(self.formatPyronameString(self.namespace, ["Employee"]))
        employee = employee_factory.setEmployeeBySerialNum( int(serialNum) )
        
        employee.startIndirect(indirect_serial_num = int(inid), terminal_id = self.terminal_name)
        employee.disconnect()

        self.goToPage("./dcs_current_activity/index?serialNum=" + serialNum)
        
    def writeLocalContent(self):
        req = self.request()
        if req.hasField("serialNum"):
            serialNum = req.field("serialNum")

        self.writeln("""<table width="100%%">""")
        self.writeln("<tr class=list_data><td>&nbsp;</td><td align=right><a href='index?serialNum=%s'>back</a></td></tr>" % serialNum)
        
        indirect_factory = Pyro.core.getProxyForURI(self.formatPyronameString(self.namespace, ["Indirect"]))
        
        for indirect in indirect_factory.getActiveIndirects():
            self.writeln("""<tr class=list_data><td>%s</td><td><a href="start_indirect?_action_=indirect&serialNum=%i&inid=%i">%s</a></td></tr>""" % (indirect["code"], int(serialNum), int(indirect["serialNum"]), indirect["description"]))
            
        self.writeln("</table>")
