# vim: ts=4 et sts=4 sw=4 autoindent

from lib.WapSecureSitePage import SecureSitePage
from sndcs_common.PyroProxyMixin import PyroProxyMixin
import Pyro.core

class start_job(SecureSitePage, PyroProxyMixin):
    def __init__(self):
        SecureSitePage.__init__(self,0)

    def localTitle(self):
        return "Start Job"

    def writeLocalContent(self):

        req = self.request()
        has = req.hasField
        if (has("job") and has("assembly") and has("operation") and has("serialNum")):
            job       = req.field("job")
            assembly  = req.field("assembly")
            operationid = req.field("operation")
            serialNum = req.field("serialNum")
        else:
            self.goToPage("./dcs_employee_list")

        employee_factory = Pyro.core.getProxyForURI(self.formatPyronameString(self.namespace, ["Employee"]))
        employee = employee_factory.setEmployeeBySerialNum( int(serialNum) )
        
        employee.startProduction(operation_id = int(operationid), terminal_id = self.terminal_name, jobType = req.field("jobType","Production"))
        employee.disconnect()

        self.goToPage("./dcs_current_activity/index?serialNum=" + serialNum)
        

