# vim: ts=4 sts=4 sw=4 autoindent

from lib.WapSitePage import SitePage
from sndcs.UserFactory import UserFactory
from etc import salt

class login(SitePage):

    def __init__(self):
        SitePage.__init__(self,0)

    def actions(self):
        return SitePage.actions(self) + ["Login", "Logout"]

    def Login(self):
        req = self.request()
        if req.hasField("password") and req.hasField("username"):
            username = req.field("username")
            password = req.field("password")

            testuser=UserFactory().validateUser(username,"%s%s" % (salt,password) )

            if testuser:
                self.session().setValue("userLoggedOn",testuser[0].serialNum())
                if not self.session().value("backPage","").count("wap"):
                    self.goToPage("dcs_employee_list")
                else:
                    self.goToPage( self.session().value("backPage") )
            else:
                self.message="Error: Invalid Username and/or Password"
                self.writeBody()

    def Logout(self):
        self.session().setValue("userLoggedOn",0)
        self.session().setValue("backPage","dcs_employee_list")
        self.writeBody()

    def localTitle(self):
        return "Login"

    def writeLocalContent(self):
        sess = self.session()

        if sess.hasValue("userLoggedOn"):
            if sess.value("userLoggedOn")!=0:
                self.goToPage("./dcs_employee_list")
                
        self.writeln("""
        <table>
        <tr class=title><td colspan=2 align=center><font color='#FF0000'>%s</font></td></tr>
        <form action=login method=post>
        <tr class='body_desc'><td>Username:</td><td><input type='text' name=username size=20></td></tr>
        <tr class=body_desc><td>Password:</td><td><input type=password name=password size=20></td></tr>

        <input name='_action_' value='Login' type='hidden'>

        <tr><td align='center' colspan=2><input type=submit value='Submit' class="submit"></td></tr>

        </form>
    
        <tr><td align='left' colspan=2><a href='../rss/dcs_feed.xml'><img src='../../images/rss.gif' border=0></a></td></tr>

        </table>
        """ % self.message)


