# vim: ts=4 et sts=4 sw=4 autoindent

from lib.WapSecureSitePage import SecureSitePage
from sndcs.EmployeeFactory import EmployeeFactory
from sndcs_common.PyroProxyMixin import PyroProxyMixin
import Pyro.core

class index(SecureSitePage, PyroProxyMixin):
    def __init__(self):
        SecureSitePage.__init__(self,0)

    def actions(self):
        return SecureSitePage.actions(self) + ["lunch", "breakin"]

    def localTitle(self):
        return "Break and Lunch In/Out"

    def lunch(self):
        req = self.request()
        if (req.hasField("serialNum")):
            serialNum = req.field("serialNum")

        employee_factory = Pyro.core.getProxyForURI(self.formatPyronameString(self.namespace, ["Employee"]))
        employee = employee_factory.setEmployeeBySerialNum( int(serialNum) )

        if employee.isClockedIn():
            employee.log_on_off_lunch_break(type=1, terminal_id = self.terminal_name)     
            employee.disconnect()
            self.goToPage("./dcs_current_activity/index?serialNum=" + serialNum)
        else:
            employee.disconnect()

    def breakin(self):
        req = self.request()
        if (req.hasField("serialNum")):
            serialNum = req.field("serialNum")

        employee_factory = Pyro.core.getProxyForURI(self.formatPyronameString(self.namespace, ["Employee"]))
        employee = employee_factory.setEmployeeBySerialNum( int(serialNum) )

        if employee.isClockedIn():
            employee.log_on_off_lunch_break(type=2,terminal_id = self.terminal_name)
            employee.disconnect()
            self.goToPage("./dcs_current_activity/index?serialNum=" + serialNum)
        else:
            employee.disconnect()

    def writeLocalContent(self):
        pass
