from distutils.core import setup
import py2exe
from sndcs_common import VERSION

# pywin32 COM pulls in a lot of stuff which we don't want or need.
excludes = ["pywin", "pywin.debugger", "pywin.debugger.dbgcon",
            "pywin.dialogs", "pywin.dialogs.list", "win32com.server"]

opts = {
        "py2exe": {
            "includes": "pango,atk,gobject,cairo,pangocairo",
            #"compressed": 2,
            #"optimize": 2,
            #"bundle_files": 1,
            "excludes": excludes,
            "dll_excludes": ["w9xpopen.exe",],
            "dist_dir": "win32client",
            }
}

setup(
    version=VERSION,
    description="An enterprise labor data collection system.",
    name="SaberNet DCS",
    windows=[
            {"script":"""sndcs_client/gtk/sndcs_gtk""",
             "icon_resources": [(1,"sndcs/pixmaps/sndcs.ico")],
            }
            ],
    console=[
            {"script":"""configure_sndcs.py""", "icon_resources": [(1,"sndcs/pixmaps/sndcs.ico")],
            }
            ],
    data_files=[
        ("config", ["sndcs/config/logging.conf","sndcs/config/sndcs2.conf"]),
        (".", ["sndcs_client/gtk/sndcs2.glade","sndcs/pixmaps/dcs_splash.png","sndcs/pixmaps/sndcs.png"]),
        ],
    #zipfile = None,
    options=opts,
)
